-- BEEFCAKE BREAKFAST BRAWL

function Initialise()
    SendMessage("Commentary.NoDefault")
    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 15
    goldtime = (60 * 1000) * 14.5

    SendStringMessage("Camera.Disable", "Blimp")
    SendStringMessage("Camera.Disable", "Spectator")
    floodsetting = 0
    
    SetData("Particle.Rain.Prob", 0)
    SetData("Particle.Snow.Prob", 0)

   -- Shaking = 0
    
    SetData("TurnTime", 40000)
    SetData("RoundTime", 280000)
    StartTimer("Warning", 260000)
    
    SetData("Land.Indestructable", 1)
    
    SendMessage("GameLogic.PlaceObjects")
    SendMessage("GameLogic.ChangeWind")
    
    SetData("Trigger.Spawn", "Trigger1")
    SetData("Trigger.Radius", 12)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
        
    SetData("Crate.Spawn", "Crate1")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 3)
    SetData("Crate.Contents", "kUtilityGirder")
    SetData("Crate.Index", 1)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Crate2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 5)
    SetData("Crate.Contents", "kWeaponBazooka")
    SetData("Crate.Index", 2)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Crate3")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 5)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.Index", 3)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")

--Easter Egg Crate
    SetData("Crate.Spawn", "Crate4")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityBridgeKit")
    SetData("Crate.Index", 4)
    SetData("Crate.GroundSnap", 1)
    SendIntMessage("Crate.RadarHide", 4)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Crate5")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 2)
    SetData("Crate.Contents", "kWeaponFirePunch")
    SetData("Crate.Index", 5)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Crate6")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponPetrolBomb")
    SetData("Crate.Index", 6)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
--    SendIntMessage("Crate.RadarHide", 1)    
--    SendIntMessage("Crate.RadarHide", 2)    
--    SendIntMessage("Crate.RadarHide", 3)    
--    SendIntMessage("Crate.RadarHide", 4)    
--    SendIntMessage("Crate.RadarHide", 5)
--    SendIntMessage("Crate.RadarHide", 6)

    SetData("Particle.DetailObject", "Sparks")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Birds")
    SetData("Particle.Name", "Part_BirdSky")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "SmokeBottle")
    SetData("Particle.Name", "ParticleSmokePlume")
    SendMessage("Particle.NewEmitter")
    
    water = 0
    Switch = 0
    
    SetData("Particle.DetailObject", "Sink")
    SetData("Particle.Name", "Part_Sinkhole")
    SendMessage("Particle.NewEmitter")
    
    Taps()
    
    WaterTrigger()
    WaterTrigger2()
    
    CameraShake = 0
    SetData("Camera.StartOfTurnCamera","Default")
    SetupWormsAndTeams()
    SetupInventories()
    StartCamera()

end

function Crate_Collected()
    CrateNumber = GetData("Crate.Index")
 
 --If this crate is collected then the Bridge Kit becomes available
    if CrateNumber == 4 then
    
        Key,Lock = EditContainer("L.W.BridgeK")
        if Lock.Locked == true then
        Lock.Locked = false
        SetData("MCa.LockedName2","L.W.BridgeK")
        end
        CloseContainer(Key)
    
        SetData("CommentaryPanel.Comment", "Miss.Breakfast.EasterEgg")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function DoOncePerTurnFunctions()
   
    if floodsetting == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Breakfast.Warning")
        SetData("CommentaryPanel.Delay",3000)
        SendMessage("CommentaryPanel.TimedText")
        floodsetting = 2
    end
    
    if floodsetting == 2 then
    --SetData("CommentaryPanel.Comment", "MissBreakfast.Water")
    --SendMessage("CommentaryPanel.ScriptText")
    water = water + 12
    SetData("Water.Level", water)
    end
end


function Camera_Path_Stopped()
    if CameraFly == 1 then
        CameraFly = 0
        CancelTimer(CamLoop)
        StartFirstTurn()
    end
end

function StartCamera()
   SendMessage("EFMV.Start")
    CameraFly = 1
    SetData("CommentaryPanel.Comment", "Miss.Breakfast.Intro")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2")
    SetData("Camera.Path.Knots.LookAt", "Look1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",450)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("StartCamera2", 3750)
end

function StartCamera2()
    SetData("CommentaryPanel.Comment", "Miss.Breakfast.Intro2")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "Pos3,Pos4")
    SetData("Camera.Path.Knots.LookAt", "Look2")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",450)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
   
    CamLoop = StartTimer("GO", 4600)
end

function GO()
    CameraFly = 0
    StartFirstTurn()
end

function TurnStarted()
    ActiveWorm = GetData("ActiveWormIndex")
    SendIntMessage("GameLogic.DestroyTrigger", 100)
    SendIntMessage("GameLogic.DestroyTrigger", 102)
    WaterTrigger()
    WaterTrigger2()
end

function Trigger_Collected()
    TriggerIndex = GetData("Trigger.Index")
    if TriggerIndex == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Breakfast.What")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif TriggerIndex == 100 and ActiveWorm == 0 then
        SetData("Camera.Shake.Length",1000)
        SetData("Camera.Shake.Magnitude",0.30)
        SendMessage("Camera.ShakeStart")
        ShakeHandle = GetData("Camera.Shake.Handle")
        StartTimer("WaterTrigger", 500)
    elseif TriggerIndex == 102 and ActiveWorm == 2 then
        SetData("Camera.Shake.Length",1000)
        SetData("Camera.Shake.Magnitude",0.30)
        SendMessage("Camera.ShakeStart")
        ShakeHandle = GetData("Camera.Shake.Handle")
        StartTimer("WaterTrigger2", 500)
    --else
    --    SendIntMessage("GameLogic.DestroyTrigger", 100)
    --    SendIntMessage("GameLogic.DestroyTrigger", 102)
    --    StartTimer("WaterTrigger", 1000)
    --    StartTimer("WaterTrigger2", 1000)
    end
end

function WaterTrigger()
    SetData("Trigger.Spawn", "WaterTrigger_p1")
    SetData("Trigger.Radius", 50)
    SetData("Trigger.Index", 100)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
end

function WaterTrigger2()
    SetData("Trigger.Spawn", "WaterTrigger_p2")
    SetData("Trigger.Radius", 50)
    SetData("Trigger.Index", 102)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 2)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
end

function CheckOneTeamVictory()
    SendMessage("WormManager.GetActiveTeamCount")
    TeamCount = GetData("TeamCount")
    SendMessage("Commentary.Clear")
    
    SendMessage("WormManager.GetSurvivingTeam")
    WhichTeam = GetData("SurvivingTeamIndex")

    if TeamCount == 0 then
        if Switch == 0 then
            SetData("CommentaryPanel.Comment", "Miss.Breakfast.Failure")
            SendMessage("CommentaryPanel.ScriptText") 
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            SetData("CommentaryPanel.Comment", "Miss.Breakfast.Failure")
            SendMessage("CommentaryPanel.ScriptText") 
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 0 then
        Switch = 1
        AWARDD()
    else
        StartTurn()
    end
end

function AWARDD()

    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.Breakfast.Success")
    SendMessage("CommentaryPanel.ScriptText") 
    
    Result()
end

--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()

    SetData("Camera.Path.IgnoreInput", 1)
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
        Key,Lock = EditContainer("L.Sch.Sticky") --April Fools wormapedia entry
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName3","L.Sch.Sticky")
        end
        CloseContainer(Key)
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.P.Fools") --April Fools wormapedia entry
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.P.Fools")
                end
                CloseContainer(Key)
            end
        end
    end
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end


function Warning()
    SetData("CommentaryPanel.Comment", "Miss.Breakfast.WaterWarning")
    SendMessage("CommentaryPanel.ScriptText")
end

--20/1/2003 - I can't remember why i've done this below.?!?!
--function Timer_GameTimedOut()
--    StartTimer("water", 600000)
--end

--This starts the water rising when the round time ends.

function Timer_GameTimedOut()
    floodsetting = 1
end

function TurnEnded()
   CheckOneTeamVictory()

   
end

function Camera_Path_Reached_Knot()

    if Knot == "PosFlood4" then
        SetData("Camera.Path.IgnoreInput", 0)
    end
    
end


function StartFirstTurn()
   SendMessage("EFMV.End")
    WaitUntilNoActivity = false
   SendMessage("Timer.StartGame")
    SetData("CommentaryPanel.Comment", "Miss.Breakfast.Rumble")
    SendMessage("CommentaryPanel.ScriptText")
   StartTurn()
end

function Taps()
    SetData("Particle.DetailObject", "Tap1")
    SetData("Particle.Name", "Part_Tap")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Tap2")
    SetData("Particle.Name", "Part_Tap")
    SendMessage("Particle.NewEmitter")
    
    StartTimer("Taps2", 10000)
end

function Taps2()
    Taps()
end

--function Weapon_Fired_End()
--    SendMessage("GameLogic.AboutToApplyDamage")
 --   SendMessage("GameLogic.ApplyDamage")
--end

--This function is called waterr because it will break if a variable and function
--have the exact same name.

function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")

    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.GraveIndex = GM.T1_Grave
    --team.SfxBankName = GM.T1_Speech
    team.FlagGfxName = GM.T1_Flag
    team.TeamColour = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Bad Guys"
    team.IsAIControlled = true
    team.TeamColour = 1
    team.FlagGfxName = "71"
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn1"
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
    
    lock, worm = EditContainer("Worm.Data02") 
    worm.Active = true
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn3"
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 

    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01")
    CopyContainer("AIParams.CPU3", "AIParams.Worm01")
    worm.Energy = 100
    worm.Name = "Big Johnny"
    worm.SfxBankName = "Gangsta"
    worm.Spawn = "spawn2"
    worm.TeamIndex = 1
    CloseContainer(lock)
  
    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03")
    CopyContainer("AIParams.CPU3", "AIParams.Worm03")
    worm.Energy = 100
    worm.Name = "Mr Cecil"
    worm.SfxBankName = "Gangsta"
    worm.Spawn = "spawn4"
    worm.TeamIndex = 1
    CloseContainer(lock)
  
    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    CopyContainer("AIParams.CPU3", "AIParams.Worm04")
    worm.Energy = 100
    worm.Name = "Caveman Kayvan"
    worm.SfxBankName = "Gangsta"
    worm.Spawn = "spawn5"
    worm.TeamIndex = 1
    CloseContainer(lock)
    
    CopyContainer("Worm.Data00", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    CopyContainer("AIParams.CPU3", "AIParams.Worm05")
    worm.Energy = 100
    worm.Name = "Six Eight Eight"
    worm.SfxBankName = "Gangsta"
    worm.Spawn = "spawn6"
    worm.TeamIndex = 1
    CloseContainer(lock)
  
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Bazooka = 2
    inventory.Grenade = 8
   -- inventory.ClusterGrenade = 5
    inventory.Dynamite = 1
    --inventory.Landmine = 2
    --inventory.Shotgun = 4
    --inventory.Uzi = 2
    --inventory.Prod = -1
    --inventory.FirePunch = 5
    inventory.BaseballBat = 1
    --inventory.HomingMissile = 1
    --inventory.HomingPidgeon = 1
    inventory.Girder = 1
   -- inventory.PetrolBomb = 1
    inventory.Sheep = 1
    inventory.SkipGo = -1
    inventory.LowGravity = 2
    CloseContainer(lock)
    
    

    lock, delays = EditContainer("Inventory.WeaponDelays")
    delays.HomingPidgeon = 5
    delays.Sheep = 10
    CloseContainer(lock)

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
    CopyContainer("Inventory.Team.Default", "Inventory.Team01")
    
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Bazooka = 0
    inventory.Grenade = 0
    inventory.ClusterGrenade = 0
    CloseContainer(lock)
end