
   -- Mission chute challenge 3

function Initialise()
    -- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 2000)
    SetData("RoundTime", 50000)
    SetData("TurnTime", 0)
    SetData("Jetpack.MaxAltitude", 5500)
    SendStringMessage("Camera.Disable", "Track")
    SendMessage("GameLogic.PlaceObjects")
    
    SendMessage("Commentary.NoDefault")
    SetData("Camera.StartOfTurnCamera","Default")
    SendMessage("HUD.HideTurnTime")    
    evidence = 0
    camdone = 0
    wsafe = 0
    turnnum = 1
    CamLoop = 0
    FunLoop = 0
    TextTime = 0
    Switch = 0
    Time = 5000

    StartTimer("cloud", 1000)
    StartTimer("wave", 2700)
    
    SendMessage("EFMV.Start")   
   
    SetupWormsAndTeams()
    SetupInventories()
    camera()
    targets()
end

--////////////////////////////////////////////////////////////////////
--//                    Setup worms and inventories                 //
--////////////////////////////////////////////////////////////////////

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    -- Activate Team 0
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock) -- must close the container ASAP
    
    -- Worm 0, Team 0
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 1
    worm.Spawn = "spawn1"
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.IsEmotional = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    -- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.SuperSheep = 0
    inventory.Parachute = -1
    CloseContainer(lock) -- must close the container ASAP

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
    CopyContainer("Inventory.Team.Default", "Inventory.Team01")

    -- Sets team01 to have different/extra weapons other than default
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.HomingMissile = 0
    inventory.HomingPidgeon = 0
    CloseContainer(lock)
    
    -- Sets up some delays
    lock, delays = EditContainer("Inventory.WeaponDelays") 
    CloseContainer(lock)
end

--//////////////////////////////////////////////////////////////

function Weapon_PoweringUpStart()
end

function Weapon_Fired_Start()
end

function Weapon_Fired_End()
end

--////////////////////////////////////////////////////////////////
--//                   Random wind                              //
--////////////////////////////////////////////////////////////////

function SelectRandomWind()
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", 0.0*MaxWind)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", 3.3) 

end


--////////////////////////////////////////////////////////////////
--//            Crate Logic                                     //
--////////////////////////////////////////////////////////////////

function Crate_Collected()

    RoundTimeRemaining = GetData("RoundTimeRemaining")
    SetData("RoundTimeRemaining", RoundTimeRemaining + Time)

    CrateNumber = GetData("Crate.Index")
    
    if CrateNumber == 15 then
        SetData("Crate.Spawn", "targ0")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 20)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.WaitTillLanded", 0)         
        SendMessage("GameLogic.CreateCrate")
    end

    if CrateNumber == 20 then
        SendIntMessage("Crate.Delete", 1) 
        SendIntMessage("Crate.Delete", 2) 
        SendIntMessage("Crate.Delete", 3) 
        SendIntMessage("Crate.Delete", 4)
        SendIntMessage("Crate.Delete", 5) 
        SendIntMessage("Crate.Delete", 6) 
        SendIntMessage("Crate.Delete", 7) 
        SendIntMessage("Crate.Delete", 8)
        SendIntMessage("Crate.Delete", 9) 
        SendIntMessage("Crate.Delete", 10) 
        SendIntMessage("Crate.Delete", 11) 
        SendIntMessage("Crate.Delete", 12)    
        SendIntMessage("Crate.Delete", 13) 
        SendIntMessage("Crate.Delete", 14)     
       
        SetData("Crate.Scale", 1.0)
        
        if Time > 1000 then
            Time = Time - 1000
        end
        
        targets()
    end  
end

function targets()
     	SetData("Crate.Spawn", "targ1")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 1)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")

     	SetData("Crate.Spawn", "targ2")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 2)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")

      	SetData("Crate.Spawn", "targ3")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 3)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")       
        
        
       	SetData("Crate.Spawn", "targ4")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 4)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")      
        
        
        SetData("Crate.Spawn", "targ5")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")     
        
      	SetData("Crate.Spawn", "targ6")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 6)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")


     	SetData("Crate.Spawn", "targ7")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 7)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")

 
      	SetData("Crate.Spawn", "targ8")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 8)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")       
        
        
       	SetData("Crate.Spawn", "targ9")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 9)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")      
        
        
        SetData("Crate.Spawn", "targ10")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0) 
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")     

     	SetData("Crate.Spawn", "targ11")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 11)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")


     	SetData("Crate.Spawn", "targ12")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 12)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")


      	SetData("Crate.Spawn", "targ13")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 13)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")       
        
        
       	SetData("Crate.Spawn", "targ14")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 14)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")      
        
        
        SetData("Crate.Spawn", "targ15")
        SetData("Crate.Type", "Utility")
	SetData("Crate.Index", 15)
        SetData("Crate.Contents", "kUtilityJetpack")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")     
end

--///////////////////////////////////////////////////////////////
--//            Create Particles                               //
--/////////////////////////////////////////////////////////////// 

        
function cloud()
	SetData("Particle.DetailObject", "cloud1")
	SetData("Particle.Name", "ParticleEmitter7")
	SendMessage("Particle.NewEmitter")
	id1 = GetData("Particle.Handle")
end


function Kel()
end

--////////////////////////////////////////////////////////////////
--//                    Camera Functions                        //
--////////////////////////////////////////////////////////////////

function camera()
    CameraFly = 1
    SetData("CommentaryPanel.Comment", "Chall.Sheep3.Intro1")
    SetData("CommentaryPanel.Delay",4000)
    SendMessage("CommentaryPanel.TimedText")
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2,Pos3")
    SetData("Camera.Path.Knots.LookAt", "Look1")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",450)  
    SetData("Camera.Path.Tension.Position", 0.5)
    SendMessage("Camera.Path.Start")

end


function camera2()
    SetData("Camera.Path.Knots.Position", "Pos9,Pos10")
    SetData("Camera.Path.Knots.LookAt", "Look6,Look7")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",900)  
    SetData("Camera.Path.Steps.LookAt",900)
    SetData("Camera.Path.Tension.Position", -1.5)
    SendMessage("Camera.Path.Start")
    FunLoop = StartTimer("BriefText", 3000)
    
end


function Camera_Path_Reached_Knot()
   knot = GetData("Camera.Path.Knot")
    
    if knot == "Pos2" then
    
        wave()
    
    end
    
    if knot == "Pos3" then  
        Whiteout()
        camera2()
        SetData("CommentaryPanel.Comment", "Chall.chute3.extra1")
        SetData("CommentaryPanel.Delay",3000)
        SendMessage("CommentaryPanel.TimedText")
        

    end  
    
    if knot == "Pos10" then 
    
        SetData("CommentaryPanel.Comment", "Chall.chute3.extra2")
        SetData("CommentaryPanel.Delay",3000)
        SendMessage("CommentaryPanel.TimedText")
        Whiteout()
        startt()
    end
    
end


function Camera_Path_Stopped()

    SendMessage("Commentary.Clear")
    SendIntMessage("Worm.ResetAnim", 0)

    if CameraFly == 1 then
        CameraFly = 0
        CancelTimer(FunLoop)
        
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        
        startt()
    end
end

--////////////////////////////////////////////////////////////////
--//            Animations                                      //
--////////////////////////////////////////////////////////////////

function wave()
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Pray")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Pray")
    SendIntMessage("Worm.QueueAnim", 0)
end

--////////////////////////////////////////////////////////////////
--//                   Whiteout function                        //
--//////////////////////////////////////////////////////////////// 

function Whiteout()
    SetData("Particle.DetailObject", "FLASH")
    SetData("Particle.Name", "ParticleWhiteout")
    SendMessage("Particle.NewEmitter")
    id2 = GetData("Particle.Handle")
end


--////////////////////////////////////////////////////////////////
--//            Text control and functions                      //
--////////////////////////////////////////////////////////////////

function BriefText()
    SetData("CommentaryPanel.Comment", "Chall.chute3.extra3")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")
end


--////////////////////////////////////////////////////////////////
--//                    Turn Logic                              //
--////////////////////////////////////////////////////////////////

function startt()
    camdone = 1
    StartFirstTurn()
    SendMessage("EFMV.End")
end


function StartTurn()

    done_once_per_turn_functions = false
   
    SendMessage("Timer.StartHotSeatTimer")
    SendMessage("GameLogic.ActivateNextWorm")
    SendMessage("Weapon.Create")
    SendMessage("GameLogic.Turn.Started")
    
    turnnum = turnnum + 1 
    
    SetWind()
    TurnStarted()
    RunAILogic()

end

function Worm_Died()
    SetData("CommentaryPanel.Comment", "Chall.Generic.Lose1")
    SendMessage("CommentaryPanel.ScriptText")
end

function CheckOneTeamVictory()
    SendMessage("WormManager.GetActiveTeamCount")
    TeamCount = GetData("TeamCount")
    SendMessage("Commentary.Clear")
    
    SendMessage("WormManager.GetSurvivingTeam")
    WhichTeam = GetData("SurvivingTeamIndex")

    if TeamCount == 0 then
        Switch = 1
        Result()
    end
end


function Timer_GameTimedOut()
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win3")
    SendMessage("CommentaryPanel.ScriptText")

    if Switch == 0 then 
        Result()
    end
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
    timetook = GetData("ElapsedRoundTime")
    goldtime = GetData("MCa.BestGold")
    silvertime = GetData("MCa.BestSilver")
    bronzetime = GetData("MCa.BestBronze")
     
    if timetook > bronzetime then
        Movie = 1
        if timetook > silvertime then
            Movie = 2
            if timetook > goldtime then
                Movie = 3
                    Key,Lock = EditContainer("L.W.Banana")
                    if Lock.Locked == true then
                        Lock.Locked = false
                        SetData("MCa.LockedName","L.W.Banana")
                    end
                    CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Challenge.Result")
end
