
   -- Mission Crate

function Initialise()
    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 4.5
    goldtime = (60 * 1000) * 3

    MyRandomNumber = 0    
    
    id1 = 0
    id2 = 0
    id3 = 0
    id4 = 0
    turn = 0
    camdone = 0
    CamLoop = 0
    Fix = 0
    Switch = 0
    Timer1 = 0

    SendMessage("EFMV.Start")

    SetData("Jetpack.InitFuel", 45000)
 
    -- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SetData("TurnTime", 45000)
    SetData("RoundTime", 3000000)
    
    SetData("Particle.DetailObject", "sparkle1")
    SetData("Particle.Name", "Part_StarBridge")
    SendMessage("Particle.NewEmitter")
    PID1 = GetData("Particle.Handle")
    
   
    SetData("Crate.Spawn", "crate1")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", -1)
    SetData("Crate.Contents", "kUtilityJetpack")
    SetData("Crate.TeamCollectable", 0)
    SetData("Crate.Index", 1)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
	
    SetData("Crate.Spawn", "crate3")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityGirder")
    SetData("Crate.Index", 2)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
	
    SetData("Crate.Spawn", "crate4")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 25)
    SetData("Crate.Index", 3)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    
--////////////////////////////////////////////////////////////////////
-- place the mission critical crate from the outset
    
    SetData("Crate.Spawn", "crate2")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", -1)
    SetData("Crate.Contents", "kUtilityJetpack")
    SetData("Crate.Index", 99)
    SetData("Crate.Pushable", 0)
    SetData("Crate.GroundSnap", 1) 
    SendMessage("GameLogic.CreateCrate")
    
--////////////////////////////////////////////////////////////////////
    
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")
    
    SendMessage("GameLogic.PlaceObjects")

    SetupWormsAndTeams()
    SetupInventories()
    RailCamera1()

end  


--////////////////////////////////////////////////
--// make the wind random                       //
--////////////////////////////////////////////////

function SelectRandomWind()
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", RandomNumber*MaxWind * 5 / 10)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", Direction)   
end


--////////////////////////////////////////////////////
--//    start environmental effects                 //
--////////////////////////////////////////////////////

function bubbles()

    if MyRandomNumber == 1 then
        SetData("Particle.DetailObject", "Bubbles1")
        SetData("Particle.Name", "ParticleBubbles")
	SendMessage("Particle.NewEmitter")
	id1 = GetData("Particle.Handle")
	
	SendIntMessage("Particle.DeleteEmitter",id2)
	SendIntMessage("Particle.DeleteEmitter",id3)
	SendIntMessage("Particle.DeleteEmitter",id4)
	
	elseif MyRandomNumber == 2 then
            SetData("Particle.DetailObject", "Bubbles2")
            SetData("Particle.Name", "ParticleBubbles")
            SendMessage("Particle.NewEmitter")
            id2 = GetData("Particle.Handle")
	
            SendIntMessage("Particle.DeleteEmitter",id1)
            SendIntMessage("Particle.DeleteEmitter",id3)
            SendIntMessage("Particle.DeleteEmitter",id4)
	
	elseif MyRandomNumber == 3 then
            SetData("Particle.DetailObject", "Bubbles3")
            SetData("Particle.Name", "ParticleBubbles")
            SendMessage("Particle.NewEmitter")
            id3 = GetData("Particle.Handle")
	
            SendIntMessage("Particle.DeleteEmitter",id1)
            SendIntMessage("Particle.DeleteEmitter",id2)
            SendIntMessage("Particle.DeleteEmitter",id4)
	
        elseif MyRandomNumber == 4 then
            SetData("Particle.DetailObject", "Bubbles4")
            SetData("Particle.Name", "ParticleBubbles")
            SendMessage("Particle.NewEmitter")
            id4 = GetData("Particle.Handle")
	
            SendIntMessage("Particle.DeleteEmitter",id1)
            SendIntMessage("Particle.DeleteEmitter",id2)
            SendIntMessage("Particle.DeleteEmitter",id3)
	
    end
	
    StartTimer("bubbleend", 4000)	
	
end	

function bubbleend()

SendMessage("RandomNumber.Get")
RandomNumber = GetData("RandomNumber.Uint")
MyRandomNumber = math.mod(RandomNumber, 3) + 1
bubbles()

end


--////////////////////////////////////////////////////////
--//            Set up teams and inventories            //
--////////////////////////////////////////////////////////


function SetupWormsAndTeams()

   GM = QueryContainer("GM.GameInitData")
   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
   team.Name = GM.T1_Name
   team.TeamColour = 1
   team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
   CloseContainer(lock) -- must close the container ASAP

   -- Activate Team 1
   lock, team = EditContainer("Team.Data01") 
   team.Active = true
   team.Name = "BadBoys"
   team.IsAIControlled = true
   team.TeamColour = 0
   team.FlagGfxName = "66"
   CloseContainer(lock)

   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
   worm.Name = GM.T1_W1_Name
   worm.SfxBankName = GM.T1_Speech
   worm.Spawn = "spawn1"
   worm.Energy = 100
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 
   
   -- Worm 1, Team 0
    CopyContainer("Worm.Data00", "Worm.Data01")
   lock, worm = EditContainer("Worm.Data01")
   worm.Energy = 100
   worm.SfxBankName = GM.T1_Speech
   worm.Name = GM.T1_W2_Name
   worm.Spawn = "spawn5"
   worm.TeamIndex = 0
   CloseContainer(lock)

   -- Worm 0, Team 1
   CopyContainer("Worm.Data00", "Worm.Data02")
   lock, worm = EditContainer("Worm.Data02")
   CopyContainer("AIParams.CPU1", "AIParams.Worm02")
   worm.Energy = 40
--This needs changing to SUPER VILLAIN - Boggy P will sport this voice in every mission
   worm.SfxBankName = "Super Villain"
   worm.Name = "Boggy Pete"
   worm.Spawn = "spawn3"
   worm.TeamIndex = 1
   CloseContainer(lock)
   
    -- Worm 1, Team 1
   CopyContainer("Worm.Data00", "Worm.Data03")
   lock, worm = EditContainer("Worm.Data03")
   CopyContainer("AIParams.CPU1", "AIParams.Worm03")
   worm.Energy = 30
   worm.SfxBankName = "Madchester"
   worm.Name = "Jeggett"
   worm.Spawn = "spawn2"
   worm.TeamIndex = 1
   CloseContainer(lock)
   
    -- Worm 2, Team 1
   CopyContainer("Worm.Data00", "Worm.Data04")
   lock, worm = EditContainer("Worm.Data04")
   CopyContainer("AIParams.CPU1", "AIParams.Worm04")
   worm.Energy = 30
   worm.SfxBankName = "Madchester"
   worm.Name = "Dennis"
   worm.Spawn = "spawn4"
   worm.TeamIndex = 1
   CloseContainer(lock)

     -- Worm 3, Team 1
   CopyContainer("Worm.Data00", "Worm.Data05")
   lock, worm = EditContainer("Worm.Data05")
   CopyContainer("AIParams.CPU1", "AIParams.Worm05")
   worm.Energy = 30
   worm.SfxBankName = "Madchester"
   worm.Name = "Alan"
   worm.Spawn = "spawn6"
   worm.TeamIndex = 1
   CloseContainer(lock)
   
     -- Worm 4, Team 1
   CopyContainer("Worm.Data00", "Worm.Data06")
   lock, worm = EditContainer("Worm.Data06")
   CopyContainer("AIParams.CPU1", "AIParams.Worm06")
   worm.Energy = 30
   worm.SfxBankName = "Madchester"
   worm.Name = "Ian"
   worm.Spawn = "spawn7"
   worm.TeamIndex = 1
   CloseContainer(lock)
   
   SendMessage("WormManager.Reinitialise")

end


function SetupInventories()

    -- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Bazooka = 5
    inventory.Grenade = 2
    inventory.ClusterGrenade = -1
    inventory.Shotgun = 1
    inventory.FirePunch = 2
    inventory.Landmine = 2
    --inventory.Uzi = 1
    inventory.HomingMissile = 1
    --inventory.VikingAxe = 1
    inventory.Blowpipe = 2
    inventory.Prod = -1
    inventory.Sheep = 1
    inventory.Dynamite = 1
    inventory.SkipGo = -1
    inventory.Freeze = 2
    CloseContainer(lock) -- must close the container ASAP
    
    -- Copies this selection into Team00
    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
    CopyContainer("Inventory.Team.Default", "Inventory.Team01")
    
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Bazooka = 0
    inventory.Grenade = -1
    inventory.ClusterGrenade = -1
    inventory.Shotgun = 0
    inventory.FirePunch = 0
    inventory.Landmine = 0
    --inventory.Uzi = 1
    inventory.HomingMissile = 0
    inventory.VikingAxe = 0
    inventory.Blowpipe = 0
    inventory.Prod = 0
    inventory.Sheep = 0
    inventory.Dynamite = 0
    inventory.SkipGo = -1
    inventory.Surrender = -1
    inventory.Freeze = 0
    CloseContainer(lock)
    
end

--////////////////////////////////////////////////////////////////
--//    EFMV cameras                                            //
--////////////////////////////////////////////////////////////////

function RailCamera1()

    Fix = 1
    
    SetData("Camera.Path.Knots.Position", "Rail1a, Rail1, Rail2, Rail3, Rail4, Rail5, Rail6, Rail7")
    SetData("Camera.Path.Knots.LookAt", "Focal1, Focal2")
    SetData("Camera.Path.Steps.Position", 270)
    SetData("Camera.Path.Steps.LookAt", 1820)
    SetData("Camera.Path.Tension.Position", -0.3) 
    SendMessage("Camera.Path.Start")
    
end


function Camera_Path_Reached_Knot()

    knot = GetData("Camera.Path.Knot")

    if knot == "Rail2" then 
        SetData("CommentaryPanel.Comment", "Chall.Shotgun3.Intro1")
        SendMessage("CommentaryPanel.ScriptText")
    end 
    
    
    if knot == "Rail4" then 
        SetData("CommentaryPanel.Comment", "Chall.jet1.extra1")
        SendMessage("CommentaryPanel.ScriptText")
        
        wormsanim1()
    end
    
    if knot == "Rail5" then 
    
        wormsanim2()
        
    end
  

    if knot == "Rail6" then 
        SetData("CommentaryPanel.Comment", "Miss.Showdown.Here")
        SendMessage("CommentaryPanel.ScriptText")
    end  
    
    if knot == "Rail7" then 
        SetData("CommentaryPanel.Comment", "MissCrate.game1")
        SendMessage("CommentaryPanel.ScriptText")
        
        StartTimer("VitalCam", 2500)
    end 

end

function VitalCam()

    SetData("Camera.Path.Knots.Position", "CrateCam1, CrateCam2")
    SetData("Camera.Path.Knots.LookAt", "CrateLook1")
    SetData("Camera.Path.Steps.Position", 1000)
 
    SendMessage("Camera.Path.Start")
    
    SetData("CommentaryPanel.Comment", "MissCrate.game2")
    SendMessage("CommentaryPanel.ScriptText")
    
    StartTimer("NextMessage", 3000)
    
    Timer1 = StartTimer("startt", 6500)
    
end


function NextMessage()

    SetData("CommentaryPanel.Comment", "Chall.Sheep3.Intro8")
    SendMessage("CommentaryPanel.ScriptText")

end


--////////////////////////////////////////////////////////
--// worms animations                                   //
--////////////////////////////////////////////////////////

function wormsanim1()

        SendIntMessage("Worm.ResetAnim", 4)
        SetData("Worm.ScriptAnim", "Smug1")
        SendIntMessage("Worm.QueueAnim", 4)

end 


function wormsanim2()

        SendIntMessage("Worm.ResetAnim", 2)
        SetData("Worm.ScriptAnim", "Taunt1")
        SendIntMessage("Worm.QueueAnim", 2)

end 


--////////////////////////////////////////////////////////
--//    Start turns                                     //
--////////////////////////////////////////////////////////

function startt()

    SendMessage("EFMV.End")
    camdone =  1

    StartFirstTurn()
    
end


function startt2()

    SendMessage("EFMV.End")
    SendMessage("Camera.SetDefault")
    SetData("Camera.Path.IgnoreInput", 0)
    --camdone =  1
    SendMessage("GameLogic.ResumeGame")
end


function StartFirstTurn()

    Fix = 0
    WaitUntilNoActivity = false

    SendMessage("Timer.StartGame")
    SendMessage("EFMV.End")
    
    
    SendMessage("Camera.SetDefault")
    
    StartTurn()
    
end


--//////// Check for EFMV interruption /////////////

function Camera_Path_Stopped()

    if camdone == 0 then
    
        camdone = 1
        CancelTimer(Timer1)
        
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end

	SendMessage("Commentary.Clear")
        
        StartFirstTurn()
        SendMessage("EFMV.End")
        
    end
    
end

--////////////////////////////////////////////////////////
--//    Send text to commentary panel during the game   //
--////////////////////////////////////////////////////////


function TurnStarted()

    checkteam()
    
    if turn == 0 then
        elseif turn == 2 then
            SetData("CommentaryPanel.Comment", "MissCrate.game3")
            SendMessage("CommentaryPanel.ScriptText")
    
            SetData("CommentaryPanel.Comment", "MissCrate.game4")
            SendMessage("CommentaryPanel.ScriptText")
    
        elseif turn == 5 then
            SetData("CommentaryPanel.Comment", "MissCrate.game5")
            SendMessage("CommentaryPanel.ScriptText")
    
        elseif turn == 8 then
            SetData("CommentaryPanel.Comment", "MissCrate.game6")
            SendMessage("CommentaryPanel.ScriptText")
    end

    turn=turn + 1

end

--////////////////////////////////////////////////////////
--// check for lose condition of worms dying            //
--////////////////////////////////////////////////////////

 
function Worm_Died()

    deadworm = GetData("DeadWorm.Id")
    
    if deadworm == 0 then 
        if deadworm == 1 then
            FailureMessages()
            if Switch == 0 then
                Switch = 1
                endmissionfail()
            end
        end
    end
end

function endmissionfail()
	SendMessage("GameLogic.Mission.Failure")
end
 
--///////////////////////////////////////////////////////
--// Lock team 1 (CPU team) in artillery mode          //
--///////////////////////////////////////////////////////
 
function checkteam()

-- PC: the current team value is now called CurrentTeamIndex
    Team = GetData("CurrentTeamIndex")
    
    if Team == 1 then
        stopteam()
   end
   
end
 
 
function stopteam()

   --SendStringMessage("Input.DisableGroup", "WormMoving")
    SetData("GameLogic.ArtilleryMode", 1)
    
end
 
 
--///////////////////////////////////////////////////////////////
--// When this crate is collected, the game will end (success) //
--///////////////////////////////////////////////////////////////

function Crate_Collected()

    CrateNumber = GetData("Crate.Index")
    
    if CrateNumber == 1 then
       SendMessage("GameLogic.PauseGame")
        SetData("Camera.Path.IgnoreInput", 1)
	SendMessage("EFMV.Start")
	MakeCamera2()
	
	elseif CrateNumber == 99 then
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
            
            SendIntMessage("Particle.DeleteEmitter", PID1)
            
            SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
            SendMessage("CommentaryPanel.ScriptText")

            SetData("Camera.Path.IgnoreInput", 1)
            endmission()
    end
    
end


function MakeCamera2()
 
    SetData("Camera.Path.Knots.Position", "CrateCam1, CrateCam2")
    SetData("Camera.Path.Knots.LookAt", "CrateLook1")
    SetData("Camera.Path.Steps.Position",1000)

    SetData("CommentaryPanel.Comment","Miss.Holiday.game4")
    SendMessage("CommentaryPanel.ScriptText")
    SendMessage("Camera.Path.Start")
    
    StartTimer("startt2", 3850)
    
end


function endmission()

    Switch = 1
    Result()

end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.P.Pete") --unlock Boggy Pete Wormapedia entry
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName2","L.P.Pete")
                end
                CloseContainer(Key)
                
                Key,Lock = EditContainer("L.L.CrateBritain") --unlock landscape for multiplayer
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.CrateBritain")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end


--////////////////////////////////////////////////////////
--// check for crate being destroyed                    //
--////////////////////////////////////////////////////////

function Crate_Destroyed()
    CrateNumber = GetData("Crate.Index")
    
    if CrateNumber == 99 then
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
        
        SendIntMessage("Particle.DeleteEmitter", PID1)
    
        SetData("Camera.Path.IgnoreInput", 1)
        SetData("CommentaryPanel.Comment", "Miss.Showdown.Failed")
        SendMessage("CommentaryPanel.ScriptText")
        if Switch == 0 then
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
        
        elseif CrateNumber == 1 then
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
            
            SetData("Camera.Path.IgnoreInput", 1)
            SetData("CommentaryPanel.Comment", "Miss.Showdown.Failed")
            SendMessage("CommentaryPanel.ScriptText")
            if Switch == 0 then
                SendMessage("GameLogic.Mission.Failure")
                Switch = 1
            end
            
    end
    
end


--////////////////////////////////////////////////////////
--// Checks for existence of teams in the game returns  //
--// failed mission if none exist.                      //
--////////////////////////////////////////////////////////

function CheckOneTeamVictory()

    SendMessage("WormManager.GetActiveTeamCount")
    TeamCount = GetData("TeamCount")
   
    if TeamCount == 1 then
        SendMessage("WormManager.GetSurvivingTeam")
        TeamLeft = GetData("SurvivingTeamIndex")
        
        if TeamLeft == 1 then   
            -- all the teams have just snuffed it
            if Switch == 0 then
                Switch = 1
                FailureMessages()
                SendMessage("GameLogic.Mission.Failure")
            end
        end
        ----NEEDS RETURNING TO ZERO,.
        if TeamLeft == 0 then   
            -- all the teams have just snuffed it
            StartTurn()
        end 
        
    end
  
    if TeamCount == 2 then
        -- still at least 2 teams left
        StartTurn()
    end
   
end

--////////////////////////////////////////////////
--// fail mission when timer runs out           //
--////////////////////////////////////////////////

function TurnEnded()

    SetData("GameLogic.ArtilleryMode", 0)
    CheckOneTeamVictory()
    
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end

end

--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
    
end

function SuccessMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end

end








