
-- Deathmatch Part Three (Grant's own work - hahaha yeah right)

function Initialise()
    SetData("Camera.StartOfTurnCamera","Default")
    
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)

    SendMessage("GameLogic.PlaceObjects")
    SendMessage("EFMV.Start")
    StartedSuddenDeath = false
    
    SetupWormsAndTeams()
    SetupInventories()
    camera()
end

function camera()
    CameraFly = 1
    SetData("CommentaryPanel.Comment", "Chall.Deathmatch2.Game1")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "Cam1,Cam2")
    SetData("Camera.Path.Knots.LookAt", "Look1")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",500)
    SendMessage("Camera.Path.Start")
     
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Worried3")
    SendIntMessage("Worm.QueueAnim", 3)
     
    CamLoop = StartTimer("camera2", 3400)
end

function camera2()
    SetData("Camera.Path.Knots.Position", "Cam3,Cam4")
    SetData("Camera.Path.Knots.LookAt", "Look2")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",450)  
    SetData("Camera.Path.Steps.LookAt",550)
    SendMessage("Camera.Path.Start")
    
    SendIntMessage("Worm.ResetAnim", 4)
    SetData("Worm.ScriptAnim", "WTF")
    SendIntMessage("Worm.QueueAnim", 4)
    
    CamLoop = StartTimer("camera3", 3800)
end

function camera3()
    SendIntMessage("Worm.ResetAnim", 5)
    SetData("Worm.ScriptAnim", "Taunt2")
    SendIntMessage("Worm.QueueAnim", 5)
    
    SetData("Camera.Path.Knots.Position", "Cam5,Cam6")
    SetData("Camera.Path.Knots.LookAt", "Look3")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",350)  
    SetData("Camera.Path.Steps.LookAt",450)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera4", 3000)
end
 
function camera4()
    SendIntMessage("Worm.ResetAnim", 6)
    SetData("Worm.ScriptAnim", "Idle_Shotgun")
    SendIntMessage("Worm.QueueAnim", 6)

    SetData("Camera.Path.Knots.Position", "Cam7")
    SetData("Camera.Path.Knots.LookAt", "Look4")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",250)  
    SetData("Camera.Path.Steps.LookAt",450)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera5", 3300)
end

function camera5()
    SetData("CommentaryPanel.Comment", "Chall.Deathmatch2.Game3")
    SendMessage("CommentaryPanel.ScriptText")

    SendIntMessage("Worm.ResetAnim", 7)
    SetData("Worm.ScriptAnim", "Worried3")
    SendIntMessage("Worm.QueueAnim", 7)

    SetData("Camera.Path.Knots.Position", "Cam8")
    SetData("Camera.Path.Knots.LookAt", "Look5")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",230)  
    SetData("Camera.Path.Steps.LookAt",450)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("startt", 4500)
end
 
function Camera_Path_Reached_Knot()
    knot = GetData("Camera.Path.Knot")

    if knot == "Cam8" then
        startt()
    end
end

function startt()
    SendMessage("EFMV.End")
    CameraFly = 0
    StartFirstTurn()
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        SendMessage("Commentary.Clear")
        CameraFly = 0
        CancelTimer(CamLoop)
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        SendMessage("EFMV.End")
        StartFirstTurn()
    end
end

function SelectRandomWind()
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", RandomNumber*MaxWind * 3 /10)

   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", Direction)   
end


function TurnEnded()
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    if (RoundTimeRemaining == 0 or RoundTimeRemaining < 0) and StartedSuddenDeath == false then
        StartedSuddenDeath = true
        SetAllWormsEnergy(1)
    end
    
    CheckOneTeamVictory()
end

function SetAllWormsEnergy(energy)
    SuddenDeathMessages()

    local WormIndex = 0
    local DataId = GetWormContainerName(WormIndex)
    while DataId ~= "" do
        lock, worm = EditContainer(DataId)
        worm.Energy = energy
        CloseContainer(lock)
        WormIndex = WormIndex + 1
        DataId = GetWormContainerName(WormIndex)
    end
end

function SuddenDeathMessages()
    SendMessage("Commentary.Clear")

    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 6) + 1

    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.2")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.3")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.5")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 6 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.6")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function FailureMessages()
    SendMessage("Commentary.Clear")

    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1

    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Chall.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Chall.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function CheckOneTeamVictory()
    TeamCount = GetData("TeamCount")
    WhichTeam = GetData("SurvivingTeamIndex")

    if TeamCount == 0 then
        FailureMessages()
        SendMessage("GameLogic.Challenge.Failure")
    elseif TeamCount == 1 and WhichTeam == 1 then
        FailureMessages()
        SendMessage("GameLogic.Challenge.Failure")
    elseif TeamCount == 1 and WhichTeam == 0 then
        Key,Lock = EditContainer("L.C.DM4")
        Result()
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName","L.C.DM4")
        end
        CloseContainer(Key)
        SendMessage("GameLogic.Challenge.Result")
    else
        StartTurn()
    end
end

function Result()
    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
    timetook = GetData("ElapsedRoundTime")
    goldtime = GetData("MCa.BestGold")
    silvertime = GetData("MCa.BestSilver")
    bronzetime = GetData("MCa.BestBronze")
    
    if timetook < bronzetime then
        Movie = 1
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
            end
        end
    end
    
    if Movie == 1 then
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("GameOver.AwardMovie","gold")
    end
end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")

    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Enemy"
    team.TeamColour = 1
    team.IsAIControlled = true
    team.FlagGfxName = "68"
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 75
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "HUMspawn1"
    CloseContainer(lock) 

    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HUMspawn2"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GM.T1_W3_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HUMspawn3"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03")
    CopyContainer("AIParams.CPU2", "AIParams.Worm03")
    worm.Energy = 100 
    worm.Name = "Linz"
    worm.SfxBankName = "Classic"
    worm.TeamIndex = 1
    worm.Spawn = "spawn5"
    CloseContainer(lock)

    CopyContainer("Worm.Data03", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    CopyContainer("AIParams.Worm04", "AIParams.Worm04")
    worm.Energy = 100  
    worm.Name = "Ste"
    worm.SfxBankName = "Classic"
    worm.Spawn = "spawn6"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data03", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    CopyContainer("AIParams.Worm04", "AIParams.Worm05")
    worm.Energy = 100  
    worm.Name = "Larry"
    worm.SfxBankName = "Classic"
    worm.Spawn = "spawn7"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data03", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    CopyContainer("AIParams.Worm04", "AIParams.Worm06")
    worm.Energy = 100  
    worm.Name = "Kenny"
    worm.SfxBankName = "Classic"
    worm.Spawn = "spawn8"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data03", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    CopyContainer("AIParams.Worm04", "AIParams.Worm07")
    worm.Energy = 100  
    worm.Name = "Duke"
    worm.SfxBankName = "Classic"
    worm.Spawn = "spawn9"
    CloseContainer(lock)

    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Bazooka = 5
    inventory.Grenade = 5
    inventory.ClusterGrenade = -1
    inventory.Airstrike = 1
    inventory.Dynamite = 1
    inventory.Landmine = 1
    inventory.Parachute = 3
    inventory.Jetpack = 1
    inventory.Girder = 2
    inventory.Shotgun = 1
    inventory.Uzi = 1
    inventory.NinjaRope = 6
    inventory.FirePunch = 1
    inventory.Prod = -1
    inventory.PetrolBomb = 2
    inventory.BaseballBat = 1
    inventory.Mortar = 2
    inventory.SkipGo = -1
    inventory.ChangeWorm = 1
    CloseContainer(lock)

    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Bazooka = 5
    inventory.Grenade = 5
    inventory.ClusterGrenade = -1
    inventory.Airstrike = 1
    inventory.Dynamite = 1
    inventory.Landmine = 1
    inventory.Parachute = 3
    inventory.Jetpack = 1
    inventory.Girder = 2
    inventory.Shotgun = 1
    inventory.Uzi = 1
    inventory.NinjaRope = 6
    inventory.FirePunch = 1
    inventory.Prod = -1
    inventory.PetrolBomb = 2
    inventory.BaseballBat = 1
    inventory.Mortar = 2
    inventory.SkipGo = -1
    inventory.ChangeWorm = 1
    CloseContainer(lock)

    lock, delays = EditContainer("Inventory.WeaponDelays") 
    delays.Airstrike = 6
    CloseContainer(lock)
end
