
-- Mission Basic setup 1human V 1cpu player E3 Demo

function Initialise()
-- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
   SetData("TurnTime", 20000)
    --SendMessage("GameLogic.PlaceObjects")

   SendMessage("GameLogic.PlaceObjects")

    SetupWormsAndTeams()
    SetupInventories()
    StartFirstTurn()


    
end


function StartTurn()
   SendMessage("Timer.StartHotSeatTimer")
   SendMessage("GameLogic.ActivateNextWorm")
   SendMessage("Weapon.Create")
   SetWind()
   TurnStarted()
   SendMessage("GameLogic.Turn.Started")
   RunAILogic()
   
    SetData("CommentaryPanel.Comment", "E3.ingame")
    SendMessage("CommentaryPanel.ScriptText")
    
   
end


function SetupWormsAndTeams()
-- Activate Team 0
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = "The Lightsiders"
    team.TeamColour = 0
    team.IsAIControlled = true
    CloseContainer(lock) -- must close the container ASAP
-- Activate Team 1
    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Darksiders"
    team.TeamColour = 1
    team.IsAIControlled = true
    CloseContainer(lock)
-- Worm 0, Team 0
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = "Purple Light"
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.SfxBankName = "Classic"
    worm.Spawn = "spawn"
    CloseContainer(lock) 
-- Worm 1, Team 0
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = "Mac"
    worm.Spawn = "spawn"
    CloseContainer(lock)
-- Worm 2, Team 0
    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = "Taylor"
    worm.Spawn = "spawn"
    CloseContainer(lock)
-- Worm 3, Team 0
    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03") 
    worm.Name = "Kjatte"
    worm.Spawn = "spawn"
    CloseContainer(lock)
-- Worm 4, Team 1
    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 80 
    worm.Name = "Boggy B"
    worm.TeamIndex = 1
    worm.Spawn = "spawn"
    CloseContainer(lock)
-- Worm 5, Team 1
    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    worm.Energy = 80  
    worm.Name = "Da Spadger"
    worm.Spawn = "spawn"
    CloseContainer(lock)
-- Worm 6, Team 1
    CopyContainer("Worm.Data04", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    worm.Energy = 80  
    worm.Name = "Worm Mad"
    worm.Spawn = "spawn"
    CloseContainer(lock)
-- Worm 7, Team 1
    CopyContainer("Worm.Data04", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    worm.Energy = 80  
    worm.Name = "Mental"
    worm.Spawn = "spawn"
    CloseContainer(lock)
   SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
-- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Bazooka = -1
    inventory.Grenade = -1

    CloseContainer(lock) -- must close the container ASAP

-- Copies this selection into each worm
   CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   CopyContainer("Inventory.Team.Default", "Inventory.Team01")
   
   
   
    lock, delays = EditContainer("Inventory.WeaponDelays") 
   --delays.Airstrike = 4
  -- delays.HomingMissile = 0
   --delays.HomingPidgeon = 4   
  -- delays.MadCow = 6
 --  delays.HolyHandGrenade = 6   
   CloseContainer(lock)
   
   
   
   
   
end


