-- Plaice Holder - Single Player Mission

function Initialise()
    SendMessage("Commentary.NoDefault")
--Still need QA times...
    bronzetime = (60 * 1000) * 999
    silvertime = 320000
    goldtime = 290000
    
    SetData("Land.Indestructable", 1)
    
    SetData("Trigger.Spawn", "TRIG")
    SetData("Trigger.Radius", 25)
    SetData("Trigger.Index", 999)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Particle.DetailObject", "Flies")
    SetData("Particle.Name", "Part_Fly")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Flies")
    SetData("Particle.Name", "Part_Fly")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Steamplume")
    SetData("Particle.Name", "Part_Steamplume")
    SendMessage("Particle.NewEmitter")
        
    SetData("Camera.StartOfTurnCamera","Default")
        
    NewCrate = 1

    SetData("Jetpack.InitFuel", 9000)
    SetData("TurnTime", 0)
    SetData("RoundTime", 360000)
    SendMessage("GameLogic.PlaceObjects")
    SendMessage("HUD.HideTurnTime")
    --SetData("HUD.Clock.DisplayRoundTime", 0)

    SetupWormsAndTeams()
    SetupInventories()
    
    SetData("Trigger.Spawn", "Trigger1")
    SetData("Trigger.Radius", 25)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")

    SetData("Crate.Spawn", "CrateSpawn3")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", -1)
    SetData("Crate.Contents", "kUtilityJetpack")
    SetData("Crate.Index", 3)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.TeamDestructible", 10)
    SendMessage("GameLogic.CreateCrate")
    
    deadWorm = 0
    MissedTourGuide = 0
    CamSwitch = 0
    QuakeSwitch = 0
    QuakeTimer = 0
    ActivateTurn = 0
    Switch = 0

    TextOn = 0
    Remove = 0
    PID1 = 0
    PID2 = 0
    PID3 = 0
    PID4 = 0
    PID5 = 0
    PID6 = 0
    TurnCounter = 0
    RespawnWeapon = 0
    PlayerDead = 0
    PlayerCheck1 = 0
    RespawnWeapon = 1
    
    SetData("Particle.DetailObject", "sparkle2")
    SetData("Particle.Name", "Part_StarBridge")
    SendMessage("Particle.NewEmitter")
    PID2 = GetData("Particle.Handle")
        
    Gun()
    SendMessage("EFMV.Start")
    camera()
end

--////////////////////////////////////////////////////////////////////////
--//            Random wind                                             //
--////////////////////////////////////////////////////////////////////////


function SelectRandomWind()
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", 0.3*MaxWind)

   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", 1.9) 
end


function Missed()
        --SetData("CommentaryPanel.Comment", "Miss.Plaice.Now")
        --SendMessage("CommentaryPanel.ScriptText")
        MissedTourGuide = 1
        Gun()
end


function Gun()

    if RespawnWeapon == 1 then
        SetData("Crate.Spawn", "CrateSpawn1")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Index", 1)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        
        if MissedTourGuide == 1 then
            SetData("CommentaryPanel.Comment", "Miss.Plaice.Missed")
            SetData("CommentaryPanel.Delay",2500) 
            SendMessage("CommentaryPanel.TimedText")
            SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game9")
            SendMessage("CommentaryPanel.ScriptText")
            
            MissedTourGuide = 0
            StartTurn()
        end
    end
end

--////////////////////////////////////////////////////////////////////
--//                    Check for trigger destroyed                 //
--////////////////////////////////////////////////////////////////////

function Trigger_Destroyed()

	TriggerIndex = GetData("Trigger.Index")
        
	if TriggerIndex == 666 then
        
            CreateExplosion("Explosion1", 110, 0.35, 150, 175, 80)
            SetData("Particle.DetailObject", "ExplosionGFX1")
            SetData("Particle.Name", "EffectExplosion")
            SendMessage("Particle.NewEmitter")
            SetData("CommentaryPanel.Comment", "Miss.Plaice.Secret")
            SetData("CommentaryPanel.Delay",3000)
            SendMessage("CommentaryPanel.TimedText")
           
        elseif TriggerIndex == 999 then
            CreateExplosion("CageExplosion", 10, 0.35, 150, 35, 80)
            CreateExplosion("CageExplosion2", 10, 0.35, 150, 35, 80)
            SendIntMessage("Worm.DieQuietly",1)
        end
end



--////////////////////////////////////////////////////////////
--//                    Crate Logic                         //
--////////////////////////////////////////////////////////////

function Crate_Destroyed()
    if Switch == 0 then
        SendMessage("GameLogic.Mission.Failure")
        Switch = 1
    end
end


function MakeNewCrate()
    if NewCrate == 2 then
    
    elseif NewCrate == 3 then
         
    elseif NewCrate == 4 then
          
    elseif NewCrate == 5 then

   -- elseif NewCrate == 8 then
    end
     
    NewCrate = NewCrate + 1     
end


function Crate_Collected()
    MakeNewCrate()
    CrateNumber = GetData("Crate.Index")
 
    if CrateNumber == 2 then

        SendIntMessage("Particle.DeleteEmitter", PID1)
        
        SendMessage("Commentary.Clear")
 
        SetData("CommentaryPanel.Comment", "Miss.Plaice.InTheShark")
        SetData("CommentaryPanel.Delay",2500) 
        SendMessage("CommentaryPanel.TimedText")
        SendMessage("EFMV.Start")
        
        SetData("Camera.Path.IgnoreInput", 1)
        
        SetData("Camera.Path.Knots.Position", "SharkPos1,SharkPos2,SharkPos3")
        SetData("Camera.Path.Knots.LookAt", "LookAtShark1,LookAtShark2")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",400)  
        SetData("Camera.Path.Steps.LookAt",500)
        SetData("Camera.Path.Tension.Position", 0.5) 
        SendMessage("Camera.Path.Start")
        EndTurn()

--        CamLoop2 = StartTimer("ResetCamera", 10000)
--        CamLoop3 = StartTimer("BorderEnd", 10000)
            
    elseif CrateNumber == 3 then
    
        SendIntMessage("Particle.DeleteEmitter", PID2)
        
        SetData("Particle.DetailObject", "sparkle3")
        SetData("Particle.Name", "Part_StarBridge")
        SendMessage("Particle.NewEmitter")
        PID3 = GetData("Particle.Handle")
        
        SendMessage("Commentary.Clear")
        
        SetData("Jetpack.InitFuel", 5000)
        SetData("CommentaryPanel.Comment", "Miss.Plaice.FindAWay")
        SetData("CommentaryPanel.Delay",3000) 
        SendMessage("CommentaryPanel.TimedText")
        SetData("Crate.Spawn", "CrateSpawn5")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 2)
        SetData("Crate.Contents", "kUtilityGirder")
        SetData("Crate.Index", 4)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
    
    elseif CrateNumber == 4 then
    
        SendIntMessage("Particle.DeleteEmitter", PID3)
        
        SetData("Particle.DetailObject", "sparkle4")
        SetData("Particle.Name", "Part_StarBridge")
        SendMessage("Particle.NewEmitter")
        PID4 = GetData("Particle.Handle")
        
        SetData("CommentaryPanel.Comment", "Miss.Plaice.Lighthouse")
        SetData("CommentaryPanel.Delay",3000) 
        SendMessage("CommentaryPanel.TimedText")
        SetData("Crate.Spawn", "CrateSpawn4")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kUtilityParachute")
        SetData("Crate.Index", 5)
        SendMessage("GameLogic.CreateCrate")
        LighthouseCam()
        
    
    elseif CrateNumber == 5 then
        SendIntMessage("Particle.DeleteEmitter", PID4)
        
        SetData("CommentaryPanel.Comment", "Miss.Plaice.Earthquake")
        SetData("CommentaryPanel.Delay",3000) 
        SendMessage("CommentaryPanel.TimedText")
        
        
        QuakeTimer = StartTimer("QuakeImminent", 15000)        
        
    elseif CrateNumber == 999 then
    
        SendIntMessage("Particle.DeleteEmitter", PID5)
    
        SetData("CommentaryPanel.Comment", "Miss.Plaice.Flare")
        SendMessage("CommentaryPanel.ScriptText")
        FlareCam()
    end
end

--//////////////////////////////////////////////////////////////
--//            Cameras                                       //
--//////////////////////////////////////////////////////////////



function camera()

    CameraFly = 1
    SetData("CommentaryPanel.Comment", "Miss.Plaice.Blur")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")
    
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2")
    SetData("Camera.Path.Knots.LookAt", "LookAt1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",325)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")

end

function camera2()
    SetData("CommentaryPanel.Comment", "Miss.Plaice.Blur2")
    SetData("CommentaryPanel.Delay",2500)
    SendMessage("CommentaryPanel.TimedText")
    
    SetData("Camera.Path.Knots.Position", "Pos3,Pos4,Pos5")
    SetData("Camera.Path.Knots.LookAt", "LookAt2,LookAt2a")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",255)  
    SetData("Camera.Path.Steps.LookAt",200)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    TimerControl = 1

end

function CameraText()
    SetData("CommentaryPanel.Comment", "Miss.Plaice.Blur3")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")
    
end

function camera3()
    SetData("Camera.Path.Knots.Position", "Pos6,Pos7,Pos8,Pos9")
    SetData("Camera.Path.Knots.LookAt", "LookAt3,LookAt3a")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",325)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")

    
end

function camera4()
    SetData("Camera.Path.Knots.Position", "Pos10,Pos11")
    SetData("Camera.Path.Knots.LookAt", "LookAt4")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",550)  
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    
    Animm()
    
end

function FIRST()
    SendMessage("EFMV.Start")
    SendMessage("GameLogic.PauseGame")
    SetData("GameLogic.ArtilleryMode", 1)
    SetData("Camera.Path.Knots.Position", "FirstPos1,FirstPos2")
    SetData("Camera.Path.Knots.LookAt", "FirstLook")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",450)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    --StartTimer("CarryOn", 3000)
end


function CrateCam()
    --Pause()
    --PauseTimer = StartTimer("Resume", 8000)
    SendMessage("EFMV.Start")
    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("Camera.Path.Knots.Position", "CrateCamPos1,CrateCamPos2,CrateCamPos3")
    SetData("Camera.Path.Knots.LookAt", "CrateCamLook1,CrateCamLook2")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",450)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    EndTurn()
end


function LighthouseCam()
   -- Pause()
   -- PauseTimer = StartTimer("Resume", 10000)
    SendMessage("EFMV.Start")
    SetData("Camera.Path.IgnoreInput", 1)    
    
    SetData("Camera.Path.Knots.Position", "LightPos1,LightPos2,LightPos3")
    SetData("Camera.Path.Knots.LookAt", "LookAtLight1,LookAtLight2")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",500)
    SetData("Camera.Path.Tension.Position", 0.2) 
    SendMessage("Camera.Path.Start")
    EndTurn()
end

--The earthquake starts once the last crate (on top of the lighthouse) has been collected.
--The aim is to survive the earthquake, after this the final crates will appear.
function StartEarthquake()
    SetData("Earthquake.Length", -1)
    SetData("Earthquake.ImpulseMagnitudeMin",0.02)
    SetData("Earthquake.ImpulseMagnitudeMax",0.09)
    SendMessage("Earthquake.Start")
    
    StartTimer("FLARE", 5000)
    
end

--////////////////////////////////////////////////////////////////////////
--//            Earthquake Text                                         //
--////////////////////////////////////////////////////////////////////////

function QuakeImminent()

    if QuakeSwitch == 0 then
        SetData("CommentaryPanel.Comment", "Miss.Plaice.Quake")
        SendMessage("CommentaryPanel.ScriptText")
        
        StartTimer("CountText10", 2000)
    end
end

function CountText10()

    if QuakeSwitch == 0 then
        SetData("CommentaryPanel.Comment", "Miss.count10")
        SendMessage("CommentaryPanel.ScriptText")
    
        StartTimer("CountText9", 1900)
    end
end

function CountText9()

    if QuakeSwitch == 0 then
        SetData("CommentaryPanel.Comment", "Miss.count9")
        SendMessage("CommentaryPanel.ScriptText")
    
        StartTimer("CountText8", 1900)
    end
end

function CountText8()

    if QuakeSwitch == 0 then
        SetData("CommentaryPanel.Comment", "Miss.count8")
        SendMessage("CommentaryPanel.ScriptText")
        
        StartTimer("CountText7", 1900)
    end
end

function CountText7()

    if QuakeSwitch == 0 then
        SetData("CommentaryPanel.Comment", "Miss.count7")
        SendMessage("CommentaryPanel.ScriptText")
       
        StartTimer("CountText6", 1900)
    end
end

function CountText6()

    if QuakeSwitch == 0 then
        SetData("CommentaryPanel.Comment", "Miss.count6")
        SendMessage("CommentaryPanel.ScriptText")
       
        StartTimer("CountText5", 1900)
    end
end

function CountText5()

    if QuakeSwitch == 0 then
        SetData("CommentaryPanel.Comment", "Miss.count5")
        SendMessage("CommentaryPanel.ScriptText")
       
        StartTimer("CountText4", 1900)
    end
end

function CountText4()

    if QuakeSwitch == 0 then
        SetData("CommentaryPanel.Comment", "Miss.count4")
        SendMessage("CommentaryPanel.ScriptText")
        
        StartTimer("CountText3", 1900)
    end
end

function CountText3()

    if QuakeSwitch == 0 then
        SetData("CommentaryPanel.Comment", "Miss.count3")
        SendMessage("CommentaryPanel.ScriptText")
        
        StartTimer("CountText2", 1900)
    end
end

function CountText2()

    if QuakeSwitch == 0 then
        SetData("CommentaryPanel.Comment", "Miss.count2")
        SendMessage("CommentaryPanel.ScriptText")
       
        StartTimer("CountText1", 1900)
    end
end

function CountText1()

    if QuakeSwitch == 0 then
        SetData("CommentaryPanel.Comment", "Miss.count1")
        SendMessage("CommentaryPanel.ScriptText")
        
        StartTimer("StartEarthquake", 1900)
    end
end

function FLARE()
    SetData("CommentaryPanel.Comment", "Miss.Plaice.ThisIsland")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")
    
    
    
    SetData("Crate.Spawn", "SecretCrate")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityLowGravity")
    SetData("Crate.Index", 666)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
--    SetData("Crate.DisableMessage", 1)
    SetData("Crate.Spawn", "SecretCrate2")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityLowGravity")
    SetData("Crate.Index", 667)
    SetData("Crate.GroundSnap", 1)
 --   SetData("Crate.DisableMessage", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SendMessage("Earthquake.End")
    
    SetData("Particle.DetailObject", "sparkle5")
    SetData("Particle.Name", "Part_StarBridge")
    SendMessage("Particle.NewEmitter")
    PID5 = GetData("Particle.Handle")
    
    SetData("Crate.Spawn", "FlareCrate")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.DisableMessage", 1)
    SetData("Crate.Contents", "kUtilityLowGravity")
    SetData("Crate.Index", 999)
    SetData("Crate.GroundSnap", 0)
    SendMessage("GameLogic.CreateCrate")
end


--USED AT THE END OF THE MISSION
function FlareCam()
  --  Pause()
    SendMessage("EFMV.Start")
    SendMessage("GameLogic.PauseGame")
    SetData("GameLogic.ArtilleryMode", 1)
    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("Particle.DetailObject", "Fireworks1")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")
    PID6 = GetData("Particle.Handle")
    
    
    StartTimer("SignalFlare1Repeat", 2000)
        
    SetData("Camera.Path.Knots.Position", "FlarePos1,FlarePos2")
    SetData("Camera.Path.Knots.LookAt", "FlareLook1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",950)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 

    SendMessage("Camera.Path.Start")
    StartTimer("EndSuccess", 6000)

end

function SignalFlareRepeat()

    SendIntMessage("Particle.DeleteEmitter", PID6)

    SetData("Particle.DetailObject", "Fireworks1")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")

end
    

function Camera_Path_Reached_Knot()

    knot = GetData("Camera.Path.Knot")
   
    if knot == "Pos2" then
        camera2()
    end
    
    if knot == "Pos4" then
        camera3()
    end
       
    if knot == "Pos7" then
        CameraText()
    end
    
    if knot == "Pos8" then
        camera4()
    end
    
    if knot == "Pos11" then
        GOGOGO()
    end
    
    if knot == "CrateCamPos3" then
        SetData("Camera.Path.IgnoreInput", 0)
        SendMessage("EFMV.End")
        StartTurn()
    end
    
    if knot == "SharkPos2" then
        SetData("CommentaryPanel.Comment", "Miss.Plaice.Cant")
        SetData("CommentaryPanel.Delay",3000)
        SendMessage("CommentaryPanel.TimedText")

    end
    
    if knot == "SharkPos3" then
        SendMessage("Camera.SetDefault")
        SetData("Camera.Path.IgnoreInput", 0)
        SendMessage("EFMV.End")
        StartTurn()
    end
    
    if knot == "LightPos3" then
        lock, inventory = EditContainer("Inventory.Alliance00")         
        inventory.Jetpack = 0    
        CloseContainer(lock) -- must close the container ASAP
        SendMessage("Weapon.Delete")
        SendMessage("Camera.SetDefault")
        
        SetData("Camera.Path.IgnoreInput", 0)
        SendMessage("EFMV.End")
        StartTurn()
        ActivateTurn = 1
    end
    
end


function Animm()
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Bored1")
    SendIntMessage("Worm.QueueAnim", 1)
end


function Camera_Path_Stopped()

    if CameraFly == 1 then
        CameraFly = 0
        if TimerControl == 1 then
            TimerControl = 0
        end
        SendMessage("EFMV.End")
        StartFirstTurn()
    end
end

--////////////////////////////////////////////////////////////////////////
--//                    Turn Logic                                      //
--////////////////////////////////////////////////////////////////////////

function StartFirstTurn()
    SendMessage("EFMV.End")
   -- StartTimer("FIRST", 3500)
    WaitUntilNoActivity = false
    SendMessage("Timer.StartGame")
    ResetCamera()
    StartTurn()
    SetData("CommentaryPanel.Comment", "Miss.Plaice.Find")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Delay",2500)
end

--This camera simply does not work, it pulls the user out of their stride and adds nothing (apart from bugs)



function CarryOn()
    SetData("GameLogic.ArtilleryMode", 0)
    SendMessage("GameLogic.ResumeGame")
    SendMessage("EFMV.End")
    StartTurn()
end


--The earthquake.
function Shabba()
    SendMessage("Earthquake.End")
    CamLoop = StartTimer("PlayerCheck", 2000)
   -- NewCrate = 7
  --  MakeNewCrate() 
end


function GOGOGO()
    CameraFly = 0
    StartFirstTurn()
end




--////////////////////////////////////////////////////////////////
--//            Check for worm died                             //
--////////////////////////////////////////////////////////////////

--The functions below allow the damage to be taken from the enemy during a turn.

--function Weapon_Fired_Start()
   -- Called when powering up finishes or fire button presses
--    SendMessage("Timer.EndTurn") 
--    SendMessage("Weapon.DisableWeaponChange")
--end

--function Weapon_Fired_End()
--    SendMessage("Weapon.Delete")
--    TurnEnded()
--end


function CheckOneTeamVictory()

   SendMessage("WormManager.GetActiveTeamCount")
   TeamCount = GetData("TeamCount")
   
    if TeamCount == 1 then
        SendMessage("WormManager.GetSurvivingTeam")
        TeamLeft = GetData("SurvivingTeamIndex")
        
        if TeamLeft == 1 then
            if Switch == 0 then
                RespawnWeapon = 0
                -- all the teams have just snuffed it
                SendMessage("Commentary.Clear") 
                SetData("CommentaryPanel.Comment", "Miss.Plaice.Failure")
                SendMessage("CommentaryPanel.ScriptText")             
                SendMessage("Earthquake.End")
                SendMessage("GameLogic.Mission.Failure")
                Switch = 1
            end
        end
        ----NEEDS RETURNING TO ZERO,.
        if TeamLeft == 0 then
            if PlayerCheck1 == 0 then
                SetData("Particle.DetailObject", "sparkle1")
                SetData("Particle.Name", "Part_StarBridge")
                SendMessage("Particle.NewEmitter")
                PID1 = GetData("Particle.Handle")
        
                SetData("Crate.Spawn", "CrateSpawn2")
                SetData("Crate.Type", "Utility")
                SetData("Crate.NumContents", -1)
                SetData("Crate.Contents", "kUtilityJetpack")
                SetData("Crate.Index", 2)
                SendMessage("GameLogic.CreateCrate")
                PlayerCheck1 = 1 -- make sure this block can't be switched on again.
                CrateCam()
            elseif ActivateTurn == 1 then
                StartTurn()
            end
        end 
    elseif TeamCount == 2 then
            -- still at least 2 teams left
            Missed()
            
    elseif TeamCount == 0 then
        if Switch == 0 then
            -- all the teams have just snuffed it
            QuakeSwitch = 1

            SendMessage("Commentary.Clear") 
            SetData("CommentaryPanel.Comment", "Miss.Plaice.Failure")
            SendMessage("CommentaryPanel.ScriptText") 
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end
end


--function Worm_Died()

--   deadWorm = GetData("DeadWorm.Id")

--    if deadWorm == 1 then 
    
--        SetData("Particle.DetailObject", "sparkle1")
--        SetData("Particle.Name", "Part_StarBridge")
--        SendMessage("Particle.NewEmitter")
--        PID1 = GetData("Particle.Handle")
    
--        SetData("Crate.Spawn", "CrateSpawn2")
--       SetData("Crate.Type", "Utility")
--        SetData("Crate.NumContents", -1)
--        SetData("Crate.Contents", "kUtilityJetpack")
--        SetData("Crate.Index", 2)
--        SendMessage("GameLogic.CreateCrate")
--        CamSwitch = 1
--    end
    

--        SendMessage("WormManager.GetActiveTeamCount")
--        TeamCount = GetData("TeamCount")
    
--       SendMessage("WormManager.GetSurvivingTeam")
--        WhichTeam = GetData("SurvivingTeamIndex")

--    if TeamCount == 0 then
--        SendMessage("Commentary.Clear") 
--        SetData("CommentaryPanel.Comment", "Miss.Plaice.Failure")
--        SendMessage("CommentaryPanel.ScriptText") 
--        SendMessage("GameLogic.Mission.Failure")
--        RespawnWeapon = 0

--    elseif TeamCount == 1 and WhichTeam == 1 then
--        SendMessage("Commentary.Clear") 
--        SetData("CommentaryPanel.Comment", "Miss.Plaice.Failure")
--        SendMessage("CommentaryPanel.ScriptText") 
--        SendMessage("GameLogic.Mission.Failure")
--        RespawnWeapon = 0
--    end
--end



function Pause()
  -- SendMessage("GameLogic.PauseGame")
end

function Resume()
 --  SendMessage("GameLogic.ResumeGame")
end


function Timer_GameTimedOut()
    if Switch == 0 then
        QuakeSwitch = 1
        SendMessage("Commentary.Clear")
        SetData("CommentaryPanel.Comment", "Miss.Plaice.Failure")
        SendMessage("CommentaryPanel.ScriptText")
        SendMessage("Earthquake.End")    
        SendMessage("GameLogic.Mission.Failure")
        Switch = 1
    end
end
 
function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Tour Guide"
    team.FlagGfxName = "59"
    team.IsAIControlled = true
    team.TeamColour = 25
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn1"
    worm.Energy = 1
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
   
    lock, worm = EditContainer("Worm.Data01") 
    worm.Active = true
    worm.Name = "Quint"
    worm.IsAllowedToTakeTurn = false
    worm.SfxBankName = "Whoopsie"
    worm.Spawn = "spawn2"
    worm.Energy = 50
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    CloseContainer(lock) 

    SendMessage("WormManager.Reinitialise")
end


function SetupInventories()
   lock, inventory = EditContainer("Inventory.Team00") 
  -- inventory.Bazooka = -1
  -- inventory.Shotgun = -1
   CloseContainer(lock) 
   
   lock, inventory = EditContainer("Inventory.Team01") 
   CloseContainer(lock) 
end


function ResetCamera()
   SendMessage("Camera.SetDefault")
end


--function TurnEnded()
--    CheckOneTeamVictory()
--end


function EndSuccess()
    SuccessMessages()
    SendMessage("EFMV.End")
    Result()
end

--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()

    SetData("Camera.Path.IgnoreInput", 1)
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
 
        Key,Lock = EditContainer("L.C.SS2")
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName3","L.C.SS2")
        end     
        CloseContainer(Key)
 
        if timetook < silvertime then
            Movie = 2

            if timetook < goldtime then
                Movie = 3
                
                Key,Lock = EditContainer("L.P.Chatter")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName2","L.P.Chatter")
                end
                CloseContainer(Key)
                
                Key,Lock = EditContainer("L.L.Plaice")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Plaice")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

--/////////////////////////////////////////////////////////////////
--/////////////////////////////////////////////////////////////////

function SuccessMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end

end
