
   -- Mission TARGET HUNT II (Shotgun)

function Initialise()

    SendMessage("Commentary.NoDefault")
    
    NewCrate = 1
    turn = 0
    MyRandomNumber = 0
    TimeOut = 0 
    Time = 6000
    counter = 0
    SunkMessage = 99
    
    SendMessage("HUD.HideTurnTime")
    SendMessage("EFMV.Start")
    -- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
   
    SendMessage("GameLogic.PlaceObjects")
    StartTimer("bombs", 1000)

    SetData("HotSeatTime", 0) -- no hotseat time
    SetData("RoundTime", 60000) 
    SetData("TurnTime", 0) 
    
    CameraFly = 0
    
    SetData("GameLogic.ArtilleryMode", 1)
    SetData("Camera.GameOverCamera","Orbit")
    SetData("Camera.StartOfTurnCamera","Default")
    SendStringMessage("Camera.Disable", "Blimp")
    SendStringMessage("Camera.Disable", "Track")
    SetData("Land.Indestructable", 1)
    SetupWormsAndTeams()
    SetupInventories()
    StartGrantCam()
    bubbleend()
    flak()
    
end

function flak()

    SetData("Particle.DetailObject", "Flak4")
    SetData("Particle.Name", "Part_Flak")
    SendMessage("Particle.NewEmitter")
end


-- does the water spashes for shells
function bubbles()

-- if the random number is 1 then this particle appears
	if MyRandomNumber == 1 then
	SetData("Particle.DetailObject", "dchargea")
	SetData("Particle.Name", "Part_Depthcharge")
	SendMessage("Particle.NewEmitter")
        --below sets this particle emitter to have id1
	id1 = GetData("Particle.Handle")
		
	elseif MyRandomNumber == 2 then
	SetData("Particle.DetailObject", "dchargeb")
	SetData("Particle.Name", "Part_Depthcharge")
	SendMessage("Particle.NewEmitter")
	id2 = GetData("Particle.Handle")
		
	elseif MyRandomNumber == 3 then
	SetData("Particle.DetailObject", "dchargec")
	SetData("Particle.Name", "Part_Depthcharge")
	SendMessage("Particle.NewEmitter")
	id3 = GetData("Particle.Handle")
		
	elseif MyRandomNumber == 4 then
	SetData("Particle.DetailObject", "dcharged")
	SetData("Particle.Name", "Part_Depthcharge")
	SendMessage("Particle.NewEmitter")
	id4 = GetData("Particle.Handle")
        
        
        elseif MyRandomNumber == 5 then
	SetData("Particle.DetailObject", "dchargee")
	SetData("Particle.Name", "Part_Depthcharge")
	SendMessage("Particle.NewEmitter")
	id5 = GetData("Particle.Handle")
		
	elseif MyRandomNumber == 6 then
	SetData("Particle.DetailObject", "dchargef")
	SetData("Particle.Name", "Part_Depthcharge")
	SendMessage("Particle.NewEmitter")
	id6 = GetData("Particle.Handle")
		
	elseif MyRandomNumber == 7 then
	SetData("Particle.DetailObject", "dchargeg")
	SetData("Particle.Name", "Part_Depthcharge")
	SendMessage("Particle.NewEmitter")
	id7 = GetData("Particle.Handle")
	
	elseif MyRandomNumber == 8 then
	SetData("Particle.DetailObject", "dchargeh")
	SetData("Particle.Name", "Part_Depthcharge")
	SendMessage("Particle.NewEmitter")
	id8 = GetData("Particle.Handle")
		
	elseif MyRandomNumber == 9 then
	SetData("Particle.DetailObject", "dchargei")
	SetData("Particle.Name", "Part_Depthcharge")
	SendMessage("Particle.NewEmitter")
	id9 = GetData("Particle.Handle")
	
	end
        
        
    -- waits 6 secs before picking another particle (in function bubbleend)	
    StartTimer("bubbleend", 6500)	
	
end	


function bubbleend()
    -- makes up a random number between 1 and 4
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 8) + 1

    -- executes the bubbles function
    bubbles()
end


function Weapon_PoweringUpStart()
end

function Weapon_Fired_Start()
end

function Weapon_Fired_End()
end

function StartFirstTurn()
    WaitUntilNoActivity = false
    SendMessage("EFMV.End")	
    SendMessage("Timer.StartGame")
    StartTurn()
end

function Worm_Died()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Chall.Generic.Lose1")
    SendMessage("CommentaryPanel.ScriptText")
end


function Timer_GameTimedOut()
    TimeOut = 1
    
    SendMessage("Weapon.Delete")
    SendMessage("Weapon.DisableWeaponChange")
    EndTurn()
    
    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
    SendMessage("CommentaryPanel.ScriptText")
    
end
    
function TurnEnded()

    if TimeOut == 0 then
        SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Camera.Path.IgnoreInput", 1)
        
        Result()
    else
        Result()
    end
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////

function Result()  
    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
    timetook = GetData("ElapsedRoundTime")
    goldtime = GetData("MCa.BestGold")
    silvertime = GetData("MCa.BestSilver")
    bronzetime = GetData("MCa.BestBronze")
     
    if timetook > bronzetime then
        Movie = 1
        if timetook > silvertime then
            Movie = 2
            if timetook > goldtime then
                Movie = 3
            end
        end
    end

    if Movie == 1 then
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Challenge.Result")
end



function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
   team.TeamColour = 0
   CloseContainer(lock) -- must close the container ASAP

-- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
   worm.Spawn = "wspawn1"
   worm.Energy = 1
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 
   SendMessage("WormManager.Reinitialise")

end

function Crate_Sunk()
    SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
    SendMessage("CommentaryPanel.ScriptText")
    SunkMessage = 1
    MakeNewCrate()
end

function Crate_Destroyed()

    if SunkMessage == 0 then
        MakeNewCrate()
    end
end



function MakeNewCrate()
    if SunkMessage == 0 then
        SetData("CommentaryPanel.Comment", "Chall.Assault1.game1")
        SendMessage("CommentaryPanel.ScriptText")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining + Time)
    else
        SunkMessage = 0
    end
    
    if NewCrate == 1 then
    	SetData("Crate.Spawn", "target2")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 1)
        SetData("Crate.TeamCollectable", 2)		
	SetData("Crate.NumContents", 0)
	SetData("Crate.CanDropFromChute", 0)
	SetData("Crate.WaitTillLanded", 0)
	SetData("Crate.Scale", 3)
	SendMessage("GameLogic.CreateCrate")
        SunkMessage = 0
    elseif NewCrate == 2 then
	SetData("Crate.Spawn", "target1")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 2)
	SetData("Crate.NumContents", 0)
	SetData("Crate.CanDropFromChute", 0)
	SetData("Crate.WaitTillLanded", 0)
	SetData("Crate.Scale", 3)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 3 then
     	SetData("Crate.Spawn", "target3")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 3)
	SetData("Crate.NumContents", 0)
	SetData("Crate.CanDropFromChute", 0)
	SetData("Crate.WaitTillLanded", 0)
	SetData("Crate.Scale", 3)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 4 then
	SetData("Crate.Spawn", "target4")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 4)
	SetData("Crate.NumContents", 0)
	SetData("Crate.CanDropFromChute", 0)
	SetData("Crate.WaitTillLanded", 0)
	SetData("Crate.Scale", 3)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 5 then
     	SetData("Crate.Spawn", "target5")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 5)
	SetData("Crate.NumContents", 0)
	SetData("Crate.CanDropFromChute", 0)
	SetData("Crate.WaitTillLanded", 0)
	SetData("Crate.Scale", 3)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 6 then
     	SetData("Crate.Spawn", "target6")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 6)
	SetData("Crate.NumContents", 0)
	SetData("Crate.CanDropFromChute", 0)
	SetData("Crate.WaitTillLanded", 0)
	SetData("Crate.Scale", 3)
	SendMessage("GameLogic.CreateCrate")
	SetData("CommentaryPanel.Comment", "Chall.Assault1.game1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif NewCrate == 7 then
     	SetData("Crate.Spawn", "target7")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 7)
	SetData("Crate.NumContents", 0)
	SetData("Crate.CanDropFromChute", 0)
	SetData("Crate.WaitTillLanded", 0)
	SetData("Crate.Scale", 3)
	SendMessage("GameLogic.CreateCrate")
	SetData("CommentaryPanel.Comment", "Chall.Assault1.game1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif NewCrate == 8 then
     	SetData("Crate.Spawn", "target8")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 8)
	SetData("Crate.NumContents", 0)
	SetData("Crate.CanDropFromChute", 0)
	SetData("Crate.WaitTillLanded", 0)
	SetData("Crate.Scale", 3)
	SendMessage("GameLogic.CreateCrate")
        SetData("CommentaryPanel.Comment", "Chall.Homing.WellDone")
        SendMessage("CommentaryPanel.ScriptText")

        if Time > 1000 then
            Time = Time - 1000
        end
        
        NewCrate = 0
        MakeNewCrate()
    end
    
    NewCrate = NewCrate + 1
end

function SetupInventories()
   -- sets up a default container and adds our selection to it
   lock, inventory = EditContainer("Inventory.Team.Default") 
   inventory.Shotgun = -1
   CloseContainer(lock) -- must close the container ASAP

   -- Copies this selection into each worm

   CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   CopyContainer("Inventory.Team.Default", "Inventory.Team01")


   lock, delays = EditContainer("Inventory.WeaponDelays") 
   CloseContainer(lock)

end

function StartGrantCam()
    CameraFly = 1
    StartTimer("Anim1", 4000)
    SetData("CommentaryPanel.Comment", "Chall.Shotgun1.Intro1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2")
    SetData("Camera.Path.Knots.LookAt", "Look1,Look2")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.2)
    SetData("Camera.Path.Steps.Position",450)  
    SetData("Camera.Path.Steps.LookAt",450)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera2", 5500)
    
end


function camera2()
    SetData("CommentaryPanel.Comment", "Chall.Shotgun1.Intro2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Pos3")
    SetData("Camera.Path.Knots.LookAt", "Look3,Look4,Look5")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.2)
    SetData("Camera.Path.Steps.Position",550)  
    SetData("Camera.Path.Steps.LookAt",300)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("startt", 7000)
end

function Anim1()
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Wave_Left")
    SendIntMessage("Worm.QueueAnim", 0)
end

function camera3()
    SetData("CommentaryPanel.Comment", "Chall.Shotgun1.Intro3")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("Anim1", 5000)
    SetData("Camera.Path.Knots.Position", "Pos5,Pos6")
    SetData("Camera.Path.Knots.LookAt", "Look4,Look5")
    SetData("Camera.Path.Loop.LookAt", 1) 
    SetData("Camera.Path.Tension.Position", -0.2)
    SetData("Camera.Path.Steps.Position",600)  
    SetData("Camera.Path.Steps.LookAt",850)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("startt", 4000)
end

function checkteam()
-- PC: the current team value is now called CurrentTeamIndex
    Team = GetData("CurrentTeamIndex")
    if Team == 0 then
        stopteam()
    end
end
    
function stopteam()
   --SendStringMessage("Input.DisableGroup", "WormMoving")
    SetData("GameLogic.ArtilleryMode", 1)
end


function startt()
SendMessage("EFMV.End")
camdone =  1

	StartFirstTurn()
	MakeNewCrate()
end


function Camera_Path_Stopped()

    if CameraFly == 1 then
        CameraFly = 0
	MakeNewCrate()
        CancelTimer(CamLoop)
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        SendMessage("EFMV.End")
        StartFirstTurn()
    end
end


function bombs()
	SetData("Particle.DetailObject", "littleboy1")
	SetData("Particle.Name", "Part_Littleboy")
	SendMessage("Particle.NewEmitter")
        lb1 = GetData("Particle.Handle")

	SetData("Particle.DetailObject", "littleboy2")
	SetData("Particle.Name", "Part_Littleboy")
	SendMessage("Particle.NewEmitter")
        lb2 = GetData("Particle.Handle")
end

