
-- Mission Tutorial1

function Initialise()


	-- sets NewCrate to 1
	NewCrate = 1

	-- Create particle variable
	Lava = 0
	Lava2 = -1



-- Sets up mines and turn time
   SetData("Mine.DudProbabilty", 0.1)
   SetData("Mine.MinFuse", 1000)
   SetData("Mine.MaxFuse", 5000)
   SetData("TurnTime", 60000)
   SetData("RoundTime", 1800000)

   Turn = 0

   SendMessage("GameLogic.PlaceObjects")
   SendMessage("GameLogic.ChangeWind")

-- below drops the first crate by executing Make NewCrate function As New crate equals 1 it will drop the first one
   MakeNewCrate()

   SetupWormsAndTeams()
   SetupInventories()
   StartFirstTurn()



	SendMessage("Particle.StartEvent")


end


-- //////////////////////////////////////////////////////////////////

function SetupWormsAndTeams()

   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
   team.Name = "Allies"
   team.TeamColour = 0
   CloseContainer(lock) -- must close the container ASAP

   -- Activate Team 1
   lock, team = EditContainer("Team.Data01") 
   team.Active = true
   team.Name = "Axis"
   team.TeamColour = 1
   CloseContainer(lock)

   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
   worm.Name = "Riley"
   worm.Energy = 100
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 

   -- Worm 1, Team 0
   CopyContainer("Worm.Data00", "Worm.Data01")
   lock, worm = EditContainer("Worm.Data01") 
   worm.Name = "Sarge"
   CloseContainer(lock)

   -- Worm 2, Team 0
   CopyContainer("Worm.Data00", "Worm.Data02")
   lock, worm = EditContainer("Worm.Data02") 
   worm.Name = "Ryan"
   CloseContainer(lock)

   -- Worm 3, Team 0
   CopyContainer("Worm.Data00", "Worm.Data03")
   lock, worm = EditContainer("Worm.Data03") 
   worm.Name = "Frost"
   CloseContainer(lock)

   -- Worm 4, Team 1
   CopyContainer("Worm.Data00", "Worm.Data04")
   lock, worm = EditContainer("Worm.Data04")
   worm.Energy = 80 
   worm.Name = "Fritz"
   worm.TeamIndex = 1
   CloseContainer(lock)

   -- Worm 5, Team 1
   CopyContainer("Worm.Data04", "Worm.Data05")
   lock, worm = EditContainer("Worm.Data05")
   worm.Energy = 80  
   worm.Name = "Heinz"
   CloseContainer(lock)

   -- Worm 6, Team 1
   CopyContainer("Worm.Data04", "Worm.Data06")
   lock, worm = EditContainer("Worm.Data06")
   worm.Energy = 80  
   worm.Name = "Scutze"
   CloseContainer(lock)

   -- Worm 7, Team 1
   CopyContainer("Worm.Data04", "Worm.Data07")
   lock, worm = EditContainer("Worm.Data07")
   worm.Energy = 80  
   worm.Name = "Whittman"
   CloseContainer(lock)

   SendMessage("WormManager.Reinitialise")

end


-- //////////////////////////////////////////////////////////////////

function SetupInventories()
   -- sets up a default container and adds our selection to it
   lock, inventory = EditContainer("Inventory.Team.Default") 
   inventory.Bazooka = 0
   CloseContainer(lock) -- must close the container ASAP

end

-- ///////////////////////////////////////////////////////////////////

-- Executes MakeNewCrate when these 2 functions happen
function Crate_Collected()
    MakeNewCrate()
end

-- ///////////////////////////////////////////////////////////////////

function Crate_Destroyed()
    MakeNewCrate()
end

-- ///////////////////////////////////////////////////////////////////

-- When MakeNewCrate is called It runs through this below and adds 1 each time so it knows which crate it is on
function MakeNewCrate()


    if NewCrate == 1 then
	SetData("Crate.Spawn", "crate1")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 1)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 2 then
	SetData("Crate.Spawn", "crate2")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 3 then
	SetData("Crate.Spawn", "crate3")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 3)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 4 then
	SetData("Crate.Spawn", "crate4")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 4)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 5 then
	SetData("Crate.Spawn", "crate5")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 5)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 6 then
	SetData("Crate.Spawn", "crate6")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 6)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 7 then
	SetData("Crate.Spawn", "crate7")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 7)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 8 then
	SetData("Crate.Spawn", "crate8")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 8)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 9 then
	SetData("Crate.Spawn", "crate9")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 9)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 10 then
	SetData("Crate.Spawn", "crate10")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 10)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 11 then
	SetData("Crate.Spawn", "crate11")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 11)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 12 then
	SetData("Crate.Spawn", "crate12")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 12)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 13 then
	SetData("Crate.Spawn", "crate13")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 13)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 14 then
	SetData("Crate.Spawn", "crate14")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
	SetData("Crate.Index", 14)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 15 then
	SetData("Crate.Spawn", "crate15")
	SetData("Crate.Type", "Weapon")
	SetData("Crate.NumContents", 99)
	SetData("Crate.Contents", "kWeaponBazooka")
	SetData("Crate.Index", 15)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 16 then
	SetData("Crate.Spawn", "target1")
	SetData("Crate.Type", "Target")
	SetData("Crate.Index", 16)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 17 then
	SetData("Crate.Spawn", "target2")
	SetData("Crate.Type", "Target")
	SetData("Crate.Index", 17)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 18 then
	SetData("Crate.Spawn", "target3")
	SetData("Crate.Type", "Target")
	SetData("Crate.Index", 18)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 19 then
	SetData("Crate.Spawn", "target4")
	SetData("Crate.Type", "Target")
	SetData("Crate.Index", 19)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 20 then
	SetData("Crate.Spawn", "target5")
	SetData("Crate.Type", "Target")
	SetData("Crate.Index", 20)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 21 then
	SetData("Crate.Spawn", "target6")
	SetData("Crate.Type", "Target")
	SetData("Crate.Index", 21)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 22 then
	SetData("Crate.Spawn", "target7")
	SetData("Crate.Type", "Target")
	SetData("Crate.Index", 22)
	SendMessage("GameLogic.CreateCrate")
  

     elseif NewCrate == 23 then
        SendMessage("GameLogic.EndGame")
     end


     NewCrate = NewCrate + 1
end

-- //////////////////////////////////////////////////////////////////////


-- This function creates the particle emitter
function Particle_StartEvent()	

	if Lava == 0 then
		-- Set the name of the detail object the particle emitter is attached to.
		-- This is the same as the name in the editor
		SetData("Particle.DetailObject", "lava1")
	
		-- Set the name of the particle effect to use
		SetData("Particle.Name","ParticleFire")
	
		-- Send a message to the game to create the particle emitter
		SendMessage("Particle.NewEmitter")
	
		-- Get the handle of the particle emitter just created. Each emitter created 
		-- has a unique handle reference which should be shored for later 
		-- reference - eg when you want to kill the emitter
		id = GetData("Particle.Handle")
	
	elseif Lava == 1 then
		SetData("Particle.DetailObject", "lava2")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")		

	elseif Lava == 2 then
		SetData("Particle.DetailObject", "lava3")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 3 then
		SetData("Particle.DetailObject", "lava4")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 4 then
		SetData("Particle.DetailObject", "lava5")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 5 then
		SetData("Particle.DetailObject", "lava6")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 6 then
		SetData("Particle.DetailObject", "lava7")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 7 then
		SetData("Particle.DetailObject", "lava8")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 8 then
		SetData("Particle.DetailObject", "lava9")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 9 then
		SetData("Particle.DetailObject", "lava10")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 10 then
		SetData("Particle.DetailObject", "lava11")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 11 then
		SetData("Particle.DetailObject", "lava12")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 12 then
		SetData("Particle.DetailObject", "lava13")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 13 then
		SetData("Particle.DetailObject", "lava14")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 14 then
		SetData("Particle.DetailObject", "lava15")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 15 then
		SetData("Particle.DetailObject", "lava16")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 16 then
		SetData("Particle.DetailObject", "lava17")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 17 then
		SetData("Particle.DetailObject", "lava18")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 18 then
		SetData("Particle.DetailObject", "lava19")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 19 then
		SetData("Particle.DetailObject", "lava20")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 20 then
		SetData("Particle.DetailObject", "lava21")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava == 21 then
		SetData("Particle.DetailObject", "lava22")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")
	end

		-- /////////////////////////////////

	if Lava2 == 0 then
		SetData("Particle.DetailObject", "lava1")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")
	
	elseif Lava2 == 1 then
		SetData("Particle.DetailObject", "lava2")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")		

	elseif Lava2 == 2 then
		SetData("Particle.DetailObject", "lava3")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 3 then
		SetData("Particle.DetailObject", "lava4")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 4 then
		SetData("Particle.DetailObject", "lava5")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 5 then
		SetData("Particle.DetailObject", "lava6")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 6 then
		SetData("Particle.DetailObject", "lava7")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 7 then
		SetData("Particle.DetailObject", "lava8")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 8 then
		SetData("Particle.DetailObject", "lava9")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 9 then
		SetData("Particle.DetailObject", "lava10")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 10 then
		SetData("Particle.DetailObject", "lava11")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 11 then
		SetData("Particle.DetailObject", "lava12")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 12 then
		SetData("Particle.DetailObject", "lava13")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 13 then
		SetData("Particle.DetailObject", "lava14")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 14 then
		SetData("Particle.DetailObject", "lava15")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 15 then
		SetData("Particle.DetailObject", "lava16")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 16 then
		SetData("Particle.DetailObject", "lava17")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 17 then
		SetData("Particle.DetailObject", "lava18")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 18 then
		SetData("Particle.DetailObject", "lava19")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 19 then
		SetData("Particle.DetailObject", "lava20")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 20 then
		SetData("Particle.DetailObject", "lava21")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")

	elseif Lava2 == 21 then
		SetData("Particle.DetailObject", "lava22")
		SetData("Particle.Name","ParticleFire")
		SendMessage("Particle.NewEmitter")
		id = GetData("Particle.Handle")
	end
	

	Lava = Lava + 1
	Lava2 = Lava2 + 1
	

	-- Call the Particle_EndEvent in x seconds time
	TimerID2 = StartTimer("Particle.EndEvent", 750)
	

end




-- ////////////////////////////////////////////////////////////////////////////////////

-- This function destroys the particle emitter
function Particle_EndEvent()

	-- Send a message to the game to destroy the emitter, passing the handle
	-- that was returned when the emitter was created
	SendIntMessage("Particle.DeleteEmitter",id)

	if Lava2 > 0 then
		SendIntMessage("Particle.DeleteEmitter",id)
	end	

	if Lava == 22 then
		Lava = 0
	end

	if Lava2 == 22 then
		Lava2 = 0
	end

	TimerID1 = StartTimer("Particle.StartEvent", 50)

end














