
-- Counting Sheep: The player needs to send the restless Colonel to sleep!
-- ! Particles of some kind of cloud sheen effect need adding to cloud models (when they become cloud models).
-- ! Game needs playtesting.
-- ! Game needs time out anim!!

function Initialise()
    bronzetime = (60 * 1000) * 999
    silvertime = 255000
    goldtime = (60 * 1000) * 4
    SendMessage("EFMV.Start")
    SetData("Mine.DudProbabilty", 0.0)
    SetData("Mine.MinFuse", 3000)
    SetData("Mine.MaxFuse", 3000)
    SendMessage("GameLogic.PlaceObjects")
    SendMessage("Commentary.NoDefault")
--    SetData("HUD.Clock.DisplayRoundTime", 0)
    
    SetData("Land.Indestructable", 1)
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")
    SetData("DefaultRetreatTime", 0)
    SetData("RoundTime", 600000)
    SetData("TurnTime", 40000)
    SetData("HotSeatTime", 5000)
    
    SetData("Particle.DetailObject", "Part_Bee")
    SetData("Particle.Name", "Part_Bumblebee")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Part_Bee2")
    SetData("Particle.Name", "Part_Bumblebee")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Part_Bee3")
    SetData("Particle.Name", "Part_Bumblebee")
    SendMessage("Particle.NewEmitter")
    
    ChimneySmoke()
    
    SleepState = 0
    TriggerState = 0
    TurnState = 0
    TurnState2 = 0
    MyCratePosition = 1
    CrateOnLand = 1
    CameraFly = 1
    deadworms = 0
    WakingUp = 0
    FirstTime = 0
    NotQuite = 0
    TextControl = 0
    deadhat = 0
    TimedOut = 0
    GlobalCondition = 0
    Switch = 0
    
    CreateTriggers()
    SpawnFirstCrate()
    
    SelectRandomWind()
    SetupWormsAndTeams()
    SetupInventories()
    FirstCam()
end

function ChimneySmoke()
    SetData("Particle.DetailObject", "ChimneySmoke")
    SetData("Particle.Name", "ParticleSmokePlume")
    SendMessage("Particle.NewEmitter")
    
    StartTimer("ChimneySmoke", 20000)
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        SendMessage("Commentary.Clear")
        SendMessage("EFMV.End")
        CameraFly = 0
        CancelTimer(CamLoop)
        StartFirstTurn()
    end
end

function FirstCam()
    SetData("Camera.Path.Knots.Position", "FirstCam,FirstCam2")
    SetData("Camera.Path.Knots.LookAt", "FirstLook")
    SetData("Camera.Path.Steps.Position",800)
    SetData("Camera.Path.Steps.LookAt",800) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("SecondCam", 4000)
end

function SecondCam()
    SetData("Camera.Path.Knots.Position", "SecondCam,SecondCam2")
    SetData("Camera.Path.Knots.LookAt", "SecondLook,SecondLook2")
    SetData("Camera.Path.Steps.Position",800)
    SetData("Camera.Path.Steps.LookAt",800) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("NewCam", 4000)
end

function NewCam()
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.game1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "NewCam")
    SetData("Camera.Path.Knots.LookAt", "NewLook")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line2", 2000)
    
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Salute")
    SendIntMessage("Worm.QueueAnim", 0)
end

function Line1()
    SetData("Camera.Path.Knots.Position", "Line1Cam,Line1Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line1Look")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line2", 3000)
end

function FunkySheep()
    SetData("GameLogic.WeaponName", "kWeaponSheep")
    SendMessage("GameLogic.RequestWeaponIndex")
    WIndex = GetData("GameLogic.WeaponIndex")

    lock, worm = EditContainer("Worm.Data00")
    worm.WeaponIndex = WIndex
    worm.LogicAnimState = 10
    CloseContainer(lock)
    SendIntMessage("Worm.ScriptDrawAnim", 0)
    SendMessage("Weapon.CreateGraphic")
    
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "DrawSheep")
    SendIntMessage("Worm.QueueAnim", 0)
end

function Line2()
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Dazed1")
    SendIntMessage("Worm.QueueAnim", 2)

    SetData("CommentaryPanel.Comment", "Miss.CountSheep.game2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line2Cam,Line2Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line2Look")
    SetData("Camera.Path.Steps.Position",450)
    SetData("Camera.Path.Steps.LookAt",450) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line3", 3500)
end

function Line3()
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Yawn")
    SendIntMessage("Worm.QueueAnim", 2)
    
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.game3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line3Cam")
    SetData("Camera.Path.Knots.LookAt", "Line3Look") 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("New2", 4000)
end

function New2()
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "NotMe6")
    SendIntMessage("Worm.QueueAnim", 0)
    
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.hint1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "New2Cam,New2Cam2")
    SetData("Camera.Path.Knots.LookAt", "New2Look")
    SetData("Camera.Path.Steps.Position",700)
    SetData("Camera.Path.Steps.LookAt",700) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("New3", 4000)
end

function New3()    
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.hint2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "New3Cam")
    SetData("Camera.Path.Knots.LookAt", "New3Look")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line6", 3000)
    StartTimer("QuestionMarks", 1700)
    StartTimer("New3Anim", 1300)
end

function New3Anim()
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "NotMe4")
    SendIntMessage("Worm.QueueAnim", 0)
end

function QuestionMarks()
    SetData("Particle.DetailObject", "PartQues1")
    SetData("Particle.Name", "Part_QuestionMark")
    SendMessage("Particle.NewEmitter")
end

function Line6()
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.game6")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line6Cam,Line6Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line6Look") 
    SetData("Camera.Path.Steps.Position",450)
    SetData("Camera.Path.Steps.LookAt",450) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line7", 3000)
end

function Line7()
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.game7")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line5Cam,Line5Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line5Look") 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line4", 3000)
end

function Line4()
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.game4")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line4Cam,Line4Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line4Look") 
    SetData("Camera.Path.Steps.Position",450)
    SetData("Camera.Path.Steps.LookAt",450) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line5", 3000)
end

function Line5()
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.game5")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line7Cam")
    SetData("Camera.Path.Knots.LookAt", "Line7Look") 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("CameraFinished", 3000)
    
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Yawn")
    SendIntMessage("Worm.QueueAnim", 2)
end

function CameraFinished()
    SendMessage("EFMV.End")
    CameraFly = 0
    StartFirstTurn()
end

function Crate_Collected()
    CrateOnLand = 0
    
    CrateIndex = GetData("Crate.Index")
    if CrateIndex == 101 then
        MyCratePosition = 2
    elseif CrateIndex == 102 then
        MyCratePosition = 3
    elseif CrateIndex == 103 then
        MyCratePosition = 4
    elseif CrateIndex == 104 then
        MyCratePosition = 1
    end
    
    if TextControl == 0 then
        SetData("CommentaryPanel.Comment", "Miss.CountSheep.hint3")
        SendMessage("CommentaryPanel.ScriptText")
        TextControl = 1
    end
end

function SpawnFirstCrate()
    CrateOnLand = 1

    SetData("Crate.Spawn", "Sheep1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.Index", 101)
    SetData("Crate.NumContents", 1)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Contents", "kWeaponSheep")
    SendMessage("GameLogic.CreateCrate")
end

function SpawnMyCrates()
    CrateOnLand = 1

    if MyCratePosition == 1 then
        SetData("Crate.Spawn", "Sheep1")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.Index", 101)
        SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 0)
        SetData("Crate.Contents", "kWeaponSheep")
        SendMessage("GameLogic.CreateCrate")
    elseif MyCratePosition == 2 then
        SetData("Crate.Spawn", "Sheep2")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.Index", 102)
        SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 0)
        SetData("Crate.Contents", "kWeaponSheep")
        SendMessage("GameLogic.CreateCrate")
    elseif MyCratePosition == 3 then
        SetData("Crate.Spawn", "Sheep3")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.Index", 103)
        SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 0)
        SetData("Crate.Contents", "kWeaponSheep")
        SendMessage("GameLogic.CreateCrate")
    elseif MyCratePosition == 4 then
        SetData("Crate.Spawn", "Sheep4")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.Index", 104)
        SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 0)
        SetData("Crate.Contents", "kWeaponSheep")
        SendMessage("GameLogic.CreateCrate")
    end
end

function CreateTriggers()
    SendIntMessage("GameLogic.DestroyTrigger", 1)
    SendIntMessage("GameLogic.DestroyTrigger", 2)
    SendIntMessage("GameLogic.DestroyTrigger", 3)
    SendIntMessage("GameLogic.DestroyTrigger", 4)

    SetData("Trigger.Spawn", "Jump1")
    SetData("Trigger.Radius", 25)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.SheepCollect",-1)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Jump1A")
    SetData("Trigger.Radius", 25)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.SheepCollect",-1)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Jump2")
    SetData("Trigger.Radius", 25)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.SheepCollect",-1)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Jump2A")
    SetData("Trigger.Radius", 25)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.SheepCollect",-1)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Jump3")
    SetData("Trigger.Radius", 25)
    SetData("Trigger.Index", 3)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.SheepCollect",-1)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Jump3A")
    SetData("Trigger.Radius", 25)
    SetData("Trigger.Index", 3)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.SheepCollect",-1)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Jump4")
    SetData("Trigger.Radius", 25)
    SetData("Trigger.Index", 4)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.SheepCollect",-1)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Jump4A")
    SetData("Trigger.Radius", 25)
    SetData("Trigger.Index", 4)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.SheepCollect",-1)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
end

function LookInvent()
    inventory = QueryContainer("Inventory.Alliance00")
    if inventory.Sheep < 1 and CrateOnLand == 0 then
        SendMessage("Commentary.Clear")
        SetData("CommentaryPanel.Comment", "Miss.CountSheep.game20")
        SendMessage("CommentaryPanel.ScriptText")
        SpawnMyCrates()
        StartTimer("StartTurn", 2500)
    else    
        StartTurn()
    end
end

function StartTurn()
    NotQuite = 0
    done_once_per_turn_functions = false
    SendMessage("Timer.StartHotSeatTimer")
    SendMessage("GameLogic.ActivateNextWorm")
    SendMessage("Weapon.Create")
    SetWind()
    TurnStarted()
    SendMessage("GameLogic.Turn.Started")
    RunAILogic()
end

function TurnEnded()
    CreateTriggers()
    TriggerState = 0
    
    if GlobalCondition == 0 then
        if TimedOut == 0 then
            if SleepState == 0 and NotQuite == 1 then
                NotQuite = 0
                NotQuiteAnimState()
            elseif SleepState == 0 then
                EndOfTurnAnimState0()
            elseif SleepState == 1 then
                TurnState2 = 0
                TurnState = TurnState + 1
                if TurnState == 1 then
                    EndOfTurnAnimState1()
                elseif TurnState == 2 then
                    SleepState = 0
                    TurnState = 0
                    WakeAnim()
                end
            elseif SleepState == 2 then
                TurnState = 0
                TurnState2 = TurnState2 + 1
                if TurnState2 == 1 then
                    EndOfTurnAnimState2() 
                elseif TurnState2 == 2 then
                    -- Worm is waking up slightly
                    WakingUp = 1
                    SleepState = 1
                    TurnState = 1
                    TurnState2 = 0
                    EndOfTurnAnimState1()
                end
            elseif SleepState == 3 then
                SleepAnim()
            end
        elseif TimedOut == 1 then
            if Switch == 0 then
                FailureMessages()
                SendMessage("GameLogic.Mission.Failure")
                Switch = 1
            end
        end
    end
end

function CheckOneTeamVictory()
    StartTurn()
end

function Trigger_SheepCollected()
    TriggerState = TriggerState + 1

    TriggerIndex = GetData("Trigger.Index")    
    if TriggerIndex == 1 then
        SendIntMessage("GameLogic.DestroyTrigger", 1)
        TextNumber()
    elseif TriggerIndex == 2 then
        SendIntMessage("GameLogic.DestroyTrigger", 2)
        TextNumber()
    elseif TriggerIndex == 3 then
        SendIntMessage("GameLogic.DestroyTrigger", 3)
        TextNumber()
    elseif TriggerIndex == 4 then
        SendIntMessage("GameLogic.DestroyTrigger", 4)
        TextNumber()
    end
end

function TextNumber()
    if TriggerState == 1 then
        SetData("CommentaryPanel.Comment", "Miss.CountSheep.game11")
        SendMessage("CommentaryPanel.ScriptText")
        NotQuite = 1
    elseif TriggerState == 2 then
        SetData("CommentaryPanel.Comment", "Miss.CountSheep.game12")
        SendMessage("CommentaryPanel.ScriptText")
        NotQuite = 1
    elseif TriggerState == 3 then
        SetData("CommentaryPanel.Comment", "Miss.CountSheep.game13")
        SendMessage("CommentaryPanel.ScriptText")
        NotQuite = 1
    elseif TriggerState == 4 then
        SetData("CommentaryPanel.Comment", "Miss.CountSheep.game14")
        SendMessage("CommentaryPanel.ScriptText")
        NotQuite = 0
        SleepState = SleepState + 1
    end
end

function MakeRandomNumber()
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 3) + 1
end
-- this means colonel is awake and bored
function EndOfTurnAnimState0()
    if deadhat == 0 then
    SendMessage("Commentary.Clear")
    SendMessage("EFMV.Start")

    MakeRandomNumber()
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.CountSheep.game8")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.CountSheep.game9")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.CountSheep.game10")
        SendMessage("CommentaryPanel.ScriptText")
    end
    
    MakeRandomNumber()
    if MyRandomNumber == 1 then
        SendIntMessage("Worm.ResetAnim", 2)
        SetData("Worm.ScriptAnim", "Bored1")
        SendIntMessage("Worm.QueueAnim", 2)
    elseif MyRandomNumber == 2 then
        SendIntMessage("Worm.ResetAnim", 2)
        SetData("Worm.ScriptAnim", "Bored1")
        SendIntMessage("Worm.QueueAnim", 2)
    elseif MyRandomNumber == 3 then
        SendIntMessage("Worm.ResetAnim", 2)
        SetData("Worm.ScriptAnim", "Bored1")
        SendIntMessage("Worm.QueueAnim", 2)
    end
        
    SetData("Camera.Path.Knots.Position", "SleepCam2,SleepCam")
    SetData("Camera.Path.Knots.LookAt", "SleepLook")
    SetData("Camera.Path.Steps.Position",800)
    SetData("Camera.Path.Steps.LookAt",800) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    StartTimer("LookInvent", 3000)
    StartTimer("CameraReset", 3000)
    
    end
end
-- this means sheep did not make it over all four hurdles but tells player they are on right track
function NotQuiteAnimState()
    if deadhat == 0 then
    SendMessage("Commentary.Clear")
    SendMessage("EFMV.Start")

    SetData("CommentaryPanel.Comment", "Miss.CountSheep.game23")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.game24")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.game25")
    SendMessage("CommentaryPanel.ScriptText")
    
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Yawn")
    SendIntMessage("Worm.QueueAnim", 2)
    
    SetData("Camera.Path.Knots.Position", "SleepCam2,SleepCam")
    SetData("Camera.Path.Knots.LookAt", "SleepLook")
    SetData("Camera.Path.Steps.Position",800)
    SetData("Camera.Path.Steps.LookAt",800) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    StartTimer("LookInvent", 6500)
    StartTimer("CameraReset", 6500)
    
    end
end

-- this means Colonel is slightly dozing
function EndOfTurnAnimState1()
    if deadhat == 0 then
    SendMessage("Commentary.Clear")
    SendMessage("EFMV.Start")
    
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "NodOffSlight")
    SendIntMessage("Worm.QueueAnim", 2)
    
    if WakingUp == 0 then
        if FirstTime == 0 then
            SetData("CommentaryPanel.Comment", "Miss.CountSheep.game15")
            SendMessage("CommentaryPanel.ScriptText")
            FirstTime = 1
        end
        SetData("CommentaryPanel.Comment", "Miss.CountSheep.game16")
        SendMessage("CommentaryPanel.ScriptText")
    elseif WakingUp == 1 then
        WakingUp = 0
        SetData("CommentaryPanel.Comment", "Miss.CountSheep.game21")
        SendMessage("CommentaryPanel.ScriptText")
    end
        
    SetData("Camera.Path.Knots.Position", "SleepCam,SleepCam2")
    SetData("Camera.Path.Knots.LookAt", "SleepLook")
    SetData("Camera.Path.Steps.Position",800)
    SetData("Camera.Path.Steps.LookAt",800) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    StartTimer("LookInvent", 5500)
    StartTimer("CameraReset", 5500)
    
    end
end
-- colonel is even sleepier!!
function EndOfTurnAnimState2()
    if deadhat == 0 then
    SendMessage("Commentary.Clear")
    SendMessage("EFMV.Start")
    
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "NodOffMore")
    SendIntMessage("Worm.QueueAnim", 2)
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.game22")
    SendMessage("CommentaryPanel.ScriptText")
        
    SetData("Camera.Path.Knots.Position", "SleepCam,SleepCam2")
    SetData("Camera.Path.Knots.LookAt", "SleepLook")
    SetData("Camera.Path.Steps.Position",800)
    SetData("Camera.Path.Steps.LookAt",800) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    StartTimer("LookInvent", 5500)
    StartTimer("CameraReset", 5500)
    
    end
end
-- colonel wakes up - user has failed to release another sheep
function WakeAnim()
    if deadhat == 0 then
    SendMessage("Commentary.Clear")
    SendMessage("EFMV.Start")
    
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "NodOffEnd")
    SendIntMessage("Worm.QueueAnim", 2)
    
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.game17")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "WakeCam")
    SetData("Camera.Path.Knots.LookAt", "WakeLook")
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    StartTimer("LookInvent", 6600)
    StartTimer("CameraReset", 6600)
    end
end
-- colonel is fully asleep and mission is completed successfully
function SleepAnim()
    if deadhat == 0 then
    SendMessage("Commentary.Clear")
    SetData("Worm.Blink", 0)
    SendIntMessage("Worm.SetBlink", 2)

    SendMessage("EFMV.Start")
    
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Asleep")
    SendIntMessage("Worm.QueueAnim", 2)
    SetData("Worm.ScriptAnim", "Asleep")
    SendIntMessage("Worm.QueueAnim", 2)
    SetData("Worm.ScriptAnim", "Asleep")
    SendIntMessage("Worm.QueueAnim", 2)
    SetData("Worm.ScriptAnim", "Asleep")
    SendIntMessage("Worm.QueueAnim", 2)
    SetData("Worm.ScriptAnim", "Asleep")
    SendIntMessage("Worm.QueueAnim", 2)
    SetData("Worm.ScriptAnim", "Asleep")
    SendIntMessage("Worm.QueueAnim", 2)
    
    SetData("Particle.DetailObject", "Part_Z")
    SetData("Particle.Name", "Part_SleepyZ")
    SendMessage("Particle.NewEmitter")
    
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.success")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.CountSheep.success2")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "SleepCam,SleepCam2")
    SetData("Camera.Path.Knots.LookAt", "SleepLook")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    StartTimer("endmissionsuccess", 2000)
    Switch = 1
    
    end
end

function CameraReset()
    SendMessage("EFMV.End")
    SendMessage("Camera.SetDefault")
end

function Worm_Died()
    deadworm = GetData("DeadWorm.Id")
    if deadworm == 0 or deadworm == 1 then
        deadworms = deadworms + 1
        if deadworms == 2 then
            if Switch == 0 then
                deadhat = 1
                GlobalCondition = 1
                SendMessage("Commentary.Clear")
                SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
                SendMessage("CommentaryPanel.ScriptText")
                SetData("CommentaryPanel.Comment", "Miss.generic.fail")
                SendMessage("CommentaryPanel.ScriptText")
                endmissionfail()
                Switch = 1
            end
        end
    elseif deadworm == 2 then
        if Switch == 0 then
            deadhat = 1
            GlobalCondition = 1
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
            SendMessage("CommentaryPanel.ScriptText")
            SetData("CommentaryPanel.Comment", "Miss.generic.fail")
            SendMessage("CommentaryPanel.ScriptText")
            endmissionfail()
            Switch = 1
        end
    end
end

function endmissionsuccess()
    
    Result()

end



--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
        Key,Lock = EditContainer("L.C.SS3")
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName2","L.C.SS3")
        end
        CloseContainer(Key)

        if timetook < silvertime then
            Movie = 2
            
            if timetook < goldtime then
                Movie = 3

                Key,Lock = EditContainer("L.L.Counting")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Counting")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end


function endmissionfail()
    SendMessage("GameLogic.Mission.Failure")
end

function SetupWormsAndTeams()

    GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Colonel"
    team.FlagGfxName = "68"
    team.TeamColour = 1
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "HumanWorm1"
    CloseContainer(lock) 

    lock, worm = EditContainer("Worm.Data01") 
    worm.Active = true
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "HumanWorm2"
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data02") 
    worm.Active = true
    worm.Name = "The Colonel"
    worm.Energy = 1
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    worm.SfxBankName = "Conscience"
    worm.Spawn = "HatWorm"
    worm.IsEmotional = false
    worm.IsAllowedToTakeTurn = false
    CloseContainer(lock) 

    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Alliance00") 
    --fast walklio :)
    inventory.Parachute = -1
    inventory.SkipGo = -1
    CloseContainer(lock)
end

--////////////////////////////////////////////////
--// fail mission when timer runs out           //
--////////////////////////////////////////////////

function Timer_GameTimedOut()

    TimedOut = 1

end


--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
    
end
