
-- Mission Leek In Teh Veg Patchxxor

function Initialise()

    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 8
    goldtime = (60 * 1000) * 6.5

    water = 0
    camdone = 0
    turn = 0
    Switch = 0
    Timer1 = 0
    
    SetData("Particle.Rain.Prob", 100)
    SetData("Particle.Snow.Prob", 0)
    
    NextTurn = 1

    SendMessage("EFMV.Start")
    SendStringMessage("Camera.Disable", "Track")

    -- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SetData("TurnTime", 35000)
    SetData("RoundTime", 1000000)
--    SetData("Particle.Rain.Prob", 100)
--    SetData("Particle.Snow.Prob", 0)
   
    SendMessage("GameLogic.PlaceObjects")

    SetData("Crate.Spawn", "crate1")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityTeleport")
    SetData("Crate.Index", 1) 
    SendMessage("GameLogic.CreateCrate")

    SetData("Crate.Spawn", "crate2")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityTeleport")
    SetData("Crate.Index", 2) 
    SendMessage("GameLogic.CreateCrate")

    SetData("Crate.Spawn", "crate3")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityTeleport")
    SetData("Crate.Index", 3) 
    SendMessage("GameLogic.CreateCrate")   

    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera","")     

    SetupWormsAndTeams()
    SetupInventories()

    --StartFirstTurn()
    camera()
    
end

--////////////////////////////////////////////////
--//            Raise water                     //
--////////////////////////////////////////////////



function WaterMessage()

    if turn == NextTurn then    
        SetData("CommentaryPanel.Comment", "Miss.leek.extra6")
        SendMessage("CommentaryPanel.ScriptText")
        
        NextTurn = turn + 1
    end
    

end


function SetWind()

    if turn > 0 then
    
       SelectRandomWind()
       
    end
    
end



function DoOncePerTurnFunctions()
    if Switch == 0 then
        water = water + 10
        SetData("Water.Level", water)
        
        turn = turn + 1
        
        WaterMessage()
    end
end


--////////////////////////////////////////////////
--//          Set up worms and inventories      //
--////////////////////////////////////////////////

function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")

   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
   team.Name = GM.T1_Name
   team.TeamColour = 0
   team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
   CloseContainer(lock) -- must close the container ASAP

   -- Activate Team 1
   lock, team = EditContainer("Team.Data01") 
   team.Active = true
   team.Name = "The Villains"
   team.IsAIControlled = true
   team.TeamColour = 1
   team.FlagGfxName = "97"
   CloseContainer(lock)

   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
   worm.Name = GM.T1_W1_Name
   worm.SfxBankName = GM.T1_Speech
   worm.Spawn = "spawn1"
   worm.IsParachuteSpawn = false
   worm.Energy = 100
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 

   -- Worm 1, Team 0
   CopyContainer("Worm.Data00", "Worm.Data01")
   lock, worm = EditContainer("Worm.Data01") 
   worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
   worm.Spawn = "spawn2"
   CloseContainer(lock)

   -- Worm 2, Team 0
   CopyContainer("Worm.Data00", "Worm.Data02")
   lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GM.T1_W3_Name
    worm.SfxBankName = GM.T1_Speech
   worm.Spawn = "spawn3"
   CloseContainer(lock)

   -- Worm 3, Team 0
   CopyContainer("Worm.Data00", "Worm.Data03")
   lock, worm = EditContainer("Worm.Data03") 
    worm.Name = GM.T1_W4_Name
    worm.SfxBankName = GM.T1_Speech
   worm.Spawn = "spawn4"
   CloseContainer(lock)

   -- Worm 4, Team 1
   CopyContainer("Worm.Data00", "Worm.Data04")
   lock, worm = EditContainer("Worm.Data04")
   CopyContainer("AIParams.CPU1", "AIParams.Worm04")
   worm.Energy = 80 
   worm.Name = "Whistler"
   worm.Spawn = "spawn5"
   worm.SfxBankName = "Geordie"
   worm.TeamIndex = 1
   CloseContainer(lock)

   -- Worm 5, Team 1
   CopyContainer("Worm.Data04", "Worm.Data05")
   lock, worm = EditContainer("Worm.Data05")
   CopyContainer("AIParams.Worm04", "AIParams.Worm05")
   worm.Energy = 80  
   worm.Name = "Wellard"
   worm.Spawn = "spawn6"
   CloseContainer(lock)

   -- Worm 6, Team 1
   CopyContainer("Worm.Data04", "Worm.Data06")
   lock, worm = EditContainer("Worm.Data06")
   CopyContainer("AIParams.CPU2", "AIParams.Worm06")
   worm.Energy = 120  
   worm.Spawn = "spawn7"
   worm.SfxBankName = "Super Villain"
   worm.Name = "Boggy Pete"
   CloseContainer(lock)

   -- Worm 7, Team 1
   CopyContainer("Worm.Data04", "Worm.Data07")
   lock, worm = EditContainer("Worm.Data07")
   worm.Energy = 80
   CopyContainer("AIParams.Worm04", "AIParams.Worm07")   
   worm.Spawn = "spawn8"
    worm.IsParachuteSpawn = true
   worm.Name = "Federer"
   CloseContainer(lock)

   
      -- Worm 8, Team 1
   CopyContainer("Worm.Data04", "Worm.Data08")
   lock, worm = EditContainer("Worm.Data08")
   CopyContainer("AIParams.Worm04", "AIParams.Worm08")
   worm.Energy = 80  
   worm.Spawn = "spawn9"
   worm.Name = "Big lad"
   CloseContainer(lock)
   
      -- Worm 9, Team 1
   CopyContainer("Worm.Data04", "Worm.Data09")
   lock, worm = EditContainer("Worm.Data09")
   CopyContainer("AIParams.Worm04", "AIParams.Worm09")   
   worm.Energy = 80  
   worm.Spawn = "spawn10"
   worm.Name = "Apone"
   CloseContainer(lock)
  
    -- Worm 10, Team 1
   CopyContainer("Worm.Data04", "Worm.Data10")
   lock, worm = EditContainer("Worm.Data10")
   CopyContainer("AIParams.Worm04", "AIParams.Worm10")   
   worm.Energy = 80  
   worm.Spawn = "spawn11"
    worm.IsParachuteSpawn = true
   worm.Name = "Sad Man"
   CloseContainer(lock)
   
   SendMessage("WormManager.Reinitialise")

end


function SetupInventories()
    -- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Bazooka = 8
    inventory.Grenade = -1
    inventory.ClusterGrenade = -1
    inventory.Airstrike = 1
    inventory.Dynamite = 2
    inventory.HolyHandGrenade = 1
    inventory.Landmine = 2
    inventory.Shotgun = 1
    inventory.Uzi = 4
    inventory.Prod = -1
    inventory.FirePunch = -1
    --inventory.Girder = 3
    inventory.SkipGo = -1
    CloseContainer(lock) -- must close the container ASAP

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
    CopyContainer("Inventory.Team.Default", "Inventory.Team01")

    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Airstrike = 0
    inventory.ClusterGrenade = 0
    inventory.Mortar = 4
    inventory.Landmine = 0
    inventory.Girder = 1
    CloseContainer(lock)
   
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Airstrike = 0
    inventory.ClusterGrenade = 0
    inventory.HolyHandGrenade = 0
    inventory.Mortar = 4
    inventory.Landmine = 0
    inventory.Girder = 1
    inventory.Jetpack = 1
    inventory.Teleport = 2
    CloseContainer(lock)
end



--/////////////////////////////////////////////////////
--//    Check for who has survived                   //
--/////////////////////////////////////////////////////

function CheckOneTeamVictory()
   -- SendMessage("WormManager.GetActiveTeamCount")
    TeamCount = GetData("TeamCount")
    WhichTeam = GetData("SurvivingTeamIndex")
    
    if TeamCount == 0 then
        
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
        end
        Switch = 1
    
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
        end
        Switch = 1
    
    elseif TeamCount == 1 and WhichTeam == 0 then
        Switch = 1
        SuccessMessages()
        WhichAward()

    else
    
    -- still at least 2 teams left
    StartTurn()
    end
end



--///////////////////////////////////////////////////
--// give an award out on successful completion    //
--///////////////////////////////////////////////////

function WhichAward()
    
    Result()
    
end

--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
        Key,Lock = EditContainer("L.C.Shotgun2") --unlock shotgun 2 challenge
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName2","L.C.Shotgun2")
        end
        CloseContainer(Key)
        
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.L.Leek") --unlock leek in a veg patch for multiplayer
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Leek")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end



--///////////////////////////////////////////////////
--//    Camera stuff                               //
--///////////////////////////////////////////////////

function camera()
    
    SetData("CommentaryPanel.Comment", "Miss.leek.extra1")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("CommentaryPanel.Comment", "Miss.leek.extra2")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("CommentaryPanel.Comment", "Miss.leek.extra3")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("CommentaryPanel.Comment", "Miss.leek.extra4")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("CommentaryPanel.Comment", "Miss.leek.extra5")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "cam1, cam2, cam3, cam4")
    SetData("Camera.Path.Knots.LookAt", "look1, look2, look3, look4")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",350)  
    SetData("Camera.Path.Steps.LookAt",375)
    SetData("Camera.Path.Tension.Position", -0.1) 
    SendMessage("Camera.Path.Start")

end


function Camera_Path_Reached_Knot()

    knot = GetData("Camera.Path.Knot")


    if knot == "cam2" then
    
        SendIntMessage("Worm.ResetAnim", 0)
        SetData("Worm.ScriptAnim", "Shocked1")
        SendIntMessage("Worm.QueueAnim", 0)
        SetData("Worm.ScriptAnim", "Smile")
        SendIntMessage("Worm.QueueAnim", 0)
        SetData("Worm.ScriptAnim", "Smile2")
        SendIntMessage("Worm.QueueAnim", 0) 
           
    end    
   
   
    if knot == "cam4" then
            
        SetData("Camera.Path.Knots.Position", "Water1")
        SetData("Camera.Path.Knots.LookAt", "Focal1")
        SendMessage("Camera.Path.Start")
        
        SetData("CommentaryPanel.Comment", "Miss.leek.extra6")
        SendMessage("CommentaryPanel.ScriptText")
        
        StartTimer("WaterRaise", 1000)
        
        Timer1 = StartTimer("GameOn", 3000)
        
    end
   
end

function WaterRaise()

    water = water + 10
    SetData("Water.Level", water)

end


function GameOn()

    SetData("Camera.Orbit.Speed",-0.2)
    camdone = 1
    startt()

end


--//////////////////////////////////////////////////
--//            Start turn                        //
--//////////////////////////////////////////////////


function startt()

    SendMessage("EFMV.End")    
    SendStringMessage("Camera.Enable", "Track")
    SendMessage("Commentary.Clear")
    
    StartFirstTurn()

end


function Input_SomeInput()

    if camdone == 0 then
        camdone =  1
        CancelTimer(Timer1)
        WaterRaise()
        startt()
    
    end
end


--////////////////////////////////////////////////
--// fail mission when timer runs out           //
--////////////////////////////////////////////////


function TurnEnded()
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    else
        CheckOneTeamVictory()
    end
end

--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
    
end

function SuccessMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end

end

