
----------------------------------------------------------
-- Mission Mike's test
----------------------------------------------------------
function Initialise()

id1 = 0
id1b = 0
id2b = 0
id3b = 0
id4b = 0

-- Sets up mines and turn time
   SetData("Mine.DudProbabilty", 0.1)
   SetData("Mine.MinFuse", 3000)
   SetData("Mine.MaxFuse", 4000)
   SetData("HotSeatTime", 0) -- no hotseat time
   SetData("RoundTime", 0) -- no Game timer
   SetData("TurnTime", 0) -- no game timer

--	SetData("Crate.Spawn", "CrateSpawn2")
--	SetData( "Crate.Type" , "utility" )
--	SetData( "Crate.Contents" , "kUtilityDoubleDamage" )
--	SendMessage("GameLogic.CreateCrate")



   SendMessage("GameLogic.PlaceObjects")



  
    SetupWormsAndTeams()
    SetupInventories()
    StartFirstTurn()

	StartTimer("CreateEmitter", 1000)	


end

-- /////////////////////////////////////////////////////////////
function CreateEmitter()


--	SetData("Particle.DetailObject", "testemitter")
	SetData("Particle.DetailObject", "wormemitter")
--	SetData("Particle.DetailObject", "distantemitter")

--	SetData("Particle.Name", "WeaponBazooka")
--	SetData("Particle.Name", "WeaponPigeon")
--	SetData("Particle.Name", "WeaponUzi")
--	SetData("Particle.Name", "WeaponPigeon")
--	SetData("Particle.Name", "UtilityFreeze")
--	SetData("Particle.Name", "UtilityLowGravity")
--	SetData("Particle.Name", "UtilityDoubleDamage")
--	SetData("Particle.Name", "WeaponFlamethrower")
--	SetData("Particle.Name", "WeaponHolyHG")
--	SetData("Particle.Name", "UtilityScalesReady")
--	SetData("Particle.Name", "UtilityScales")
--	SetData("Particle.Name", "WeaponHolyHGTrail")
--	SetData("Particle.Name", "UtilityLowGravHelm1")
--	SetData("Particle.Name", "WeaponPigeonBang")
--	SetData("Particle.Name", "WeaponBananaExplosion")
--	SetData("Particle.Name", "WeaponSheep")
--	SetData("Particle.Name", "WeaponSheepBang")
--	SetData("Particle.Name", "WeaponBazookaExhaust")
--	SetData("Particle.Name", "WeaponNuclear")
--	SetData("Particle.Name", "Part_ChimneySmoke")
--	SetData("Particle.Name", "WeaponPigeon")
--	SetData("Particle.Name", "Part_CrateSpawn")
--	SetData("Particle.Name", "WeaponOldWoman")

	SetData("Particle.Name", "EnvRainfall")

--	SetData("Particle.Name", "UtilityFast")
--	SetData("Particle.Name", "WeaponBaseballBat")
--	SetData("Particle.Name", "WeaponMuzzleFlash")
--	SetData("Particle.Name", "UtilityTeleport")
--	SetData("Particle.Name", "ParticleWhiteout")
--	SetData("Particle.Name", "Propsmoke_Propfire")
--	SetData("Particle.Name", "WeaponLaserPuff")

--	SetData("Particle.Name", "WeaponGasCan")
--	SetData("Particle.Name", "LevelDDayTracerFire")

	SendMessage("Particle.NewEmitter")
	id1b = GetData("Particle.Handle")
	
	StartTimer("CreateEmitter", 4000)	
	
end	


-- /////////////////////////////////////////////////////////////

function TurnEnded()
   SendMessage("WormManager.GetActiveWormCount")
   WormCount = GetData("WormCount")
   if WormCount == 0 then
      -- all the worms have just snuffed it
      SendMessage("GameLogic.EndGame")
   else
      -- still at least some worms left
      StartTurn()
   end
end




-- //////////////////////////////////////////////////////////////////

function SetupWormsAndTeams()

   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
   team.Name = "Allies"
   team.TeamColour = 0
   CloseContainer(lock) -- must close the container ASAP



   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
   worm.Name = "SailorBoy"
   worm.Energy = 300
   worm.Spawn = "spawn1"
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 
 

    -- Worm 1, Team 0
   lock, worm = EditContainer("Worm.Data01") 
   worm.Active = true
   worm.Name = "FirstMate"
   worm.Spawn = "spawn2"
   worm.Energy = 300
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 
 
 
 
 
 
 
 
 
   SendMessage("WormManager.Reinitialise")

end

-- //////////////////////////////////////////////////////////////////

function SetupInventories()
    -- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 

--Utilities

    inventory.ChangeWorm  = -1
    inventory.Freeze = -1
    inventory.Girder = -1
    inventory.Jetpack = -1
    inventory.LowGravity = -1
    inventory.NinjaRope = -1
    inventory.Parachute = -1
    inventory.QuickWalk = -1
    inventory.ScalesOfJustice = -1
    inventory.SkipGo = -1
    --inventory.Surrender = -1
    inventory.Teleport = -1

--Weapons

    inventory.Airstrike = -1
    inventory.BananaBomb = -1
    inventory.BaseballBat = -1
    inventory.Bazooka = -1
    inventory.ClusterGrenade = -1
    inventory.ConcreteDonkey = -1
    inventory.Dragonball = -1
    inventory.Dynamite = -1
    inventory.Earthquake = -1
    inventory.FirePunch = -1
    inventory.FlameThrower = -1
    inventory.GasCanister = -1
    inventory.Grenade = -1
    inventory.HolyHandGrenade = -1
    inventory.HomingMissile = -1
    inventory.HomingPidgeon = -1
    inventory.Landmine = -1
    --inventory.Lasergun = -1
    inventory.MadCow = -1
    inventory.MailStrike = -1
    inventory.Minigun = -1
    inventory.MingVase = -1
    inventory.Mortar = -1
    inventory.NuclearBomb = -1
    inventory.OldWoman = -1
    inventory.PetrolBomb = -1
    inventory.Prod = -1
    inventory.Sheep = -1
    inventory.Shotgun = -1
    inventory.SuperBananaBomb = -1
    inventory.SuperSheep = -1
    inventory.Teleport = -1
    inventory.Uzi = -1
    inventory.VikingAxe = -1

    CloseContainer(lock) -- must close the container ASAP

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   
end



-- ///////////////////////////////////////////////////////////////////


