
-- Ragnarok and Roll

function Initialise()
    bronzetime = (60 * 1000) * 999
    silvertime = 520000
    goldtime = 490000

    id1 = 0
    id2 = 0
    id3 = 0
    id4 = 0

    SetData("Jetpack.InitFuel", 5000)
    
    SetData("TurnTime", 45000)
    SetData("HotSeatTime", 3000)
    SetData("RoundTime", 600000)
    
    Turn = 0
    deadcpu = 0
    camdone =  0
    SendMessage("EFMV.Start")
    Switch = 0

    SetData("Crate.TrackCam", 0)
    SetData("Camera.StartOfTurnCamera","Default")
    
    -- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SendMessage("GameLogic.PlaceObjects")

    SpawnCrates()
    SpawnHealth()
    SetupWormsAndTeams()
    SetupInventories()	
    --camera()   
    First()
    bubbleend() 
end

function First()
    SetData("Camera.Path.Knots.Position", "FirstCam,FirstCam2")
    SetData("Camera.Path.Knots.LookAt", "FirstLook,FirstLook2")
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",500)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Second", 4000)
end

function Second()
    SetData("Camera.Path.Knots.Position", "SecondCam,SecondCam2")
    SetData("Camera.Path.Knots.LookAt", "SecondLook")
    SetData("Camera.Path.Steps.Position",550)  
    SetData("Camera.Path.Steps.LookAt",550)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("LookWorm", 4000)
    
    SetData("CommentaryPanel.Comment", "Miss.Pack.NEW.game1")
    SendMessage("CommentaryPanel.ScriptText")
end

function LookWorm()
    SetData("Camera.Path.Knots.Position", "LookWormCam")
    SetData("Camera.Path.Knots.LookAt", "LookWormLook")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Fourth", 5000)
    
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "WTF")
    SendIntMessage("Worm.QueueAnim", 0)
    
    SetData("CommentaryPanel.Comment", "Miss.Pack.NEW.game2")
    SendMessage("CommentaryPanel.ScriptText")
end

function Third()
    SetData("Camera.Path.Knots.Position", "ThirdCam,ThirdCam2")
    SetData("Camera.Path.Knots.LookAt", "ThirdLook")
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",500)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Fifth", 3000)
end

function Fourth()
    SetData("CommentaryPanel.Comment", "MissPack.game1")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "FourthCam,FourthCam2")
    SetData("Camera.Path.Knots.LookAt", "FourthLook,FourthLook2")
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",400)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Third", 3000)
end

function Fifth()
    SetData("Camera.Path.Knots.Position", "FifthCam,FifthCam2")
    SetData("Camera.Path.Knots.LookAt", "FifthLook")
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",500)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Sixth", 3000)
end

function Sixth()
    SetData("CommentaryPanel.Comment", "MissPack.game2")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "SixthCam,SixthCam2")
    SetData("Camera.Path.Knots.LookAt", "SixthLook")
    SetData("Camera.Path.Steps.Position",600)  
    SetData("Camera.Path.Steps.LookAt",600)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Seventh", 3000)
end

function Seventh()
    SetData("CommentaryPanel.Comment", "MissPack.game3")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "LookWorm2Cam")
    SetData("Camera.Path.Knots.LookAt", "LookWorm2Look")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("startt", 2500)
    
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 0)
end

function startt()
    SendMessage("EFMV.End")
    camdone = 1
    CancelTimer(CamLoop)
    StartFirstTurn()
end

function Camera_Path_Stopped()
    if camdone == 0 then
        SendMessage("Commentary.Clear")
        camdone = 1
        CancelTimer(CamLoop)
	SendMessage("EFMV.End")
        StartFirstTurn()
    end
end

function SpawnHealth()
    SetData("Crate.Spawn", "Health")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 25)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
end

function SpawnCrates()
    SetData("Crate.Spawn", "Jetpack")
    SetData("Crate.Type", "Utility")	
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityJetpack")
    SetData("Crate.TeamCollectable", 0)
    SetData("Crate.TeamDestructible", 10)
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")

    SetData("Crate.Spawn", "Shotgun")
    SetData("Crate.Type", "Weapon")	
    SetData("Crate.NumContents", 2)
    SetData("Crate.Contents", "kWeaponShotgun")
    SetData("Crate.TeamCollectable", 0)
    SetData("Crate.TeamDestructible", 10)
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Firepunch")
    SetData("Crate.Type", "Weapon")	
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponFirePunch")
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Parachute")
    SetData("Crate.Type", "Utility")	
    SetData("Crate.NumContents", 2)
    SetData("Crate.Contents", "kUtilityParachute")
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Girder")
    SetData("Crate.Type", "Utility")	
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityGirder")
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "BaseballBat")
    SetData("Crate.Type", "Weapon")	
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponBaseballBat")
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Dynamite2")
    SetData("Crate.Type", "Weapon")	
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponDynamite")
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")

    SetData("Crate.Spawn", "Girder2")
    SetData("Crate.Type", "Utility")	
    SetData("Crate.NumContents", 2)
    SetData("Crate.Contents", "kUtilityGirder")
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Grenade")
    SetData("Crate.Type", "Weapon")	
    SetData("Crate.NumContents", 2)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Firepunch2")
    SetData("Crate.Type", "Weapon")	
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponFirePunch")
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Bazooka")
    SetData("Crate.Type", "Weapon")	
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponBazooka")
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Freeze")
    SetData("Crate.Type", "Utility")	
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityFreeze")
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Dynamite3")
    SetData("Crate.Type", "Weapon")	
    SetData("Crate.NumContents", 2)
    SetData("Crate.Contents", "kWeaponDynamite")
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")
end

function Crate_Collected()
    CrateIndex = GetData("Crate.Index")
    if CrateIndex == 1 then
    end
end

function bubbles()
    if MyRandomNumber == 1 then
	SetData("Particle.DetailObject", "Bubbles1")
	SetData("Particle.Name", "ParticleBubbles")
	SendMessage("Particle.NewEmitter")
	id1 = GetData("Particle.Handle")
	
	SendIntMessage("Particle.DeleteEmitter",id2)
	SendIntMessage("Particle.DeleteEmitter",id3)
	SendIntMessage("Particle.DeleteEmitter",id4)
    elseif MyRandomNumber == 2 then
	SetData("Particle.DetailObject", "Bubbles2")
	SetData("Particle.Name", "ParticleBubbles")
	SendMessage("Particle.NewEmitter")
	id2 = GetData("Particle.Handle")
	
	SendIntMessage("Particle.DeleteEmitter",id1)
	SendIntMessage("Particle.DeleteEmitter",id3)
	SendIntMessage("Particle.DeleteEmitter",id4)
    elseif MyRandomNumber == 3 then
	SetData("Particle.DetailObject", "Bubbles3")
	SetData("Particle.Name", "ParticleBubbles")
	SendMessage("Particle.NewEmitter")
	id3 = GetData("Particle.Handle")
	
	SendIntMessage("Particle.DeleteEmitter",id1)
	SendIntMessage("Particle.DeleteEmitter",id2)
	SendIntMessage("Particle.DeleteEmitter",id4)
    elseif MyRandomNumber == 4 then
	SetData("Particle.DetailObject", "Bubbles4")
	SetData("Particle.Name", "ParticleBubbles")
	SendMessage("Particle.NewEmitter")
	id4 = GetData("Particle.Handle")
	
	SendIntMessage("Particle.DeleteEmitter",id1)
	SendIntMessage("Particle.DeleteEmitter",id2)
	SendIntMessage("Particle.DeleteEmitter",id3)
    end
	
    StartTimer("bubbleend", 6000)
end	

function bubbleend()
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 3) + 1
    bubbles()
end


--function Worm_Died()
--    deadworm = GetData("DeadWorm.Id")
--    if deadworm == 0 then
--        if Switch == 0 then
--            SendMessage("Commentary.Clear")
--            FailureMessages()
--            endmissionfail()
--            Switch = 1
--        end
--    elseif deadworm == 1 or deadworm == 2 or deadworm == 3 or deadworm == 4 or deadworm == 5 or deadworm == 6
--    or deadworm == 7 then
--	deadcpu = deadcpu + 1
--	if deadcpu == 7 then
--           Switch = 1
--            SendMessage("Commentary.Clear")
--            SuccessMessages()
--            endmissionsuccess()
--	end
--   end
--end

function FailureMessages()
    SendMessage("Commentary.Clear")
    
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

function SuccessMessages()
    SendMessage("Commentary.Clear")
    
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end


function endmissionfail()
    SendMessage("GameLogic.Mission.Failure")
end

function endmissionsuccess()
    Result()
end

--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()

    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.L.Ragna")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Ragna")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

function TurnEnded()

    CheckOneTeamVictory()
    
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end

end

function CheckOneTeamVictory()
    TeamCount = GetData("TeamCount")
    WhichTeam = GetData("SurvivingTeamIndex")
    
    if TeamCount == 0 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 0 then
        Switch = 1
        SuccessMessages()
        endmissionsuccess()
    else
      -- still at least 2 teams left
     StartTurn()
   end
end

function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
   lock, team = EditContainer("Team.Data00") 
   team.Name = GM.T1_Name
   team.TeamColour = 0
   team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
   CloseContainer(lock)

   lock, team = EditContainer("Team.Data01") 
   team.Active = true
   team.Name = "The Vikings"
   team.FlagGfxName = "91"
   team.IsAIControlled = true
   team.TeamColour = 1
   CloseContainer(lock)

   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
   worm.Name = GM.T1_W1_Name
   worm.SfxBankName = GM.T1_Speech
   worm.Spawn = "HumanWorm"
   worm.Energy = 75
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 

   CopyContainer("Worm.Data00", "Worm.Data01")
   lock, worm = EditContainer("Worm.Data01")
   worm.Energy = 40
   worm.SfxBankName = "Viking" 
   worm.Name = "Sven"
   worm.Spawn = "CpuWorm1"
   CopyContainer("AIParams.CPU3", "AIParams.Worm01")
   worm.TeamIndex = 1
   CloseContainer(lock)
   
   CopyContainer("Worm.Data00", "Worm.Data02")
   lock, worm = EditContainer("Worm.Data02")
   worm.Energy = 40
   worm.SfxBankName = "Viking" 
   worm.Name = "Erik"
   worm.Spawn = "CpuWorm2"
    CopyContainer("AIParams.CPU3", "AIParams.Worm02")
   worm.TeamIndex = 1
   CloseContainer(lock)
   
   CopyContainer("Worm.Data00", "Worm.Data03")
   lock, worm = EditContainer("Worm.Data03")
   worm.Energy = 40
   worm.SfxBankName = "Viking" 
   worm.Name = "Olaf"
   worm.Spawn = "CpuWorm3"
    CopyContainer("AIParams.CPU3", "AIParams.Worm03")
   worm.TeamIndex = 1
   CloseContainer(lock)
   
   CopyContainer("Worm.Data00", "Worm.Data04")
   lock, worm = EditContainer("Worm.Data04")
   worm.Energy = 40
   worm.SfxBankName = "Viking" 
   worm.Name = "Baldar"
   worm.Spawn = "CpuWorm4"
    CopyContainer("AIParams.CPU3", "AIParams.Worm04")
   worm.TeamIndex = 1
   CloseContainer(lock)
   
   CopyContainer("Worm.Data00", "Worm.Data05")
   lock, worm = EditContainer("Worm.Data05")
   worm.Energy = 40
   worm.SfxBankName = "Viking" 
   worm.Name = "Hagar"
   worm.Spawn = "CpuWorm5"
    CopyContainer("AIParams.CPU3", "AIParams.Worm05")
   worm.TeamIndex = 1
   CloseContainer(lock)

   CopyContainer("Worm.Data00", "Worm.Data06")
   lock, worm = EditContainer("Worm.Data06")
   worm.Energy = 40
   worm.SfxBankName = "Viking" 
   worm.Name = "Tor"
   worm.Spawn = "CpuWorm6"
    CopyContainer("AIParams.CPU3", "AIParams.Worm06")
   worm.TeamIndex = 1
   CloseContainer(lock)

   CopyContainer("Worm.Data00", "Worm.Data07")
   lock, worm = EditContainer("Worm.Data07")
   worm.Energy = 40
   worm.SfxBankName = "Viking" 
   worm.Name = "Angus"
   worm.Spawn = "CpuWorm7"
    CopyContainer("AIParams.CPU3", "AIParams.Worm07")
   worm.TeamIndex = 1
   CloseContainer(lock)

   SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00")
    inventory.Prod = -1
    inventory.SkipGo = -1
    --inventory.Jetpack= 5
    CloseContainer(lock)
 
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Bazooka = -1
    inventory.ClusterGrenade = -1
    inventory.Grenade = -1
    inventory.SkipGo = -1
    inventory.FirePunch = -1
    CloseContainer(lock)
    
    lock, delays = EditContainer("Inventory.WeaponDelays") 
    delays.Bazooka = 3
    CloseContainer(lock)
end


