
-- Mission Basic setup 1v1 player

function Initialise()


-- Sets up mines and turn time
   SetData("Mine.DudProbabilty", 0.1)
   SetData("Mine.MinFuse", 1000)
   SetData("Mine.MaxFuse", 5000)


   SendMessage("GameLogic.PlaceObjects")



   SetupWormsAndTeams()
   SetupInventories()

   StartFirstTurn()


end


function SelectRandomWind()
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   -- The line below controls the strength in this case it will be no more than 6
   SetData("Wind.Speed", RandomNumber*MaxWind * 6 /10)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", Direction)   
end


function SetupWormsAndTeams()

   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
   team.Name = "Allies"
   team.TeamColour = 0
   -- team.IsAIControlled = true
   CloseContainer(lock) -- must close the container ASAP

   -- Activate Team 1
   lock, team = EditContainer("Team.Data01") 
   team.Active = true
   team.Name = "Axis"
   team.TeamColour = 1
   -- team.IsAIControlled = true
   CloseContainer(lock)

   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
   worm.Name = "Riley"
   worm.Energy = 100
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   worm.SfxBankName = "Pirate"
   worm.Spawn = "spawn"
   CloseContainer(lock) 

   -- Worm 1, Team 0
   CopyContainer("Worm.Data00", "Worm.Data01")
   lock, worm = EditContainer("Worm.Data01") 
   worm.Name = "Sarge"
   worm.Spawn = "spawn"
   CloseContainer(lock)

   -- Worm 2, Team 0
   CopyContainer("Worm.Data00", "Worm.Data02")
   lock, worm = EditContainer("Worm.Data02") 
   worm.Name = "Ryan"
   worm.Spawn = "spawn"
   CloseContainer(lock)

   -- Worm 3, Team 0
   CopyContainer("Worm.Data00", "Worm.Data03")
   lock, worm = EditContainer("Worm.Data03") 
   worm.Name = "Frost"
   worm.Spawn = "spawn"
   CloseContainer(lock)

   -- Worm 4, Team 1
   CopyContainer("Worm.Data00", "Worm.Data04")
   lock, worm = EditContainer("Worm.Data04")
   worm.Energy = 80 
   worm.Name = "Fritz"
   worm.TeamIndex = 1
   worm.SfxBankName = "Biggles"
   worm.Spawn = "spawn"
   CloseContainer(lock)

   -- Worm 5, Team 1
   CopyContainer("Worm.Data04", "Worm.Data05")
   lock, worm = EditContainer("Worm.Data05")
   worm.Energy = 80  
   worm.Name = "Heinz"
   worm.Spawn = "spawn"
   CloseContainer(lock)

   -- Worm 6, Team 1
   CopyContainer("Worm.Data04", "Worm.Data06")
   lock, worm = EditContainer("Worm.Data06")
   worm.Energy = 80  
   worm.Name = "Scutze"
   worm.Spawn = "spawn"
   CloseContainer(lock)

   -- Worm 7, Team 1
   CopyContainer("Worm.Data04", "Worm.Data07")
   lock, worm = EditContainer("Worm.Data07")
   worm.Energy = 80  
   worm.Name = "Whittman"
   worm.Spawn = "spawn"
   CloseContainer(lock)

   SendMessage("WormManager.Reinitialise")

end



function SetupInventories()
   -- sets up a default container and adds our selection to it
   lock, inventory = EditContainer("Inventory.Team.Default") 
   inventory.Bazooka = -1
   inventory.Grenade = -1
   inventory.ClusterGrenade = 5
   inventory.Airstrike = 1
   inventory.Dynamite = 1
   inventory.HolyHandGrenade = 1
   inventory.BananaBomb = 1
   inventory.Landmine = 3
   inventory.Shotgun = -1
   inventory.Uzi = 3
   inventory.Minigun = 2
   inventory.HomingMissile = 1
   inventory.HomingPidgeon = 1
   inventory.Sheep = 2
   inventory.SuperSheep = 1
   inventory.Parachute = 3
   inventory.Teleport = 2
   inventory.Jetpack = 1
   inventory.SkipGo = -1
   inventory.SuperBananaBomb = 1
   CloseContainer(lock) -- must close the container ASAP


 

   -- Copies this selection into each worm


   CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   CopyContainer("Inventory.Team.Default", "Inventory.Team01")

end



function Payload_Deleted()
  PayloadId = GetData("Payload.Deleted.Id")
  if PayloadId == MineId then
      SetData("CommentaryPanel.Comment", "Text.TestComment")
      SendMessage("CommentaryPanel.ScriptText")
  end
end
