
-- Mission Alien Juice Suckers

function Initialise()
    bronzetime = (60 * 1000) * 999
    silvertime = 770000
    goldtime = 755000

    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SetData("TurnTime", 60000)
    SetData("RoundTime", 1300000)
    
    SetData("Jetpack.MaxAltitude", 3000)
    SetData("Jetpack.InitFuel", 10000)
    
    SetData("Particle.DetailObject", "Campfire")
    SetData("Particle.Name", "Part_Steamplume")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Spark1")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")

    SetData("Particle.DetailObject", "Sparks2")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Sparks3")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Sparks4")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Sparks5")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "fire1")
    SetData("Particle.Name", "Part_Smallfire")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "fire2")
    SetData("Particle.Name", "Part_Smallfire")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "explosion1")
    SetData("Particle.Name", "Part_ExplosionA")
    SendMessage("Particle.NewEmitter")
       
    SendMessage("GameLogic.PlaceObjects")
    
    SetData("Crate.Spawn", "Crate1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponSuperSheep")
    SetData("Crate.Index", 1)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Crate2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponBananaBomb")
    SetData("Crate.Index", 2)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Teleport")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityTeleport")
    SetData("Crate.Index", 2)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "WormSelect")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityChangeWorm")
    SetData("Crate.Index", 2)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Crate3")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityJetpack")
    SetData("Crate.Index", 3)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Crate4")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityTeleport")
    SetData("Crate.Index", 3)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")

    SendMessage("EFMV.Start")
    SetData("Camera.StartOfTurnCamera","Default")
    
    CamLoop = 0
    turns = 0
    Switch = 0
    Switch2 = 0
    
    CamLoop = StartTimer("Most", 35000)
    
    camera()
    SelectRandomWind()

    SetupWormsAndTeams()
    SetupInventories()
end

function camera()
    CameraFly = 1
    StartTimer("Stopp", 2000)
    
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2,Pos3,Pos4,Pos5")
    SetData("Camera.Path.Knots.LookAt", "LookAt1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",325)  
    SetData("Camera.Path.Steps.LookAt",600)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera2", 11000)
end

function Stopp()
    SetData("CommentaryPanel.Comment", "Miss.Alien.StopThem")
    SetData("CommentaryPanel.Delay",4000)
    SendMessage("CommentaryPanel.TimedText")
end

function camera2()
    StartTimer("Anim", 7000)
    StartTimer("PreAnim", 6000)
    SetData("Camera.Path.Knots.Position", "Pos6,Pos7,Pos8,Pos9,Pos10")
    SetData("Camera.Path.Knots.LookAt", "LookAt2")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",250)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera3", 10500)
end

function PreAnim()
    SetData("Camera.Shake.Length",1000)
    SetData("Camera.Shake.Magnitude",0.20)
    SendMessage("Camera.ShakeStart")
    SetData("Particle.DetailObject", "Explosion")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
end

function Anim()
    SetData("Worm.ScriptAnim", "OverHere")
    SendIntMessage("Worm.QueueAnim", 8)
end

function camera3()
    SetData("CommentaryPanel.Comment", "Miss.Alien.Help")
    SetData("CommentaryPanel.Delay",3500)
    SendMessage("CommentaryPanel.TimedText")
    SetData("Camera.Path.Knots.Position", "Pos11,Pos12,Pos13,Pos14,Pos15,Pos16")
    SetData("Camera.Path.Knots.LookAt", "LookAt3,LookAt4")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",325)  
    SetData("Camera.Path.Steps.LookAt",1000)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("GOG", 16000)
end

function GOG()
    SetData("Camera.StartOfTurnCamera","Default")
    StartFirstTurn()
end

function Most()
    SetData("CommentaryPanel.Comment", "Miss.Alien.Most")
    SetData("CommentaryPanel.Delay",3500)
    SendMessage("CommentaryPanel.TimedText")
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        CameraFly = 0
        CancelTimer(CamLoop)
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        StartFirstTurn()
    end
end
-- cameras end here
function StartFirstTurn()
    SendMessage("EFMV.End")
    WaitUntilNoActivity = false
    SendMessage("Timer.StartGame")
    StartTurn()
end


function FailureMessages()
    SendMessage("Commentary.Clear")
    
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

function CheckOneTeamVictory()
    SendMessage("WormManager.GetActiveTeamCount")
    TeamCount = GetData("TeamCount")
    SendMessage("WormManager.GetSurvivingTeam")
    WhichTeam = GetData("SurvivingTeamIndex")
    if TeamCount == 0 then
        if Switch == 0 then            
            SendMessage("Commentary.NoDefault")
            SendMessage("Commentary.Clear")
            Switch = 1
            SetData("CommentaryPanel.Comment", "Miss.Alien.Failure")
            SetData("CommentaryPanel.Delay",3000)
            SendMessage("CommentaryPanel.TimedText")
            
            SetData("GameOver.AwardMovie","MissionFailed") --play mission failed movie on exit
            SendMessage("GameLogic.Mission.Failure")
        end

    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            SendMessage("Commentary.NoDefault")
            SendMessage("Commentary.Clear")
            Switch = 1
            SetData("CommentaryPanel.Comment", "Miss.Alien.Failure")
            SetData("CommentaryPanel.Delay",3000)
            SendMessage("CommentaryPanel.TimedText")
            SetData("GameOver.AwardMovie","MissionFailed") --play mission failed movie on exit
            SendMessage("GameLogic.Mission.Failure")
        end
    elseif TeamCount == 1 and WhichTeam == 0 then
        Switch = 1
        WONWON()
    else
        StartTurn()
    end
end

function WONWON()

    SendMessage("Commentary.Clear")

    SetData("CommentaryPanel.Comment", "Miss.Alien.Success")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")
    
    Result()
    
end

--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
        Key,Lock = EditContainer("L.S.Villain")
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName2","L.S.Villain")
        end
        CloseContainer(Key) 
 
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.L.Alien")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Alien")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

function TurnStarted()
    SelectRandomWind()
    turns = turns + 1
    checkturns()
end

function TurnEnded()
    CheckOneTeamVictory()
    
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SetData("GameOver.AwardMovie","MissionFailed") --play mission failed movie on exit
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end
    
end

function checkturns()
    if turns == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Alien.UseShotgun")
        SetData("CommentaryPanel.Delay",3500)
        SendMessage("CommentaryPanel.TimedText")
    elseif turns == 25 then
        SetData("CommentaryPanel.Comment", "Miss.Alien.This")
        SetData("CommentaryPanel.Delay",2500)
        SendMessage("CommentaryPanel.TimedText")
        SetData("CommentaryPanel.Comment", "Miss.Alien.This2")
        SetData("CommentaryPanel.Delay",2500)
        SendMessage("CommentaryPanel.TimedText")
    end
end

function PlayerCheck()
end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")

    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Aliens!"
    team.FlagGfxName = "61"
    team.IsAIControlled = true
    team.TeamColour = 1
    CloseContainer(lock)
  
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn1"
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 

   -- Worm 1, Team 0
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn2"
    CloseContainer(lock)

   -- Worm 2, Team 0
    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GM.T1_W3_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn3"
    CloseContainer(lock)

   -- Worm 3, Team 0
    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03") 
    worm.Name = GM.T1_W4_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn4"
    CloseContainer(lock)

   -- Worm 4, Team 1
    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 125 
    worm.Name = "Captain Woooarrrgh"
    worm.SfxBankName = "Alien"
    worm.Spawn = "spawn5"
    worm.TeamIndex = 1
    CloseContainer(lock)

   -- Worm 5, Team 1
    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    worm.Energy =  100 
    worm.Name = "Skimiskmi Woooarrrgh"
    worm.SfxBankName = "Alien"
    worm.Spawn = "spawn6"
    CloseContainer(lock)

   -- Worm 6, Team 1
    CopyContainer("Worm.Data04", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    worm.Energy = 100
    worm.Name = "Wakawaka Wooarrgh"
    worm.SfxBankName = "Alien"
    worm.Spawn = "spawn7"
    CloseContainer(lock)

   -- Worm 7, Team 1
    CopyContainer("Worm.Data04", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    worm.Energy = 100 
    worm.Name = "Harrnini Wooarrgh"
    worm.SfxBankName = "Alien"
    worm.Spawn = "spawn8"
    CloseContainer(lock)
    
   -- Worm 8, Team 1
    CopyContainer("Worm.Data04", "Worm.Data08")
    lock, worm = EditContainer("Worm.Data08")
    worm.Energy = 100 
    worm.Name = "Hucka Hucka Wooarrgh"
    worm.SfxBankName = "Alien"
    worm.Spawn = "spawn9"
    CloseContainer(lock)
    
   -- Worm 9, Team 1
    CopyContainer("Worm.Data04", "Worm.Data09")
    lock, worm = EditContainer("Worm.Data09")
    worm.Energy = 100 
    worm.Name = "Schned Argh Wooarrgh"
    worm.SfxBankName = "Alien"
    worm.Spawn = "spawn10"
    CloseContainer(lock)

    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Bazooka = -1
    inventory.Grenade = -1
    inventory.ClusterGrenade = 5
    inventory.Dynamite = 1
    inventory.Shotgun = 3
    inventory.Prod = -1
    inventory.FirePunch = -1
    inventory.HomingMissile = 1
    inventory.Parachute = -1
    inventory.NinjaRope = -1
    inventory.BaseballBat = -1
    inventory.Girder = 4
    inventory.SkipGo = -1
    CloseContainer(lock)
    
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Bazooka = -1
    inventory.Grenade = -1
    inventory.ClusterGrenade = 5
    inventory.Dynamite = 1
    inventory.Shotgun = 3
    inventory.Prod = -1
    inventory.FirePunch = -1
    inventory.HomingMissile = 1
    inventory.BaseballBat = -1
    inventory.SkipGo = -1
    CloseContainer(lock) 
end
