
-- Mission 'Schools In For Summer'

--A basic Deathmatch style mission.
--Still requires random crate drops.

function Initialise()

    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 11
    goldtime = (60 * 1000) * 9

    SetData("Trigger.Spawn", "Egg1")
    SetData("Trigger.Radius", 10)
    SetData("Trigger.Index", 100)
    SetData("Trigger.PayloadCollect",0)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Egg2")
    SetData("Trigger.Radius", 10)
    SetData("Trigger.Index", 101)
    SetData("Trigger.PayloadCollect",0)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    EasterEgg = 0

    turn = 0
    Switch = 0
    
    SetData("Particle.DetailObject", "Bird")
    SetData("Particle.Name", "Part_BirdSky")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Bird2")
    SetData("Particle.Name", "Part_BirdSky")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Butterfly")
    SetData("Particle.Name", "Part_Butterfly")
    SendMessage("Particle.NewEmitter")

    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SetData("TurnTime", 30000)
    SetData("RoundTime", 720000) 
  
    SetData("HotSeatTime", 5000) 

    SendMessage("GameLogic.PlaceObjects")
    MaxWind = GetData("Wind.MaxSpeed")
    SetData("Wind.Speed", 1*MaxWind)
    SetData("Wind.Direction", 5.3)
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")

    SetupWormsAndTeams()
    SetupInventories()
    camera()
    StartTimer("stWave", 1200)
    StartTimer("stNEWWave", 1900)
    StartTimer("ndWave", 4750)
    StartTimer("rdWave", 8000)
    StartTimer("thWave", 13500)
end


function DoOncePerTurnFunctions()
--   SendMessage("GameLogic.DropRandomCrate")
end


function stNEWWave()
    SetData("Worm.ScriptSpeech", "YoullRegret")
    SendIntMessage("Worm.Talk", 7)
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 7)
end

function stWave()
    SendIntMessage("Worm.ResetAnim", 7)
    SetData("Worm.ScriptAnim", "HitFront")
    SendIntMessage("Worm.QueueAnim", 7)
end

function ndWave()
    SendIntMessage("Worm.ResetAnim", 5)
    SetData("Worm.ScriptAnim", "Taunt1")
    SendIntMessage("Worm.QueueAnim", 5)
end

function rdWave()
    SendIntMessage("Worm.ResetAnim", 4)
    SetData("Worm.ScriptAnim", "Wave_Left")
    SendIntMessage("Worm.QueueAnim", 4)
end

function thWave()
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Smug1")
    SendIntMessage("Worm.QueueAnim", 3)
end

function StartFirstTurn()
    SendMessage("EFMV.End")
   WaitUntilNoActivity = false
   SendMessage("Timer.StartGame")
   StartTurn()
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        CameraFly = 0
        SendMessage("Commentary.Clear")
        CancelTimer(CamLoop)
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        StartFirstTurn()
    end
end

function camera()
    SendMessage("EFMV.Start")
    CameraFly = 1
    
    SetData("CommentaryPanel.Comment", "Miss.Schools.Brief1")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2")
    SetData("Camera.Path.Knots.LookAt", "Look1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",125)  
    SetData("Camera.Path.Steps.LookAt",50)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera2", 3500)
end

function camera2()
    SetData("CommentaryPanel.Comment", "Miss.Schools.Brief3")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "Pos3,Pos4")
    SetData("Camera.Path.Knots.LookAt", "Look2")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",150)  
    SetData("Camera.Path.Steps.LookAt",50)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera3",3000)
end

function camera3()
    SetData("CommentaryPanel.Comment", "Miss.Schools.Brief4")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "Pos5,Pos6")
    SetData("Camera.Path.Knots.LookAt", "Look3")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",150)  
    SetData("Camera.Path.Steps.LookAt",50)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera4",4000)
end

function camera4()
    SetData("CommentaryPanel.Comment", "Miss.Schools.Brief6")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "Pos7,Pos8,Pos8a")
    SetData("Camera.Path.Knots.LookAt", "Look4")        
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",150)  
    SetData("Camera.Path.Steps.LookAt",50)
    SetData("Camera.Path.Tension.Position", -1) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera5",4500)
end

function camera5()
    SetData("CommentaryPanel.Comment", "Miss.Schools.Brief7")
    SendMessage("CommentaryPanel.ScriptText") 
    
    SetData("Camera.Path.Knots.Position", "Pos9")
    SetData("Camera.Path.Knots.LookAt", "Look5")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",300)  
    SetData("Camera.Path.Steps.LookAt",125)
    SetData("Camera.Path.Tension.Position", -1) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("GOOO", 1500)
end

function GOOO()
    CameraFly = 0
    StartFirstTurn()
end

function Trigger_PayloadCollected()
    TriggerIndex = GetData("Trigger.Index")    
    if TriggerIndex == 100 then
        EasterEgg = EasterEgg + 1
        CheckEgg()
    elseif TriggerIndex == 101 then
        EasterEgg = EasterEgg + 1
        CheckEgg()
    end
end

function CheckEgg()
    if EasterEgg == 2 then
            Key,Lock = EditContainer("L.S.Mad")
        if Lock.Locked == true then
             Lock.Locked = false
            SetData("MCa.LockedName3","L.S.Mad")
        end
        CloseContainer(Key)
        SetData("CommentaryPanel.Comment", "Miss.Schools.Egg")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function TurnStarted()
   
   if turn == 6 then
    SetData("CommentaryPanel.Comment", "Miss.Schools.ChinUp")
    SendMessage("CommentaryPanel.ScriptText") 
        
    elseif turn == 42 then
    SetData("CommentaryPanel.Comment", "Miss.Schools.Taking")
    SendMessage("CommentaryPanel.ScriptText") 
   
    end
    turn = turn + 1
end

function CheckOneTeamVictory()
    --WormManager.GetLiveWormsOnTeam
    SendIntMessage("WormManager.GetLiveWormsOnTeam", 0)
    WormsLeftAlive = GetData("WormCount")

    SendMessage("WormManager.GetActiveTeamCount")
    TeamCount = GetData("TeamCount")

    SendMessage("WormManager.GetSurvivingTeam")
    WhichTeam = GetData("SurvivingTeamIndex")


    if TeamCount == 0 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
            SetData("CommentaryPanel.Comment", "Miss.Schools.OhNo")
            SendMessage("CommentaryPanel.ScriptText")    
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
            SetData("CommentaryPanel.Comment", "Miss.Schools.OhNo")
            SendMessage("CommentaryPanel.ScriptText") 
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1 
        end
    elseif TeamCount == 1 and WhichTeam == 2 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
            SetData("CommentaryPanel.Comment", "Miss.Schools.OhNo")
            SendMessage("CommentaryPanel.ScriptText") 
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 0 then
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
        SetData("CommentaryPanel.Comment", "Miss.Schools.Yes")
        SendMessage("CommentaryPanel.ScriptText") 
        SetData("CommentaryPanel.Comment", "Miss.Schools.But")
        SendMessage("CommentaryPanel.ScriptText") 
        Switch = 1
        StartTimer("THEEND", 2500)
    elseif WormsLeftAlive == 0 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
            SetData("CommentaryPanel.Comment", "Miss.Schools.OhNo")
            SendMessage("CommentaryPanel.ScriptText") 
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    else
    StartTurn()
    end
end

function THEEND()
    Result()
end

--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()

    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.P.Bright")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName2","L.P.Bright")
                end
                CloseContainer(Key)
                    
                Key,Lock = EditContainer("L.L.Schools")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Schools")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")
end

-- Will leave out until i can fix.
function Worm_Died()
  --  deadworm = GetData("DeadWorm.Id")
  --  if deadworm == 7 then
  --  worm, lock = EditContainer("Worm.Data03") -- or whoever
  --  worm.DamagePending = worm.DamagePending - 5 -- or whatever
  -- CloseContainer(lock)
  --  worm, lock = EditContainer("Worm.Data04") -- or whoever
   -- worm.DamagePending = worm.DamagePending - 5 -- or whatever
   -- CloseContainer(lock)
  --  worm, lock = EditContainer("Worm.Data05") 
   -- worm.DamagePending = worm.DamagePending - 5 
   -- CloseContainer(lock)
   -- worm, lock = EditContainer("Worm.Data06") 
   -- worm.DamagePending = worm.DamagePending - 5 
   -- CloseContainer(lock)
   -- SetData("CommentaryPanel.Comment", "Miss.Schools.Captain")
   -- SendMessage("CommentaryPanel.ScriptText") 
   -- end
    
end

function SetupWormsAndTeams()

   GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    team.AlliedGroup = 0
    CloseContainer(lock) 
 
    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Gang"
    team.FlagGfxName = "97"
    team.IsAIControlled = true
    team.AlliedGroup = 1
    team.TeamColour = 1
    CloseContainer(lock)
   
    lock, team = EditContainer("Team.Data02") 
    team.Active = true
    team.Name = "The Gang Leader"
    team.FlagGfxName = "77"
    team.IsAIControlled = true
    team.AlliedGroup = 1
    team.TeamColour = 2
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn1"
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 

    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn2"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GM.T1_W3_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn3"
    CloseContainer(lock)

   CopyContainer("Worm.Data00", "Worm.Data03")
   lock, worm = EditContainer("Worm.Data03") 
   worm.Energy = 80 
   worm.Name = "Rocky"
   worm.SfxBankName = "Classic"
   worm.Spawn = "spawn4"
   worm.TeamIndex = 1
   CloseContainer(lock)

   CopyContainer("Worm.Data00", "Worm.Data04")
   lock, worm = EditContainer("Worm.Data04")
   worm.Energy = 80 
   worm.Name = "Bash"
   worm.SfxBankName = "Classic"
   worm.Spawn = "spawn5"
   worm.TeamIndex = 1
   CloseContainer(lock)

   CopyContainer("Worm.Data04", "Worm.Data05")
   lock, worm = EditContainer("Worm.Data05")
   worm.Energy = 80  
   worm.SfxBankName = "Classic"
   worm.Name = "Gripper"
   worm.Spawn = "spawn6"
   CloseContainer(lock)

   CopyContainer("Worm.Data04", "Worm.Data06")
   lock, worm = EditContainer("Worm.Data06")
   worm.Energy = 80  
   worm.SfxBankName = "Classic"
   worm.Name = "Hector"
   worm.Spawn = "spawn7"
   CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data07")   
    worm.Active = true
    worm.SfxBankName = "Whoopsie"
    worm.Name = "Gang Leader"
    worm.Spawn = "spawn8"
    worm.Energy = 125
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 2
    CloseContainer(lock) 

   SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Bazooka = 5
    inventory.Grenade = 4
    inventory.ClusterGrenade = 4
    inventory.Airstrike = 1
    inventory.Dynamite = 1
    inventory.HolyHandGrenade = 1
    inventory.BananaBomb = 3
    inventory.Landmine = 2
    inventory.Shotgun = 2
    inventory.FirePunch = 3
    inventory.Sheep = 1
    inventory.Parachute = 1
    inventory.Jetpack = 1
    inventory.SkipGo = -1
    inventory.Girder = 1
    inventory.Prod = -1
    CloseContainer(lock)

    lock, delays = EditContainer("Inventory.WeaponDelays")
    delays.Airstrike = 10
    delays.Sheep = 5
    delays.HolyHandGrenade = 4
    CloseContainer(lock)

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
    CopyContainer("Inventory.Team.Default", "Inventory.Team01")
    CopyContainer("Inventory.Team.Default", "Inventory.Team02")
  
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.BananaBomb = 0
    CloseContainer(lock)
   
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.BananaBomb = 0
    CloseContainer(lock)
end

--////////////////////////////////////////////////
--// fail mission when timer runs out           //
--////////////////////////////////////////////////

function TurnEnded()

    CheckOneTeamVictory()
    
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end

end


--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
    
end








