
-- SUPER SHEEP CHALLENGE DEUX
function Initialise()

    SendMessage("Commentary.NoDefault")

    SendMessage("EFMV.Start")
    SetData("Land.Indestructable", 1)
    
    SetData("Camera.StartOfTurnCamera","Default")
    SendMessage("GameLogic.PlaceObjects")
    SendStringMessage("Camera.Disable", "Track")
    SendMessage("HUD.HideTurnTime")    
    
    SetData("PostActivityTime", 0) -- cut back to worm as soon as sheep is dead
    SetData("TurnTime", 0)
    SetData("DefaultRetreatTime", 0) -- dont cut back to worm after firing sheep
    SetData("HotSeatTime", 0) 
    SetData("RoundTime", 60000) -- We will increase this as crates are collect and end the game when it runs out
    
    SetData("GameLogic.ArtilleryMode", 1)
       
    SetData("Particle.DetailObject", "Spark1")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
     
    SetData("Particle.DetailObject", "emitter_ParticleFireFlash")
    SetData("Particle.Name", "Part_Singleflame")
    SendMessage("Particle.NewEmitter")
       
    SendMessage("GameLogic.PlaceObjects")
    
    --The crates below are set as traps and will take away time should they be collected
    SetData("Crate.Spawn", "Weapon1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponProd")
    SetData("Crate.Index", 101)
    SetData("Crate.TeamCollectable", 0)
    SetData("Crate.Scale", 6)
    SetData("Crate.Pushable", 0)    
    SetData("Crate.Parachute", 0)
    SetData("Crate.Gravity", 0)
    SendMessage("GameLogic.CreateCrate")
        
    SetData("Crate.Spawn", "Weapon2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponProd")
    SetData("Crate.Index", 102)
    SetData("Crate.TeamCollectable", 0)
    SetData("Crate.Scale", 6)
    SetData("Crate.Pushable", 0)    
    SetData("Crate.Parachute", 0)
    SetData("Crate.Gravity", 0)
    SendMessage("GameLogic.CreateCrate")
        
    SetData("Crate.Spawn", "Weapon3")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponProd")
    SetData("Crate.Index", 103)
    SetData("Crate.TeamCollectable", 0)
    SetData("Crate.Scale", 6)
    SetData("Crate.Pushable", 0)    
    SetData("Crate.Parachute", 0)
    SetData("Crate.Gravity", 0)
    SendMessage("GameLogic.CreateCrate")
        
    SetData("Crate.Spawn", "Weapon4")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.Index", 104)
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponProd")
    SetData("Crate.TeamCollectable", 0)
    SetData("Crate.Scale", 6)
    SetData("Crate.Pushable", 0)    
    SetData("Crate.Parachute", 0)
    SetData("Crate.Gravity", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SendIntMessage("Crate.RadarHide", 101)
    SendIntMessage("Crate.RadarHide", 102)  
    SendIntMessage("Crate.RadarHide", 103)  
    SendIntMessage("Crate.RadarHide", 104) 
    
    RoundDone = 0
    RoundOverSwitch = 0
    DeleteWeapon = 0
    Switch = 0
    NewCrate = 1
    Time = 5000
    EndGame = 0
        
    SetupWormsAndTeams()
    SetupInventories()
    MakeNewCrate()
    Camera()
end

function Camera()
   SendMessage("EFMV.Start")
    SetData("CommentaryPanel.Comment", "Chall.Sheep2.Intro1")
    SendMessage("CommentaryPanel.ScriptText")
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Smug2")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2")
    SetData("Camera.Path.Knots.LookAt", "LookAt1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position", 400)  
    SetData("Camera.Path.Steps.LookAt",150)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera2", 4000)
end
 
function camera2()
    SetData("CommentaryPanel.Comment", "Chall.Sheep2.Intro2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Chall.Sheep2.Intro3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Pos3,Pos4")
    SetData("Camera.Path.Knots.LookAt", "LookAt2")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position", 500)  
    SetData("Camera.Path.Steps.LookAt",150)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera3", 4700)
end

function camera3()
    SetData("CommentaryPanel.Comment", "Chall.Sheep2.Intro4")
    SendMessage("CommentaryPanel.ScriptText")
    CamLoop = StartTimer("GRINN", 4000)

    SetData("Camera.Path.Knots.Position", "Pos5,Pos6,Pos8")
    SetData("Camera.Path.Knots.LookAt", "LookAt3")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position", 200)  
    SetData("Camera.Path.Steps.LookAt",150)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
end

function GRINN()
    SetData("CommentaryPanel.Comment", "Chall.Sheep2.Intro5")
    SendMessage("CommentaryPanel.ScriptText")
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Smile")
    SendIntMessage("Worm.QueueAnim", 0)
end

function Camera_Path_Stopped()
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    CancelTimer(CamLoop) -- stop the next camera from starting
    
    start()
end

function Camera_Path_Reached_Knot()
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- start the game proper if the path camera finishes
    knot = GetData("Camera.Path.Knot")
    
    if knot == "Pos8" then
        start()
    end
end 

function start()
    Print("In Start function")
    SendMessage("EFMV.End")
    StartFirstTurn()
end


function Timer_GameTimedOut()

    EndGame = 1
    
    if RoundDone == 0 then
        SetData("CommentaryPanel.Comment", "Chall.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText")
                
        RoundOverSwitch = 1
        RoundOver()
    end
end


function RoundOver()

    Switch = 1
    
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
    SendMessage("CommentaryPanel.ScriptText")
    
    Result()
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()  

    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Prod = 0    
    CloseContainer(lock) -- must close the container ASAP      

    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
    timetook = GetData("ElapsedRoundTime")
    goldtime = GetData("MCa.BestGold")
    silvertime = GetData("MCa.BestSilver")
    bronzetime = GetData("MCa.BestBronze")
     
    if timetook > bronzetime then
        Movie = 1
        if timetook > silvertime then
            Movie = 2
            if timetook > goldtime then
                Movie = 3
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Challenge.Result")

end



-- This will be called when a sheep snuffs it
function TurnEnded()

   SendMessage("WormManager.GetActiveTeamCount")
   TeamCount = GetData("TeamCount")
   
    if TeamCount == 0 then
        -- the worm just died
	SetData("CommentaryPanel.Comment", "Chall.Generic.Lose1")
	SendMessage("CommentaryPanel.ScriptText")
        
	if RoundOverSwitch == 0 then
                RoundDone = 1
		RoundOver()
	end
    else
        -- give him another go 
        StartTurn()
    end
end


function SetupWormsAndTeams()

    GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 1
    worm.Spawn = "spawn1"
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
 
    SendMessage("WormManager.Reinitialise")
    
end


function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.SuperSheep = -1
    CloseContainer(lock)
    
    lock, weapon = EditContainer("kWeaponSuperSheep")
    weapon.LifeTime = -1
    CloseContainer(lock)

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
end

function Crate_Collected()

    if Switch == 0 then
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
        
        CrateNumber = GetData("Crate.Index")
        
        if CrateNumber == 101 then
            SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
            SendMessage("CommentaryPanel.ScriptText") 
            RoundTimeRemaining = GetData("RoundTimeRemaining")
            SetData("RoundTimeRemaining", RoundTimeRemaining-5000)
            DeleteWeapon = 1
        elseif CrateNumber == 102 then
            SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
            SendMessage("CommentaryPanel.ScriptText") 
            RoundTimeRemaining = GetData("RoundTimeRemaining")
            SetData("RoundTimeRemaining", RoundTimeRemaining-5000)
             DeleteWeapon = 1
        elseif CrateNumber == 103 then
            SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
            SendMessage("CommentaryPanel.ScriptText") 
            RoundTimeRemaining = GetData("RoundTimeRemaining")
            SetData("RoundTimeRemaining", RoundTimeRemaining-5000)
            DeleteWeapon = 1
        elseif CrateNumber == 104 then
            SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
            SendMessage("CommentaryPanel.ScriptText") 
            RoundTimeRemaining = GetData("RoundTimeRemaining")
            SetData("RoundTimeRemaining", RoundTimeRemaining-5000)
            DeleteWeapon = 1
        else
            MakeNewCrate()
        end
    end
    
    if DeleteWeapon == 1 then
        lock, inventory = EditContainer("Inventory.Team00") 
        inventory.Prod = 0    
        CloseContainer(lock) -- must close the container ASAP
        
        DeleteWeapon = 0
    end
    
end

function Crate_Destroyed()
    AddTime = 1
    MakeNewCrate()
end

function MakeNewCrate()
    if EndGame == 0 then
        if AddTime == 0 then
            RoundTimeRemaining = GetData("RoundTimeRemaining")
            SetData("RoundTimeRemaining", RoundTimeRemaining + Time)
        end
    end

    if NewCrate == 1 then
        SetData("Crate.Spawn", "crate1")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 1)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 2 then
   	SetData("Crate.Spawn", "crate2")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 2)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
   	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 3 then  
        SetData("Crate.Spawn", "crate3")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 3)
        SetData("Crate.Scale", 5)
   	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 4 then
        SetData("Crate.Spawn", "crate4")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 4)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
   	SendMessage("GameLogic.CreateCrate")        
    elseif NewCrate == 5 then
   	SetData("Crate.Spawn", "crate5")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 5)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
   	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 6 then
   	SetData("Crate.Spawn", "crate6")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 6)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
   	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 7 then
        SetData("Crate.Spawn", "crate7")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 7)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 8 then
        SetData("Crate.Spawn", "crate8")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 8)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
   	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 9 then
        SetData("Crate.Spawn", "crate9")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 9)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
   	SendMessage("GameLogic.CreateCrate")      
    elseif NewCrate == 10 then
        SetData("Crate.Spawn", "crate10")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 10)
        SetData("Crate.Scale", 5)
        SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 11 then
	SetData("Crate.Spawn", "crate11")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 11)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 12 then
	SetData("Crate.Spawn", "crate11")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 12)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 13 then
	SetData("Crate.Spawn", "crate11")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 13)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 14 then
	SetData("Crate.Spawn", "crate14")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 14)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 15 then
	SetData("Crate.Spawn", "crate15")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 15)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 16 then
	SetData("Crate.Spawn", "crate16")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 16)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 17 then
	SetData("Crate.Spawn", "crate7")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 16)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 18 then
	SetData("Crate.Spawn", "crate10")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 16)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        
        NewCrate = 0
        
        if Time > 1000 then
            Time = Time - 1000
        end

    end
    
    AddTime = 0
    NewCrate = NewCrate + 1
         
end

function Worm_Died()
	    
    deadWorm = GetData("DeadWorm.Id")
    if deadWorm == 0 then
        Switch = 1
    end
end



