
   -- Mission Beanstalk

function Initialise()

bronzetime = (60 * 1000) * 999
silvertime = 160000
goldtime = 130000


evidence = 0
camdone = 0
wsafe = 0
turnnum = 0
turn = 0
wormone = 0
wormtwo = 0
wormthree = 0
Switch = 0
MyTimer = -1

   -- Sets up mines and turn time
   SetData("Mine.DudProbabilty", 0.1)
   SetData("Mine.MinFuse", 100)
   SetData("Mine.MaxFuse", 200)
   SetData("TurnTime", 99000)
   SetData("RoundTime", 0)
   SetData("Jetpack.MaxAltitude", 5500)
   SendStringMessage("Camera.Disable", "Track")
   SendMessage("GameLogic.PlaceObjects")
   SetData("HUD.Clock.DisplayRoundTime", 0)

   StartTimer("wave", 2700)

   SendMessage("EFMV.Start") 

    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")   
   
   SetupWormsAndTeams()
   SetupInventories()
   --StartFirstTurn()
   camera()
   targets()
   trigger()
end




function StartTurn()
   done_once_per_turn_functions = false
   SendMessage("Timer.StartHotSeatTimer")
   SendMessage("GameLogic.ActivateNextWorm")
   SendMessage("Weapon.Create")
   SetWind()
   TurnStarted()
   SendMessage("GameLogic.Turn.Started")
   RunAILogic()
   turnnum = turnnum + 1

   wormsdead()
   
--   Print("Turnnum in StartTurn() is ", turnnum)

end

function isitend()

--   Print("Turnnum in isitend() is ", turnnum)

	if turnnum == 1 and wormone == 0 then
            if Switch == 0 then
                SendMessage("Commentary.Clear")
                SendMessage("Commentary.NoDefault")
                
                
                SetData("CommentaryPanel.Comment", "Miss.bean.extra6")
                SendMessage("CommentaryPanel.ScriptText")
                SendMessage("GameLogic.Mission.Failure")
                Switch = 1
            end
	end

	if turnnum == 2 and wormtwo == 0 then
            if Switch == 0 then
                SendMessage("Commentary.Clear")
                SendMessage("Commentary.NoDefault")
                
                
                SetData("CommentaryPanel.Comment", "Miss.bean.extra6")
                SendMessage("CommentaryPanel.ScriptText")
                SendMessage("GameLogic.Mission.Failure")
                Switch = 1
            end
	end

	if turnnum == 3 and wormthree == 0 then
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
        
        SetData("CommentaryPanel.Comment", "Miss.bean.extra6")
        SendMessage("CommentaryPanel.ScriptText")
        SendMessage("GameLogic.Mission.Failure")

	end


	--if turnnum == 3 then

        --SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game24")
        --SendMessage("CommentaryPanel.ScriptText")

	--end
end 


function SelectRandomWind()
   SetData("Wind.Speed", 0.0)
end


function Trigger_Collected()

	TriggerIndex = GetData("Trigger.Index")
	if TriggerIndex == 1 then
        wormone = 1
        wsafe = wsafe + 1
        wormsafe()
	end
        
	if TriggerIndex == 2 then
        wormtwo = 1
        wsafe = wsafe + 1
        wormsafe()
	end        
        
        
	if TriggerIndex == 3 then
        wormthree = 1
        wsafe = wsafe + 1
        wormsafe()
	end          

end


function TurnEnded()
   isitend()
   CheckOneTeamVictory() 
end


function wormsdead()

    SendIntMessage("WormManager.GetLiveWormsOnTeam", 0)
    WormsLeftAlive = GetData("WormCount")

    if WormsLeftAlive < 3 then
        SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game25")
        SendMessage("CommentaryPanel.ScriptText")
    end

end


function wormsafe()

    if wsafe == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game20")
        SendMessage("CommentaryPanel.ScriptText")
        GameLogic_EndTurn_Immediate()
    end
    
    
    if wsafe == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game21")
        SendMessage("CommentaryPanel.ScriptText")
        GameLogic_EndTurn_Immediate()
    end
    
    
    if wsafe == 3 then
       -- if he is safe and collected all evidence
       if evidence == 15 then
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
            SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game22")
            SendMessage("CommentaryPanel.ScriptText")
            Result()
            Switch = 1
        else
            if Switch == 0 then
                FailureMessages()
                -- if he is safe but didnot collect evidence
                SendMessage("GameLogic.Mission.Failure")
                Switch = 1
            end
        end
    end
    
    if evidence < 15 then
        if Switch == 0 then
            SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game23")
            SendMessage("CommentaryPanel.ScriptText")
        end
    end

end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        Key,Lock = EditContainer("L.C.P2") --unlock Para Chall 2
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName","L.C.P2")
        end
        CloseContainer(Key)
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3                
                Key,Lock = EditContainer("L.P.Pinball") --unlock worms pinball wormapedia
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.P.Pinball")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

function trigger()

    SetData("Trigger.Spawn", "exit1")
    SetData("Trigger.Radius", 55)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", -1)
    SetData("Trigger.WormCollect", 0) 
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    
    SetData("Trigger.Spawn", "exit2")
    SetData("Trigger.Radius", 55)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", -1)
    SetData("Trigger.WormCollect", 1) 
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    
    SetData("Trigger.Spawn", "exit3")
    SetData("Trigger.Radius", 55)
    SetData("Trigger.Index", 3)
    SetData("Trigger.TeamCollect", -1)
    SetData("Trigger.WormCollect", 2)   
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    
    

end


function Crate_Collected()

    
    evidence = evidence + 1
    
    eremaining()
end


function eremaining()


if evidence == 1 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game1")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game3")
    SendMessage("CommentaryPanel.ScriptText")

end


if evidence == 2 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game4")
    SendMessage("CommentaryPanel.ScriptText")

end


if evidence == 3 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game5")
    SendMessage("CommentaryPanel.ScriptText")

end


if evidence == 4 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game6")
    SendMessage("CommentaryPanel.ScriptText")

end

if evidence == 5 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game7")
    SendMessage("CommentaryPanel.ScriptText")

end


if evidence == 6 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game8")
    SendMessage("CommentaryPanel.ScriptText")

end


if evidence == 7 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game9")
    SendMessage("CommentaryPanel.ScriptText")

end


if evidence == 8 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game10")
    SendMessage("CommentaryPanel.ScriptText")

end


if evidence == 9 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game11")
    SendMessage("CommentaryPanel.ScriptText")

end


if evidence == 10 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game12")
    SendMessage("CommentaryPanel.ScriptText")

end


if evidence == 11 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game13")
    SendMessage("CommentaryPanel.ScriptText")

end

if evidence == 12 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game14")
    SendMessage("CommentaryPanel.ScriptText")

end

if evidence == 13 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game15")
    SendMessage("CommentaryPanel.ScriptText")

end


if evidence == 14 then

    SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game16")
    SendMessage("CommentaryPanel.ScriptText")

end


if evidence == 15 then


end


end



function CheckOneTeamVictory()
   SendMessage("WormManager.GetActiveTeamCount")
   TeamCount = GetData("TeamCount")
   if TeamCount == 0 then
        if Switch == 0 then
            FailureMessages()
            -- all the teams have just snuffed it
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
      
   elseif TeamCount == 1 then
      StartTurn()
   else
      StartTurn()
   end
   
end




function targets()


     	SetData("Crate.Spawn", "targ1")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 1)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")


     	SetData("Crate.Spawn", "targ2")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 2)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")


        
      	SetData("Crate.Spawn", "targ3")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 3)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")       
        
        
       	SetData("Crate.Spawn", "targ4")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 4)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")      
        
        
        SetData("Crate.Spawn", "targ5")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")     
        
      	SetData("Crate.Spawn", "targ6")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 6)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")


     	SetData("Crate.Spawn", "targ7")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 7)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")


        
      	SetData("Crate.Spawn", "targ8")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 8)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")       
        
        
       	SetData("Crate.Spawn", "targ9")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 9)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")      
        
        
        SetData("Crate.Spawn", "targ10")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0) 
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")     

     	SetData("Crate.Spawn", "targ11")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 11)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")


     	SetData("Crate.Spawn", "targ12")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 12)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")


        
      	SetData("Crate.Spawn", "targ13")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 13)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")       
        
        
       	SetData("Crate.Spawn", "targ14")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 14)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")      
        
        
        SetData("Crate.Spawn", "targ15")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 15)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")     


end

        


function SetupWormsAndTeams()

    GM = QueryContainer("GM.GameInitData")
   -- Activate Team 0
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    --team.SfxBankName = GM.T1_Speech
    team.TeamColour = 0
    CloseContainer(lock) -- must close the container ASAP



   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
   worm.Name = GM.T1_W1_Name
   worm.SfxBankName = GM.T1_Speech
   worm.Energy = 100
   worm.Spawn = "spawn1"
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 

   -- Worm 1, Team 0
   CopyContainer("Worm.Data00", "Worm.Data01")
   lock, worm = EditContainer("Worm.Data01") 
   worm.Name = GM.T1_W2_Name
   worm.Spawn = "spawn2"
   CloseContainer(lock)

   -- Worm 2, Team 0
   CopyContainer("Worm.Data00", "Worm.Data02")
   lock, worm = EditContainer("Worm.Data02") 
   worm.Name = GM.T1_W3_Name
   worm.Spawn = "spawn3"
   CloseContainer(lock)

 
   SendMessage("WormManager.Reinitialise")

end



function SetupInventories()
   -- sets up a default container and adds our selection to it
   lock, inventory = EditContainer("Inventory.Team.Default") 
   inventory.SuperSheep = 0
   inventory.Parachute = -1
   inventory.NinjaRope = 0
   inventory.SkipGo = 0
   inventory.Surrender = 0
   CloseContainer(lock) -- must close the container ASAP


 

   -- Copies this selection into each worm


   CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   CopyContainer("Inventory.Team.Default", "Inventory.Team01")



   -- Sets up some delays
   lock, delays = EditContainer("Inventory.WeaponDelays") 

   CloseContainer(lock)

end

function camera()

SetData("Camera.Path.Knots.Position", "cam5, cam4, cam3, cam2, cam1")
SetData("Camera.Path.Knots.LookAt", "OrbitCentre, look1, look0")
SetData("Camera.Path.Loop.LookAt", 0) 
SetData("Camera.Path.Steps.Position",500)  
SetData("Camera.Path.Steps.LookAt",900)
SetData("Camera.Path.Tension.Position", -0.7)
SendMessage("Camera.Path.Start")

end



function Camera_Path_Reached_Knot()
   knot = GetData("Camera.Path.Knot")
   


    if knot == "cam5" then   
        SetData("Camera.Path.Steps.Position",350)
    
    elseif knot == "cam4" then
    
        SetData("CommentaryPanel.Comment", "Miss.bean.extra1")
        SendMessage("CommentaryPanel.ScriptText")


    elseif knot == "cam3" then   
        SetData("Camera.Path.Steps.Position",375)
        
        SetData("CommentaryPanel.Comment", "Miss.bean.extra2")
        SendMessage("CommentaryPanel.ScriptText")

    elseif knot == "cam2" then  

        SetData("Camera.Path.Steps.Position",400)
        
        SetData("CommentaryPanel.Comment", "Miss.bean.extra3")
        SendMessage("CommentaryPanel.ScriptText")
    
    elseif knot == "cam1" then
    
        WormCamera()
    
    end
    
end


function WormCamera()

    SetData("CommentaryPanel.Comment", "Miss.BoldlyNEW.game2")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "Wormcam")
    SetData("Camera.Path.Knots.LookAt", "Wormlook")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.7)
    SendMessage("Camera.Path.Start")
    
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "TurnLeft")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "TurnLeft")
    SendIntMessage("Worm.QueueAnim", 0)
    
    if camdone == 0 then
        StartTimer("WormAnim1", 200)
        StartTimer("WormAnim2", 100)
        MyTimer = StartTimer("startt", 4500)
    end

end

function WormAnim1()

    if camdone == 0 then
        SendIntMessage("Worm.ResetAnim", 1)
        SetData("Worm.ScriptAnim", "Smug1")
        SendIntMessage("Worm.QueueAnim", 1)
    end
end

function WormAnim2()
    if camdone == 0 then
        SendIntMessage("Worm.ResetAnim", 2)
        SetData("Worm.ScriptAnim", "Scared1")
        SendIntMessage("Worm.QueueAnim", 2)
    end
end

function startt()
   if MyTimer ~= -1 then 
      CancelTimer(MyTimer)
   end
   SendMessage("Commentary.Clear")
   camdone = 1
   StartFirstTurn()
   SendMessage("EFMV.End")  
end

function wave()

SendIntMessage("Worm.ResetAnim", 4)
SetData("Worm.ScriptAnim", "Wave_Right")
SendIntMessage("Worm.QueueAnim", 4)
end

function Input_SomeInput()

    if camdone == 0 then
      startt()
    end

end



--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
    
end

function SuccessMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end

end



