
--In Space No One Can Hear You Clean

function Initialise()
    bronzetime = (60 * 1000) * 999
    silvertime = 280000
    goldtime = 230000

    MakeNewCrate()
    NewCrate = 0
    turn = 0
    deadcpu = 0
    AnimTimerPlay = 0
    CameraFly = 1
    Switch = 0
  
    SetData("Crate.TrackCam", 0)
    SetData("Camera.StartOfTurnCamera","Default")
    SendMessage("EFMV.Start")

   -- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 3000)
    SetData("Mine.MaxFuse", 3000)
    SetData("TurnTime", 60000)
    SetData("RoundTime", 600000)

    SetData("Jetpack.MaxAltitude", 5500)

    SetData("Crate.Spawn", "crate_bazooka")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 2)
    SetData("Crate.Contents", "kWeaponBazooka")
    SetData("Crate.Index", 2)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
   
    SetData("Particle.DetailObject", "Spark1")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")

    SetData("Particle.DetailObject", "emitter_ParticleFireFlash")
    SetData("Particle.Name", "Part_Singleflame.xml")
    SendMessage("Particle.NewEmitter")
    
    --SendMessage("Commentary.NoDefault")
    SendMessage("GameLogic.PlaceObjects")

    SetupWormsAndTeams()
    SetupInventories()
    
    --give the worm the jetpack as default
    SetData("GameLogic.WeaponName", "kUtilityJetpack")
    SendMessage("GameLogic.RequestWeaponIndex")
    WIndex = GetData("GameLogic.WeaponIndex")
    lock, worm = EditContainer("Worm.Data00")
    worm.WeaponIndex = WIndex
    CloseContainer(lock)
    
    All()
end

function All()
    SetData("Camera.Path.Knots.Position", "AllCam2,AllCam")
    SetData("Camera.Path.Knots.LookAt", "AllLook")
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",400)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("First", 3500)
end

function First()
    SetData("CommentaryPanel.Comment", "MissClean.game1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "FirstCam2,FirstCam")
    SetData("Camera.Path.Knots.LookAt", "FirstLook")
    SetData("Camera.Path.Steps.Position",600)  
    SetData("Camera.Path.Steps.LookAt",600)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Second", 3000)
end

function Second()
    SetData("Camera.Path.Knots.Position", "SecondCam,SecondCam2")
    SetData("Camera.Path.Knots.LookAt", "SecondLook")
    SetData("Camera.Path.Steps.Position",600)  
    SetData("Camera.Path.Steps.LookAt",600)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Third", 3000)
end

function Third()
    SetData("Camera.Path.Knots.Position", "ThirdCam2,ThirdCam")
    SetData("Camera.Path.Knots.LookAt", "ThirdLook")
    SetData("Camera.Path.Steps.Position",550)  
    SetData("Camera.Path.Steps.LookAt",550)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera", 3000)
end

function camera()
    SetData("CommentaryPanel.Comment", "Miss.SpaceNEW.game2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line1Cam,Line1Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line1Look")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",0)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera2", 3000)
    
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "OverHere")
    SendIntMessage("Worm.QueueAnim", 0)
end

function camera2()
    SetData("CommentaryPanel.Comment", "Miss.SpaceNEW.game1")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Worm.ScriptAnim", "Smile2")
    SendIntMessage("Worm.QueueAnim", 0)
    
    AnimTimer = StartTimer("camera2anim", 2000)
    AnimTimerPlay = 1
    
    SetData("Camera.Path.Knots.Position", "Line2Cam")
    SetData("Camera.Path.Knots.LookAt", "Line2Look")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("speedexplode", 3200)
end

function camera2anim()
    SetData("Camera.Shake.Length",4000)
    SetData("Camera.Shake.Magnitude",0.45)
    SendMessage("Camera.ShakeStart")
    AnimTimerPlay = 0
    
    SetData("Worm.ScriptAnim", "WTF")
    SendIntMessage("Worm.QueueAnim", 0)
end

function speedexplode()
    SetData("Camera.Path.Knots.Position", "SpeedCam")
    SetData("Camera.Path.Knots.LookAt", "SpeedLook")
    SendMessage("Camera.Path.Start")
    
    AnimTimer2 = StartTimer("Bang", 0050)
    AnimTimerPlay2 = 1
    CamLoop = StartTimer("cpulaugh", 2500)
end

function Bang()
    AnimTimerPlay2 = 0
    
    StartTimer("Bang2", 0100)
    CreateExplosion("Explosion", 50, 0.35, 50, 90, 80)
    SetData("Particle.DetailObject", "ExplosionGFX")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
end

function Bang2()
    StartTimer("Bang3", 0100)
    CreateExplosion("ExplosionGFX2", 50, 0.35, 50, 90, 80)
    SetData("Particle.DetailObject", "ExplosionGFX2")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
end

function Bang3()    
    CreateExplosion("ExplosionGFX3", 50, 0.35, 50, 90, 80)
    SetData("Particle.DetailObject", "ExplosionGFX3")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
end

function cpulaugh()
    SendMessage("Camera.ShakeEnd")

    SetData("Camera.Path.Knots.Position", "LaughCam")
    SetData("Camera.Path.Knots.LookAt", "LaughLook")
    SendMessage("Camera.Path.Start")

    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Happy2")
    SendIntMessage("Worm.QueueAnim", 2)
    
    AnimTimer3 = StartTimer("playcamera2Abefore", 1700)
    AnimTimerPlay3 = 1
    StartTimer("camera2A", 2000)
end

function playcamera2Abefore()
    AnimTimerPlay3 = 0
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 0)
end

function camera2A()
    SetData("CommentaryPanel.Comment", "Miss.SpaceNEW.game3")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "Line2Cam")
    SetData("Camera.Path.Knots.LookAt", "Line2Look")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera3", 2500)
end

function camera3()
    SetData("CommentaryPanel.Comment", "Miss.SpaceNEW.game4")
    SendMessage("CommentaryPanel.ScriptText")

    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "NotMe2")
    SendIntMessage("Worm.QueueAnim", 3)
    SetData("Camera.Path.Knots.Position", "Line3Cam,Line3Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line3Look")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",400)  
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera4", 2000)
end

function camera4()
    SetData("CommentaryPanel.Comment", "Miss.SpaceNEW.game5")
    SendMessage("CommentaryPanel.ScriptText")

    SendIntMessage("Worm.ResetAnim", 4)
    SetData("Worm.ScriptAnim", "NotMe3")
    SendIntMessage("Worm.QueueAnim", 4)
    SetData("Camera.Path.Knots.Position", "Line4Cam,Line4Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line4Look")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera5", 2000)
end

function camera5()
    SetData("CommentaryPanel.Comment", "Miss.SpaceNEW.game6")
    SendMessage("CommentaryPanel.ScriptText")

    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "NotMe4")
    SendIntMessage("Worm.QueueAnim", 2)
    SetData("Worm.ScriptAnim", "JawFlap")
    SendIntMessage("Worm.QueueAnim", 2)
    SetData("Camera.Path.Knots.Position", "Line5Cam,Line5Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line5Look")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera6", 3000)
end

function camera6()
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "NotMe5")
    SendIntMessage("Worm.QueueAnim", 1)
    SetData("Worm.ScriptAnim", "Pray")
    SendIntMessage("Worm.QueueAnim", 1)
    SetData("Camera.Path.Knots.Position", "Line6Cam,Line6Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line6Look")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera7", 3000)
end

function camera7()
    SetData("CommentaryPanel.Comment", "Miss.Pack.NEW.game3")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "Line7Cam,Line7Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line7Look")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("CameraFinished", 3000)
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        CreateExplosion("Explosion", 50, 0.35, 50, 90, 80)
        CreateExplosion("ExplosionGFX2", 50, 0.35, 50, 90, 80)
        CreateExplosion("ExplosionGFX3", 50, 0.35, 50, 90, 80)
        SetData("Land.Indestructable", 1)
        CameraFly = 0
        CancelTimer(CamLoop)
	SendMessage("Commentary.Clear")
        SendMessage("EFMV.End")
        
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        
        if AnimTimerPlay == 1 then
            CancelTimer(AnimTimer)
            AnimPlayTimer = 0
        end
        
        if AnimTimerPlay2 == 1 then
            CancelTimer(AnimTimer2)
            AnimPlayTimer2 = 0
        end
        
        if AnimTimerPlay3 == 1 then
            CancelTimer(AnimTimer3)
            AnimPlayTimer3 = 0
        end
        
        StartFirstTurn()
    end
end

function CameraFinished()
    SetData("Land.Indestructable", 1)
    CameraFly = 0
    SendMessage("Commentary.Clear")
    SendMessage("EFMV.End")
    StartFirstTurn()
end
-- cameras end here

function CheckOneTeamVictory()
    TeamCount = GetData("TeamCount")
    WhichTeam = GetData("SurvivingTeamIndex")
    
    if TeamCount == 0 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 0 then
	SendMessage("Commentary.Clear")
        SuccessMessages()
        WhichAward()
    else
        --still at least 2 teams left
        StartTurn()
    end
end

function WhichAward()
    Result()
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        --  LEFT THIS IN, CAN BE USED TO UNLOCK SOMETHING
        Key,Lock = EditContainer("L.C.JP2")
        if Lock.Locked == true then
             Lock.Locked = false
            SetData("MCa.LockedName2","L.C.JP2")
        end
        CloseContainer(Key)
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3                
                Key,Lock = EditContainer("L.P.Lost")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.P.Lost")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end


function SelectRandomWind()
    -- First the speed
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    MaxWind = GetData("Wind.MaxSpeed")
    SetData("Wind.Speed", RandomNumber*MaxWind * 4 / 10)
    -- Now a direction
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    Direction = RandomNumber * 2 * 3.14
    SetData("Wind.Direction", Direction)   
end

function TurnStarted()
    SelectRandomWind()
    checkteam()

    if turn == 2 then	
        SetData("CommentaryPanel.Comment", "MissClean.game4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif turn == 8 then	
        SetData("CommentaryPanel.Comment", "MissClean.game5")
        SendMessage("CommentaryPanel.ScriptText")
    elseif turn == 22 then	
        SetData("CommentaryPanel.Comment", "MissClean.game6")
        SendMessage("CommentaryPanel.ScriptText")
    end
    
    turn=turn + 1
end

function checkteam()
-- PC: the current team value is now called CurrentTeamIndex
    Team = GetData("CurrentTeamIndex")
    if Team == 1 then
        stopteam()
    end
end

function StartFirstTurn()
    WaitUntilNoActivity = false
    SendMessage("EFMV.End")
    SendMessage("Commentary.Clear")
    SendMessage("Timer.StartGame")
    StartTurn()
end
    
function stopteam()
    SetData("GameLogic.ArtilleryMode", 1)
end

--///////////////////////////////////////////////////////////////
--//            Checks for game timing out                     //
--///////////////////////////////////////////////////////////////

function TurnEnded()

    SetData("GameLogic.ArtilleryMode", 0)
    CheckOneTeamVictory()
    
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end

end


function Crate_Collected()
    NewCrate = NewCrate + 1     
    MakeNewCrate()
end

function MakeNewCrate()
    if NewCrate == 1 then
	SetData("Crate.Spawn", "crate_Shotgun")
	SetData("Crate.Type", "Weapon")
	SetData("Crate.NumContents", 1)
	SetData("Crate.Contents", "kWeaponShotgun")
	SetData("Crate.Index", 3)
        SetData("Crate.GroundSnap", 1)
	SendMessage("GameLogic.CreateCrate")
    end
	
    if NewCrate == 2 then
	SetData("Crate.Spawn", "crate_supersheep")
	SetData("Crate.Type", "Weapon")
	SetData("Crate.NumContents", 1)
	SetData("Crate.Contents", "kWeaponSuperSheep")
	SetData("Crate.Index", 5)
        SetData("Crate.GroundSnap", 1)
	SendMessage("GameLogic.CreateCrate")
    end
	
    if NewCrate == 3 then
	SetData("Crate.Spawn", "crate_dynamite")
	SetData("Crate.Type", "Weapon")
	SetData("Crate.NumContents", 1)
	SetData("Crate.Contents", "kWeaponDynamite")
	SetData("Crate.Index", 6)
        SetData("Crate.GroundSnap", 1)
	SendMessage("GameLogic.CreateCrate")
    end
	
    if NewCrate == 4 then
	SetData("Crate.Spawn", "crate_grenade")
	SetData("Crate.Type", "Weapon")
	SetData("Crate.NumContents", 3)
	SetData("Crate.Contents", "kWeaponGrenade")
	SetData("Crate.Index", 7)
        SetData("Crate.GroundSnap", 1)
	SendMessage("GameLogic.CreateCrate")
        NewCrate = 0
    end
end

function checkteam()
-- PC: the current team value is now called CurrentTeamIndex
    Team = GetData("CurrentTeamIndex")
    if Team == 1 then
        stopteam()
    end
end
 
function stopteam()
    --SendStringMessage("Input.DisableGroup", "WormMoving")
    SetData("GameLogic.ArtilleryMode", 1)
end

--function Worm_Died()
--    deadworm = GetData("DeadWorm.Id")
--    if deadworm == 0 then
--        SendMessage("Commentary.Clear")
--        FailureMessages()
--        endmissionfail()
--    elseif deadworm == 1 or deadworm == 2 or deadworm == 3 or deadworm == 4 then
--	deadcpu = deadcpu + 1
--	if deadcpu == 4 then
--            SendMessage("Commentary.Clear")
--            SuccessMessages()
--            endmissionsuccess()
--	end
--   end
--end


function FailureMessages()
    SendMessage("Commentary.Clear")
    
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

function SuccessMessages()
    SendMessage("Commentary.Clear")
    
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end


function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Parachute = 2
    inventory.ClusterGrenade = 1
    inventory.SkipGo = -1
    inventory.Prod = -1
    inventory.FirePunch = 2
    inventory.Jetpack = -1
    CloseContainer(lock)

    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Bazooka = -1
    inventory.Grenade = 4
    inventory.ClusterGrenade = -1
    inventory.Shotgun = 1
    inventory.Uzi = 1
    inventory.SkipGo = -1
    CloseContainer(lock)
end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    -- Activate Team 0
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock) -- must close the container ASAP
    
    -- Activate Team 1
    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "Dirty"
    team.IsAIControlled = true
    team.FlagGfxName = "97"
    team.TeamColour = 1
    CloseContainer(lock)
    
    -- Worm 0, Team 0
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn1"
    worm.Energy = 150
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
    -- Worm 0, Team 1
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01")
    worm.Energy = 50
    worm.SfxBankName = "Alien"
    worm.Name = "Truffle"
    worm.Spawn = "spawn2"
    worm.TeamIndex = 1
    CloseContainer(lock)
    -- Worm 1, Team 1
    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02")
    worm.Energy = 50
    worm.SfxBankName = "Alien"
    worm.Name = "Treebus"
    worm.Spawn = "spawn3"
    worm.TeamIndex = 1
    CloseContainer(lock)
    -- Worm 2, Team 1
    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03")
    worm.Energy = 50
    worm.SfxBankName = "Alien"
    worm.Name = "Stig"
    worm.Spawn = "spawn4"
    worm.TeamIndex = 1
    CloseContainer(lock)
    -- Worm 3, Team 1
    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 50
    worm.SfxBankName = "Alien"
    worm.Name = "Mad Frank"
    worm.Spawn = "spawn5"
    worm.TeamIndex = 1
    CloseContainer(lock)

    SendMessage("WormManager.Reinitialise")
end




