
-- Mission All cooped up
function Initialise()
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Mine.DudProbabilty", 0)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SetData("TurnTime", 30000)
    SetData("RoundTime", 600000)
    
    SendMessage("EFMV.Start")

    bronzetime = (60 * 1000) * 999
    silvertime = 370000
    goldtime = 340000
    
    SetData("Crate.Spawn", "crate1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.TeamCollectable", 0)
    SetData("Crate.TeamDestructible", 10)
    SetData("Crate.NumContents", -1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "crate2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", -1)
    SetData("Crate.Contents", "kWeaponBazooka")
    SendMessage("GameLogic.CreateCrate")  
    
    SetData("Crate.Spawn", "crate3")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 25)
    SendMessage("GameLogic.CreateCrate")
        
    SetData("Crate.Spawn", "crate4")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 25)
    SendMessage("GameLogic.CreateCrate")
    
    SendStringMessage("Camera.Disable", "Track") 
    
    camdone =  0
    Spotted = 0
    blastdone = 0
    CameraTurns = 0
    Switch = 0
    nSpotted = 0
    WormCounter = 0
    
    SendMessage("GameLogic.PlaceObjects")
    SetupWormsAndTeams()
    SetupInventories()
    trigger()
    First()
end


function Worm_Died()

    deadworm = GetData("DeadWorm.Id")
    
    if deadworm == 0 or deadworm == 1 or deadworm == 2 then
    
        WormCounter = WormCounter + 1
    
    end

end

function First()
    SetData("Camera.Path.Knots.Position", "FirstCam2,FirstCam")
    SetData("Camera.Path.Knots.LookAt", "FirstLook")
    SetData("Camera.Path.Steps.Position",800)  
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start") 
    CamLoop = StartTimer("THREE", 4000)
end


function THREE()  
    SetData("CommentaryPanel.Comment", "Miss.count3")
    SetData("CommentaryPanel.Delay",1200)
    SendMessage("CommentaryPanel.TimedText")
    
    SetData("Camera.Path.Knots.Position", "ThreeCam")
    SetData("Camera.Path.Knots.LookAt", "ThreeLook")
    SetData("Camera.Path.Steps.Position",0)  
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start") 
    CamLoop = StartTimer("TWO", 1500)
end

function TWO()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.count2")
    SetData("CommentaryPanel.Delay",1200)
    SendMessage("CommentaryPanel.TimedText")
    
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "TwoCam")
    SetData("Camera.Path.Knots.LookAt", "TwoLook")
    SetData("Camera.Path.Steps.Position",0)  
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start") 
    CamLoop = StartTimer("ONE", 1500)
end

function ONE()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.count1")
    SetData("CommentaryPanel.Delay",1200)
    SendMessage("CommentaryPanel.TimedText")
    
    SetData("Camera.Path.Knots.Position", "OneCam")
    SetData("Camera.Path.Knots.LookAt", "OneLook")
    SetData("Camera.Path.Steps.Position",0)  
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start") 
    CamLoop = StartTimer("Explosion", 1800)
end

function Explosion()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.Cooped.extra1")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "ExplosionCam")
    SetData("Camera.Path.Knots.LookAt", "ExplosionLook")
    SetData("Camera.Path.Steps.Position",0)  
    SetData("Camera.Path.Steps.LookAt",0)
    SendMessage("Camera.Path.Start")

    blastdoor()
    AnimLoop = StartTimer("anims1", 400)
    AnimLoopRunning = 1
    CamLoop = StartTimer("CrateCam", 5000)
end

function blastdoor()
    CreateExplosion("blast", 0, 0, 0, 35, 0)
    SetData("Particle.DetailObject", "blast")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    blastdone = 1
end

function anims1()
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Scowl")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Scowl2")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Smile")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Wave_Left")
    SendIntMessage("Worm.QueueAnim", 0)    
    
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Scowl3")
    SendIntMessage("Worm.QueueAnim", 1)
    SetData("Worm.ScriptAnim", "Wave_Left")
    SendIntMessage("Worm.QueueAnim", 1)
    SetData("Worm.ScriptAnim", "Smug1")
    SendIntMessage("Worm.QueueAnim", 1)

    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Scowl2")
    SendIntMessage("Worm.QueueAnim", 2)
    SetData("Worm.ScriptAnim", "Wave_Right")
    SendIntMessage("Worm.QueueAnim", 2)  
    SetData("Worm.ScriptAnim", "Smug2")
    SendIntMessage("Worm.QueueAnim", 2)
    
    AnimLoopRunning = 0
end

function CrateCam()
    SetData("CommentaryPanel.Comment", "Miss.Cooped.extra2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Cooped.extra3")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "CrateCam,CrateCam2")
    SetData("Camera.Path.Knots.LookAt", "CrateLook")
    SetData("Camera.Path.Steps.Position",800)  
    SetData("Camera.Path.Steps.LookAt",0)
    SendMessage("Camera.Path.Start")
    
    CamLoop = StartTimer("camera2", 5500)
end

function camera2()
    SetData("CommentaryPanel.Comment", "Miss.Cooped.extra4")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("CommentaryPanel.Comment", "Miss.Cooped.extra5")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "cam3,cam4")
    SetData("Camera.Path.Knots.LookAt", "look2")
    SetData("Camera.Path.Steps.Position",1000)  
    SetData("Camera.Path.Steps.LookAt",0)
    --SetData("Camera.Path.Tension.Position", -0.4) 
    SendMessage("Camera.Path.Start")
    
    AnimLoop = StartTimer("anims2", 500)
    AnimLoopRunning = 1
    CamLoop = StartTimer("LookWorm", 5500)
end

function anims2()
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Asleep")
    SendIntMessage("Worm.QueueAnim", 3)
    SetData("Worm.ScriptAnim", "Bored1")
    SendIntMessage("Worm.QueueAnim", 3)

    SendIntMessage("Worm.ResetAnim", 4)
    SetData("Worm.ScriptAnim", "Bored1")
    SendIntMessage("Worm.QueueAnim", 4)
    SetData("Worm.ScriptAnim", "Asleep")
    SendIntMessage("Worm.QueueAnim", 4)

    SendIntMessage("Worm.ResetAnim", 5)
    SetData("Worm.ScriptAnim", "Bored1")
    SendIntMessage("Worm.QueueAnim", 5)
    SetData("Worm.ScriptAnim", "Asleep")
    SendIntMessage("Worm.QueueAnim", 5)
    
    AnimLoopRunning = 0
end

function LookWorm()
    SetData("CommentaryPanel.Comment", "Miss.Cooped.extra6")
    SendMessage("CommentaryPanel.ScriptText")

    SendIntMessage("Worm.ResetAnim", 6)
    SetData("Worm.ScriptAnim", "Yawn")
    SendIntMessage("Worm.QueueAnim", 6)
    
    SetData("Camera.Path.Knots.Position", "LookWormCam")
    SetData("Camera.Path.Knots.LookAt", "LookWormLook")
    SetData("Camera.Path.Steps.Position",0)  
    SetData("Camera.Path.Steps.LookAt",0)
    SendMessage("Camera.Path.Start")
    
    CamLoop = StartTimer("CameraFinished", 3000)
end

function CameraFinished()
    SendStringMessage("Camera.Enable", "Track")
    camdone =  1
    StartFirstTurn()
    SendMessage("EFMV.End")
end

function Camera_Path_Stopped()
    if camdone == 0 then
        if blastdone == 0 then
            CreateExplosion("blast", 0, 0, 0, 35, 0)
        end
        
        if AnimLoopRunning == 1 then
            CancelTimer(AnimLoopRunning)
            AnimLoopRunning = 0
        end
        
        camdone =  1
        SendStringMessage("Camera.Enable", "Track")
        SendMessage("EFMV.End")
        CancelTimer(CamLoop)
        StartFirstTurn()
    end
end
-- cameras end here
function SelectRandomWind()
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    MaxWind = GetData("Wind.MaxSpeed")
    SetData("Wind.Speed", RandomNumber*MaxWind * 6 /10)

    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    Direction = RandomNumber * 2 * 3.14
    SetData("Wind.Direction", Direction)   
end

function SpottedWorm()
    SendMessage("Commentary.Clear")
    ArmCPU()
    Spotted = 1
    
    SetData("GameLogic.ArtilleryMode", 1)
    SendMessage("GameLogic.RoundTime.Pause")
    SendMessage("GameLogic.TurnTime.Pause")
    SendStringMessage("Camera.Disable", "Track")
    SendMessage("EFMV.Start")
    SpottedCamStart1()
end

function SpottedCamStart1()
    SendIntMessage("Worm.ResetAnim", 6)
    SetData("Worm.ScriptAnim", "WTF")
    SendIntMessage("Worm.QueueAnim", 6)
    
    SetData("Camera.Path.Knots.Position", "SpottedCam")
    SetData("Camera.Path.Knots.LookAt", "SpottedLook")
    SetData("Camera.Path.Steps.Position",0)  
    SetData("Camera.Path.Steps.LookAt",0)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    
    StartTimer("SpottedCamStart2", 1500)
end

function SpottedCamStart2()
    SendIntMessage("Worm.ResetAnim", 6)
    SetData("Camera.Path.Knots.Position", "TwoCam")
    SetData("Camera.Path.Knots.LookAt", "TwoLook")
    SetData("Camera.Path.Steps.Position",0)  
    SetData("Camera.Path.Steps.LookAt",0) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start") 
    StartTimer("SpottedCamStart3", 1300)
end

function SpottedCamStart3()
    SetData("CommentaryPanel.Comment", "misscooped.game1")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "InGameCam")
    SetData("Camera.Path.Knots.LookAt", "InGameLook")
    SetData("Camera.Path.Steps.Position",0)  
    SetData("Camera.Path.Steps.LookAt",0)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    
    SendIntMessage("Worm.ResetAnim", 7)
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 7)
    SetData("Worm.ScriptAnim", "Scowl2")
    SendIntMessage("Worm.QueueAnim", 7)
    
    StartTimer("SpottedCamEnd", 2500)
end

function SpottedCamEnd()
    SetData("GameLogic.ArtilleryMode", 0)
    SendMessage("GameLogic.RoundTime.Resume")
    SendMessage("GameLogic.TurnTime.Resume")
    SendStringMessage("Camera.Enable", "Track")
    SendMessage("EFMV.End")
    SendMessage("Camera.SetDefault")
end

function TurnStarted()
    Team = GetData("CurrentTeamIndex")
    if Team == 1 and Spotted == 0 then
        SetData("GameLogic.ArtilleryMode", 1)
    end
end

function TurnEnded()

    RoundTimeRemaining = GetData("RoundTimeRemaining")
    
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end

    if Switch == 0 then
        Team = GetData("CurrentTeamIndex")
        SetData("GameLogic.ArtilleryMode", 0)
        
        if Team == 0 then
            CameraTurns = CameraTurns + 1
        end
        
        if Spotted == 0 and Team == 0 and CameraTurns == 1 then
            if WormCounter == 3 then
                CheckOneTeamVictory()
            else
                NotSpotted()
            end
        elseif Spotted == 0 and Team == 0 and CameraTurns == 3 then
            if WormCounter == 3 then
                CheckOneTeamVictory()
            else
                NotSpotted()
            end
        elseif Spotted == 0 and Team == 0 and CameraTurns == 5 then
            if WormCounter == 3 then
                CheckOneTeamVictory()
            else
                NotSpotted()
            end
        elseif Spotted == 0 and Team == 0 and CameraTurns == 7 then
            if WormCounter == 3 then
                CheckOneTeamVictory()
            else
                NotSpotted()
            end
        elseif Spotted == 0 and Team == 0 and CameraTurns == 9 then
            if WormCounter == 3 then
                CheckOneTeamVictory()
            else
                NotSpotted()
            end
        else
            CheckOneTeamVictory()
        end
    end
end 

function NotSpotted()
    SendMessage("GameLogic.RoundTime.Pause")
    SendMessage("GameLogic.TurnTime.Pause")
    SendStringMessage("Camera.Disable", "Track")
    SendMessage("EFMV.Start")
    NotSpottedCam()
end

function NotSpottedCam()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.Helter.game8")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "AroundCam,AroundCam2")
    SetData("Camera.Path.Knots.LookAt", "AroundLook")
    SetData("Camera.Path.Steps.Position",1000)  
    SetData("Camera.Path.Steps.LookAt",0)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    
    StartTimer("NotSpottedCamEnd", 4000)
end

function NotSpottedCamEnd()
    SendMessage("GameLogic.RoundTime.Resume")
    SendMessage("GameLogic.TurnTime.Resume")
    SendStringMessage("Camera.Enable", "Track")
    SendMessage("EFMV.End")
    CheckOneTeamVictory()
end

function trigger()
    SetData("Trigger.Spawn", "trigger1")
    SetData("Trigger.Radius", 230)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
end

function Trigger_Collected()
    TriggerIndex = GetData("Trigger.Index")
    if TriggerIndex == 1 then
        if Spotted == 0 then
            SpottedWorm()
        end
    end
end

function Crate_Collected()
    if Spotted == 0 then
        SendIntMessage("GameLogic.DestroyTrigger", 1)
        SpottedWorm()
    end
end

function FailureMessages()
    SendMessage("Commentary.Clear")
    
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

function SuccessMessages()
    SendMessage("Commentary.Clear")
    
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

function CheckOneTeamVictory()
    TeamCount = GetData("TeamCount")
    WhichTeam = GetData("SurvivingTeamIndex")
    if TeamCount == 0 then
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 0 then
        Switch = 1
        SuccessMessages()
        Result()
    else
        StartTurn()
    end
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()

    SetData("Camera.Path.IgnoreInput", 1)
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
 
        if timetook < silvertime then
            Movie = 2
            Key,Lock = EditContainer("L.P.Sally")
            if Lock.Locked == true then
                Lock.Locked = false
                SetData("MCa.LockedName2","L.P.Sally")
            end     
            CloseContainer(Key)
        
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.L.Cooped")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Cooped")
                end
                CloseContainer(Key)
            end
        end
    end
        
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end



function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")

    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)
    
    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "Wardens"
    team.TeamColour = 1
    team.FlagGfxName = "67"
    team.IsAIControlled = true
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 75
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "HumanWorm1"
    CloseContainer(lock) 

    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.Energy = 60
    worm.Spawn = "HumanWorm2"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GM.T1_W3_Name
    worm.Energy = 60
    worm.Spawn = "HumanWorm3"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 80 
    worm.Name = "Village Idiot"
    worm.TeamIndex = 1
    worm.SfxBankName = "Capone"
    worm.Spawn = "CPUWorm1"
    CopyContainer("AIParams.CPU1", "AIParams.Worm04")
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    worm.Energy = 80      
    worm.Name = "Dim Worm"
    worm.Spawn = "CPUWorm2"
    CopyContainer("AIParams.CPU2", "AIParams.Worm05")    
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    worm.Energy = 80  
    worm.Name = "Mr Mediocre"
    worm.Spawn = "CPUWorm3"
    CopyContainer("AIParams.CPU3", "AIParams.Worm06")    
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    worm.Energy = 80  
    worm.Name = "Hot Shot"
    worm.Spawn = "CPUWorm4"
    CopyContainer("AIParams.CPU4", "AIParams.Worm06")  
    CloseContainer(lock)
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.SkipGo = -1
    inventory.Prod = -1
    CloseContainer(lock)
    
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.SkipGo = -1
    CloseContainer(lock)
end

function ArmCPU()
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Bazooka = -1
    inventory.Grenade = 2
    inventory.ClusterGrenade = 2
    inventory.Dynamite = -1
    inventory.FirePunch = -1
    inventory.Jetpack = 2
    inventory.SkipGo = -1
    CloseContainer(lock)
end
