
-- Cratefun 

function Initialise()
    SendMessage("Commentary.NoDefault")
    SendStringMessage("Camera.Disable", "Track")        

    NewCrate = 1
    camdone = 0
    Switch = 0
    ExtraFuel = 10000
    EndGame = 0
    Time = 7000

    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 3000)
    SetData("Mine.MaxFuse", 4000)
    SetData("HotSeatTime", 0)

    RoundTimeRemaining = 0
    SetData("RoundTime", RoundTimeRemaining) 

    SetData("Camera.StartOfTurnCamera","Default")
    SetData("TurnTime", 0)
    SetData("RoundTime", 60000)
    SendMessage("HUD.HideTurnTime")
    SetData("Jetpack.InitFuel", 10000)
    SendMessage("EFMV.Start") 

    SetData("Land.Indestructable", 1)

    SendMessage("GameLogic.PlaceObjects")
    MakeNewCrate()

    SetupWormsAndTeams()
    SetupInventories()
    Camera()    
end

function Weapon_PoweringUpStart()
end

function Weapon_Fired_Start()
end

function Weapon_Fired_End()
end

function Timer_GameTimedOut()
    Switch = 1
    DeleteWeapon = 1
    
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")

    SetData("CommentaryPanel.Comment", "Chall.Generic.Win3")
    SendMessage("CommentaryPanel.ScriptText")
    
    Result()
end

function TurnEnded()
    Result()
end

function Worm_Died()
    deadWorm = GetData("DeadWorm.Id")
    if deadWorm == 0 then
        Switch = 1
        SendMessage("Commentary.Clear")
        SetData("CommentaryPanel.Comment", "Chall.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText") 
    end
end

function SelectRandomWind()
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", 0.1*MaxWind)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", 3.3) 
end

function MakeNewCrate()
    if EndGame == 0 then
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining + Time)
    end

    if NewCrate == 1 then
	SetData("Crate.Spawn", "crate1")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 1)
        SetData("Crate.Scale", 2.6)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 2 then
	SetData("Crate.Spawn", "crate2")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 2)
        SetData("Crate.Scale", 2.4)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 3 then
	SetData("Crate.Spawn", "crate3")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 3)
        SetData("Crate.Scale", 2.3)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 4 then
	SetData("Crate.Spawn", "crate4")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 4)
        SetData("Crate.Scale", 2.2)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 5 then
	SetData("Crate.Spawn", "crate5")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 5)
        SetData("Crate.Scale", 2.1)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 6 then
	SetData("Crate.Spawn", "crate6")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 6)
        SetData("Crate.Scale", 2)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 7 then
	SetData("Crate.Spawn", "crate7")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 7)
        SetData("Crate.Scale", 1.9)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 8 then
	SetData("Crate.Spawn", "crate8")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 8)
        SetData("Crate.Scale", 1.8)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 9 then
	SetData("Crate.Spawn", "crate9")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 9)
        SetData("Crate.Scale", 1.7)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 10 then
	SetData("Crate.Spawn", "crate10")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 1.7)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 11 then
	SetData("Crate.Spawn", "crate11")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 11)
        SetData("Crate.Scale", 1.6)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 12 then
	SetData("Crate.Spawn", "crate12")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 12)
        SetData("Crate.Scale", 1.5)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 13 then
	SetData("Crate.Spawn", "crate13")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 13)
        SetData("Crate.Scale", 1.4)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 14 then
	SetData("Crate.Spawn", "crate14")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 14)
        SetData("Crate.Scale", 1.3)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 15 then
	SetData("Crate.Spawn", "crate15")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 15)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)

        NewCrate = 0
        
        if Time > 1000 then
            Time = Time - 1000
        end
        
        if ExtraFuel == 10000 then
            ExtraFuel = 7500
        elseif ExtraFuel == 7500 then
            ExtraFuel = 5000
        end
    end
    
    NewCrate = NewCrate + 1
end

function anims()
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "SkipGo")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Smile")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Wave_Right")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Smile2")
    SendIntMessage("Worm.QueueAnim", 0)   
    SetData("Worm.ScriptAnim", "Smile3")
    SendIntMessage("Worm.QueueAnim", 0)  
end

function Camera()
    CameraFly = 1
    FunLoop = StartTimer("Thext1", 4000)
    CamLoop = StartTimer("Thext2", 11000)

    SetData("Camera.Path.Knots.Position", "cam1,cam2,cam3")
    SetData("Camera.Path.Knots.LookAt", "look1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",700)  
    SetData("Camera.Path.Steps.LookAt",750)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    FunLoop2 = StartTimer("anims", 5500)
end

function Thext1()
    SetData("CommentaryPanel.Comment", "Chall.jet1.extra1")
    SendMessage("CommentaryPanel.ScriptText")
end

function Thext2()
    SetData("CommentaryPanel.Comment", "Chall.jet1.extra2")
    SendMessage("CommentaryPanel.ScriptText")
end

function Camera_Path_Reached_Knot()
    knot = GetData("Camera.Path.Knot")
    if knot == "cam3" then 
        StartTimer("endy", 1750)
    end
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        CameraFly = 0
        CancelTimer(CamLoop)
        CancelTimer(FunLoop)
        CancelTimer(FunLoop2)
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        endy()
    end
end

function endy()
    SendIntMessage("Worm.ResetAnim", 0)
    camdone =  1
    StartFirstTurn()
    SendMessage("EFMV.End") 
end

function Crate_Collected()
    if Switch == 0 then
        SetData("CommentaryPanel.Comment", "missrum.game5")
        SendMessage("CommentaryPanel.ScriptText") 
        MakeNewCrate()
    end
end

function Crate_Destroyed()
    if Switch == 0 then
        MakeNewCrate()
    end
end

function Result()
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
    SendMessage("CommentaryPanel.ScriptText") 

    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
    timetook = GetData("ElapsedRoundTime")
    goldtime = GetData("MCa.BestGold")
    silvertime = GetData("MCa.BestSilver")
    bronzetime = GetData("MCa.BestBronze")

    if timetook > bronzetime then
        Movie = 1
        if timetook > silvertime then
            Movie = 2
            if timetook > goldtime then
                Movie = 3

                Key,Lock = EditContainer("L.L.Cratefun")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Cratefun")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Challenge.Result")
end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
   
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 1
    worm.Spawn = "spawn1"
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
 
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Jetpack = 1
    CloseContainer(lock)
end
