
-- Mission crust - collect all 3 health crates and kill enemy

function Initialise()

    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 4
    goldtime = (60 * 1000) * 3

    camdone =  0
    numberofvitals = 0
    SunkCrate = 0
    Interrupt = 0
    
    PID1 = 99
    PID2 = 99
    PID1 = 99
    
    Switch = 99
    Switch2 = 0
    
    WormDead = 99
    DeadWormCounter = 0

    SendStringMessage("Camera.Disable", "Track")
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")
    

-- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0)
    SetData("Mine.MinFuse", 4000)
    SetData("Mine.MaxFuse", 5000)
    SetData("TurnTime", 35000)
    SetData("RoundTime", 1000000)
    SetData("Jetpack.InitFuel", 20000)
    
    SetData("Crate.Spawn", "vital1")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 25)
    SetData("Crate.TeamCollectable", 0)
    SetData("Crate.Index", 1)
    SendMessage("GameLogic.CreateCrate")

    SetData("Crate.Spawn", "vital2")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 25)
    SetData("Crate.TeamCollectable", 0)        
    SetData("Crate.Index", 2)   
    SendMessage("GameLogic.CreateCrate")
        
    SetData("Crate.Spawn", "vital3")
    SetData("Crate.Type", "Health")
    SetData("Crate.Index", 3)
    SetData("Crate.TeamCollectable", 0)        
    SendMessage("GameLogic.CreateCrate")        
  
    SendMessage("GameLogic.PlaceObjects")
    
    SendMessage("EFMV.Start")
    
    Sparkle_Particles()
    SetupWormsAndTeams()
    SetupInventories()
    --StartFirstTurn()
    camera()
    StartTimer("anims", 1000)
    
    
end


function Sparkle_Particles()

    SetData("Particle.DetailObject", "sparkle1")
    SetData("Particle.Name", "Part_StarBridge")
    SendMessage("Particle.NewEmitter")
    PID1 = GetData("Particle.Handle")
    
    SetData("Particle.DetailObject", "sparkle2")
    SetData("Particle.Name", "Part_StarBridge")
    SendMessage("Particle.NewEmitter")
    PID2 = GetData("Particle.Handle")
    
    SetData("Particle.DetailObject", "sparkle3")
    SetData("Particle.Name", "Part_StarBridge")
    SendMessage("Particle.NewEmitter")
    PID3 = GetData("Particle.Handle")
end

--////////////////////////////////////////////////////////
--//            Check Crates                            //
--////////////////////////////////////////////////////////

function Worm_Died()
    WormDead = GetData("DeadWorm.Id")
    
    if WormDead == 4 or WormDead == 5 or WormDead == 6 or WormDead == 7 then
        DeadWormCounter = DeadWormCounter + 1
    end
end

function Crate_Collected()
    Switch = GetData("Crate.Index")
    
    if Switch == 1 then
        SendIntMessage("Particle.DeleteEmitter", PID1)
    elseif Switch == 2 then
        SendIntMessage("Particle.DeleteEmitter", PID2)
    elseif Switch == 3 then
        SendIntMessage("Particle.DeleteEmitter", PID3)
    end
    
    SetData("CommentaryPanel.Comment", "missCrust.game1")
    SendMessage("CommentaryPanel.ScriptText")
    checkvitals()
end

function Crate_Destroyed()

    VitalNumber = GetData("Crate.Index")
    
    if VitalNumber == 1 then
        SendIntMessage("Particle.DeleteEmitter", PID1)
    
    elseif VitalNumber == 2 then
        SendIntMessage("Particle.DeleteEmitter", PID2)
    
    elseif VitalNumber == 3 then
        SendIntMessage("Particle.DeleteEmitter", PID3)
    end
    
    if Switch2 == 0 then
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
        
        SetData("CommentaryPanel.Comment", "missCrust.game2")
        SendMessage("CommentaryPanel.ScriptText")
        
        SendMessage("GameLogic.Mission.Failure")
        Switch2 = 1
    end
    
end


function Crate_Sunk()

    SunkCrate = GetData("Crate.Index")
    
    if SunkCrate == 1 or SunkCrate == 2 or SunkCrate == 3 then
        if Switch2 == 0 then
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
        
            SetData("CommentaryPanel.Comment", "missCrust.game2")
            SendMessage("CommentaryPanel.ScriptText")
        
            SendMessage("GameLogic.Mission.Failure")
            Switch2 = 1
        end
    end
    
    if SunkCrate == 1 then
        SendIntMessage("Particle.DeleteEmitter", PID1)
    
    elseif SunkCrate == 2 then
        SendIntMessage("Particle.DeleteEmitter", PID2)
    
    elseif SunkCrate == 3 then
        SendIntMessage("Particle.DeleteEmitter", PID3)
    end
    
end


function checkvitals()

    VitalNumber = GetData("Crate.Index")
    if VitalNumber == 1 then
        numberofvitals = numberofvitals + 1
    end

    if VitalNumber == 2 then
        numberofvitals = numberofvitals + 1
    end
    
    if VitalNumber == 3 then 
        numberofvitals = numberofvitals + 1
    end
    
    if DeadWormCounter == 4 and numberofvitals == 3 then
        if Switch2 == 0 then
            SuccessMessages()
            WONWON()
            Switch2 = 1
        end
    end
end


--//////////////////////////////////////////////////////////
--//            Add particles and player anims            //
--//////////////////////////////////////////////////////////


function anims()
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Taunt1")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Taunt1")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Taunt1")
    SendIntMessage("Worm.QueueAnim", 0)


    SendIntMessage("Worm.ResetAnim", 6)
    SetData("Worm.ScriptAnim", "Taunt2")
    SendIntMessage("Worm.QueueAnim", 6)
    SetData("Worm.ScriptAnim", "Taunt2")
    SendIntMessage("Worm.QueueAnim", 6)
    SetData("Worm.ScriptAnim", "Taunt2")
    SendIntMessage("Worm.QueueAnim", 6)        
        
    SetData("Particle.DetailObject", "BirdSky1")
    SetData("Particle.Name", "Part_BirdSky")
    SendMessage("Particle.NewEmitter")     
end

--//////////////////////////////////////////////////
--//            Randomise wind                    //
--//////////////////////////////////////////////////

function SelectRandomWind()
-- First the speed
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    MaxWind = GetData("Wind.MaxSpeed")
    SetData("Wind.Speed", RandomNumber*MaxWind * 6 /10)
-- Now a direction
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    Direction = RandomNumber * 2 * 3.14
    SetData("Wind.Direction", Direction)   
end

--//////////////////////////////////////////////////
--//            Setup worms and inventories       //
--//////////////////////////////////////////////////


function SetupWormsAndTeams()

    GM = QueryContainer("GM.GameInitData")
-- Activate Team 0
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
   -- team.SfxBankName = GM.T1_Speech
    team.TeamColour = 0
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    CloseContainer(lock) -- must close the container ASAP
    
-- Activate Team 1
    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "Dirty Thieves"
    team.IsAIControlled = true
    team.TeamColour = 1
    team.FlagGfxName = "72"
    CloseContainer(lock)    

    -- Worm 0, Team 0
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "spawn1"
    
    CloseContainer(lock) 

-- Worm 1, Team 0
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.Spawn = "spawn2"
    CloseContainer(lock)
    
-- Worm 1, Team 0
    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GM.T1_W3_Name
    worm.Spawn = "spawn7"
    CloseContainer(lock)

-- Worm 4, Team 1
    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    CopyContainer("AIParams.CPU2", "AIParams.Worm04")
    worm.Energy = 65 
    worm.TeamIndex = 1
    worm.Name = "Number 2"
    worm.SfxBankName = "Madchester"
    worm.Spawn = "spawn3"
    CloseContainer(lock)
    
-- Worm 5, Team 1
    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    CopyContainer("AIParams.CPU2", "AIParams.Worm05")
    worm.Energy = 85 
    worm.Name = "Boggy Pete"
    worm.SfxBankName = "Super Villain"
    worm.Spawn = "spawn4"
    CloseContainer(lock)
    
-- Worm 6, Team 1
    CopyContainer("Worm.Data04", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    CopyContainer("AIParams.CPU2", "AIParams.Worm06")
    worm.Energy = 65  
    worm.Name = "Crony"
    worm.Spawn = "spawn5"
    CloseContainer(lock)
    
-- Worm 7, Team 1
    CopyContainer("Worm.Data04", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    CopyContainer("AIParams.CPU2", "AIParams.Worm07")
    worm.Energy = 65  
    worm.Name = "Henchman"
    worm.Spawn = "spawn6"
    CloseContainer(lock)
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
-- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Bazooka = -1
    inventory.Grenade = -1
    inventory.ClusterGrenade = 1
    inventory.Airstrike = 0
    inventory.Dynamite = 0
    inventory.HolyHandGrenade = 0
    inventory.BananaBomb = 0
    inventory.Landmine = 0
    inventory.HomingMissile = 0
    inventory.HomingPidgeon = 0
    inventory.Sheep = 0
    inventory.SuperSheep = 0
    inventory.Parachute = 0
    inventory.Teleport = 0
    inventory.Jetpack = 3
    inventory.MadCow = 0
    inventory.OldWoman = 0
    inventory.Girder = 0
    inventory.BridgeKit = 0
    inventory.Shotgun = 0
    inventory.Uzi = 0
    inventory.NuclearBomb = 0
    inventory.GasCanister = 0
    inventory.NinjaRope = 0
    inventory.FirePunch = -1
    inventory.LowGravity = 0
    inventory.Freeze = 0
    inventory.QuickWalk = 0
    inventory.Prod = 0
    inventory.SkipGo = -1
  
    
    CloseContainer(lock) -- must close the container ASAP

-- Copies this selection into each worm
    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
    CopyContainer("Inventory.Team.Default", "Inventory.Team01")
   
   

    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Shotgun = -1
    inventory.Uzi = 1
    inventory.Jetpack = 0
    CloseContainer(lock)
end


--////////////////////////////////////////////////////////
--//            Check team conditions                   //
--////////////////////////////////////////////////////////

function CheckOneTeamVictory()
   SendMessage("WormManager.GetActiveTeamCount")
   TeamCount = GetData("TeamCount")
   SendMessage("WormManager.GetSurvivingTeam")
   WinningTeam = GetData("SurvivingTeamIndex")

   if TeamCount == 0 then
        -- all the teams have just snuffed it
        if Switch2 == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch2 = 1
        end
        
   elseif TeamCount == 1 and numberofvitals == 3 and WinningTeam == 0 then
        -- only one team remains
        -- PC: changed this call to catch naughty use of GetActiveTeamIndex usage. Use the new 
        -- call to get the last team with a worm thats alive on it.
        SendMessage("WormManager.GetSurvivingTeam")
        WinningTeam = GetData("SurvivingTeamIndex")
        
        SuccessMessages()
        WONWON()
      
    elseif TeamCount == 1 and WinningTeam == 1 then
        if Switch2 == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch2 = 1
        end
    else
        -- still at least 2 teams left
        StartTurn()
   end
   
end

function WONWON()

    Result()

end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.L.Crust")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Crust")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end


--////////////////////////////////////////////////////////
--//            Set up cameras                          //
--////////////////////////////////////////////////////////


function camera()


    SetData("Camera.Path.Knots.Position", "cam1,cam2,cam3,cam4")
    SetData("Camera.Path.Knots.LookAt", "look1,look2,look4,look5")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",470)  
    SetData("Camera.Path.Steps.LookAt",625)
    SetData("Camera.Path.Tension.Position", -0.4) 
    SendMessage("Camera.Path.Start")
    
    StartTimer("FirstMessage", 500)
    
end


function Camera_Path_Reached_Knot()

    knot = GetData("Camera.Path.Knot")
    

    if knot == "cam2" then
    
        SetData("CommentaryPanel.Comment", "Miss.crust.extra2")
        SendMessage("CommentaryPanel.ScriptText")
        
    end
    
    if knot == "cam3" then
    
        SetData("CommentaryPanel.Comment", "Miss.Generic.Hint2")
        SendMessage("CommentaryPanel.ScriptText")
        
    end
    
    if knot == "cam4" then
    
        SendIntMessage("Worm.ResetAnim", 2)
        SetData("Worm.ScriptAnim", "Taunt2")
        SendIntMessage("Worm.QueueAnim", 2)
        SetData("Worm.ScriptAnim", "Taunt2")
        SendIntMessage("Worm.QueueAnim", 2)
        SetData("Worm.ScriptAnim", "Taunt2")
        SendIntMessage("Worm.QueueAnim", 2)
    
        WormCam1()
    
    end
    
    
    if knot == "cam7" then

        SendIntMessage("Worm.ResetAnim", 1)
        SetData("Worm.ScriptAnim", "Idle_1_Yawn")
        SendIntMessage("Worm.QueueAnim", 1)
        SetData("Worm.ScriptAnim", "Idle_1_Yawn")
        SendIntMessage("Worm.QueueAnim", 1)
        SetData("Worm.ScriptAnim", "Idle_1_Yawn")
        SendIntMessage("Worm.QueueAnim", 1)
    
        WormCam2()

    end
    
    
    if knot == "OrbitStart" then
    
        startt()
      
    end
   
end

function FirstMessage()

    if Interrupt == 0 then
        SetData("CommentaryPanel.Comment", "Miss.crust.extra1a")
        SendMessage("CommentaryPanel.ScriptText")
    end

end

function WormCam1()

        SetData("Camera.Path.Knots.Position", "Wormcam1")
        SetData("Camera.Path.Knots.LookAt", "Wormlook1")
        SetData("Camera.Path.Loop.LookAt", 0) 
        SendMessage("Camera.Path.Start")
        
        SetData("CommentaryPanel.Comment", "Miss.MovieNEW.game4")
        SendMessage("CommentaryPanel.ScriptText")
        
        
        StartTimer("CrateCam", 3500)
end


function WormCam2()

    if Interrupt == 0 then
        SetData("Camera.Path.Knots.Position", "Wormcam2")
        SetData("Camera.Path.Knots.LookAt", "Wormlook2")
        SetData("Camera.Path.Loop.LookAt", 0) 
        SendMessage("Camera.Path.Start")
        
        SetData("CommentaryPanel.Comment", "Miss.MovieNEW.game2")
        SendMessage("CommentaryPanel.ScriptText")
        
        StartTimer("EndCam", 4000)
        
    end
        
end

function CrateCam()

    if Interrupt == 0 then
    
        SetData("Camera.Path.Knots.Position", "cam5, cam6, cam7")
        SetData("Camera.Path.Knots.LookAt", "look5, look6")
        SetData("Camera.Path.Loop.LookAt", 0) 
        SetData("Camera.Path.Steps.Position",250)  
        SetData("Camera.Path.Steps.LookAt",555)
        SetData("Camera.Path.Tension.Position", -0.4) 
        SendMessage("Camera.Path.Start")
    
        SetData("CommentaryPanel.Comment", "Miss.Generic.Hint4")
        SendMessage("CommentaryPanel.ScriptText")
    end
        
end


function EndCam()

    if Interrupt == 0 then

        SetData("Camera.Path.Knots.Position", "cam7, OrbitStart")
        SetData("Camera.Path.Knots.LookAt", "look6, Cratelook1")
        SetData("Camera.Path.Loop.LookAt", 0) 
        SetData("Camera.Path.Steps.Position",470)  
        SetData("Camera.Path.Steps.LookAt",625)
        SetData("Camera.Path.Tension.Position", -0.4) 
        SendMessage("Camera.Path.Start")
    
        StartTimer("GameOnMessage", 2000)
        
    end

end

function GameOnMessage()
    SetData("CommentaryPanel.Comment", "Chall.Sheep3.Intro8")
    SendMessage("CommentaryPanel.ScriptText")
end


--////////////////////////////////////////////////////
--//            Check for turns                     //
--////////////////////////////////////////////////////

function startt()
    StartFirstTurn()
    SendMessage("EFMV.End")    
    SendStringMessage("Camera.Enable", "Track")
end


function Camera_Path_Stopped()

    SendMessage("Commentary.Clear")
    SendIntMessage("Worm.ResetAnim", 0)
    
    if camdone == 0 then
        camdone =  1
        Interrupt = 1
        StartFirstTurn()
        SendMessage("EFMV.End")        
        SendStringMessage("Camera.Enable", "Track")
    end

end


--////////////////////////////////////////////////
--// fail mission when timer runs out           //
--////////////////////////////////////////////////


function TurnEnded()

    SetData("GameLogic.ArtilleryMode", 0)
    CheckOneTeamVictory()
    
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch2 == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch2 = 1
        end
    end

end

--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
    
end

function SuccessMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end

end






