
-- Jeggetts test level 

function Initialise()


-- Sets up mines and turn time
   SetData("Mine.DudProbabilty", 0.1)
   SetData("Mine.MinFuse", 3000)
   SetData("Mine.MaxFuse", 4000)
   SetData("HotSeatTime", 0) -- no hotseat time
   SetData("RoundTime", 0) -- no Game timer
   SetData("TurnTime", 0) -- no game timer

   SendMessage("EFMV.Start")

   SendMessage("GameLogic.PlaceObjects")





    SetupWormsAndTeams()
    SetupInventories()
    --StartFirstTurn()
    camera()





end
function Weapon_PoweringUpStart()
end

function Weapon_Fired_Start()
end

function Weapon_Fired_End()
end



-- /////////////////////////////////////////////////////////////






function TurnEnded()
   SendMessage("WormManager.GetActiveTeamCount")
   TeamCount = GetData("TeamCount")
   if TeamCount == 0 then
      -- all the worms have just snuffed it
      
       lock, worm = EditContainer("Worm.Data00") 
       worm.Active = true
       worm.Name = GetData ("User.HumanWorm1")
       worm.Energy = 100
       worm.Spawn = "Spawn1"
       worm.WeaponFuse = 3
       worm.WeaponIsBounceMax = false
       worm.TeamIndex = 0
       CloseContainer(lock) 
      
    SendIntMessage("Worm.Respawn", 00)
    StartTurn()
    dietext()
    
   else
      -- still at least some worms left
      StartTurn()
   end
end






-- //////////////////////////////////////////////////////////////////

function SetupWormsAndTeams()

   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
   team.Name = GetData("User.HumanTeamName")
   team.TeamColour = 0
   CloseContainer(lock) -- must close the container ASAP



   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
   worm.Name = GetData ("User.HumanWorm1")
   worm.Energy = 100
   worm.Spawn = "Spawn1"
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 
 

   SendMessage("WormManager.Reinitialise")

end

-- //////////////////////////////////////////////////////////////////

function SetupInventories()
    -- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Jetpack = -1
    CloseContainer(lock) -- must close the container ASAP

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   
end



-- ///////////////////////////////////////////////////////////////////



-- //////////////////////////////////////////////////////////////////////


function SelectRandomWind()
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", 0.1*MaxWind)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", 3.3) 

end


     
     








function anims()


    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Smug1")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Smug1")
    SendIntMessage("Worm.QueueAnim", 0) 
    SetData("Worm.ScriptAnim", "Smug1")
    SendIntMessage("Worm.QueueAnim", 0) 
    
   
   
end






function camera()

    SetData("Camera.Path.Knots.Position", "cam1,cam2")
    SetData("Camera.Path.Knots.LookAt", "look1,look2")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",850)  
    SetData("Camera.Path.Steps.LookAt",850)
    SetData("Camera.Path.Tension.Position", 0.5) 
    SendMessage("Camera.Path.Start")
    StartTimer("anims", 2500)
    
end



function Camera_Path_Reached_Knot()
   knot = GetData("Camera.Path.Knot")
   
 
 
-- ends camera   
   
   if knot == "cam2" then 
   
   StartTimer("shockfirst", 3400)   
   
   StartTimer("shocked", 3900)
   

          
   end


end


function shockfirst()


    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Shocked1")
    SendIntMessage("Worm.QueueAnim", 0) 
    
    SetData("Worm.ScriptAnim", "Shocked1")
    SendIntMessage("Worm.QueueAnim", 0) 
    
    SetData("Worm.ScriptAnim", "Shocked1")
    SendIntMessage("Worm.QueueAnim", 0) 
    
    SetData("Worm.ScriptAnim", "Shocked1")
    SendIntMessage("Worm.QueueAnim", 0)
    
    SetData("Worm.ScriptAnim", "Shocked1")
    SendIntMessage("Worm.QueueAnim", 0) 
    
    SetData("Worm.ScriptAnim", "Shocked1")
    SendIntMessage("Worm.QueueAnim", 0) 
    
    SetData("Worm.ScriptAnim", "Shocked1")
    SendIntMessage("Worm.QueueAnim", 0)
    
    SetData("Worm.ScriptAnim", "Shocked1")
    SendIntMessage("Worm.QueueAnim", 0) 
    
    SetData("Worm.ScriptAnim", "Shocked1")
    SendIntMessage("Worm.QueueAnim", 0)     
    
    
    SetData("Worm.ScriptAnim", "Shocked1")
    SendIntMessage("Worm.QueueAnim", 0)       
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 0)  

    SetData("Worm.ScriptAnim", "Sad1")
    SendIntMessage("Worm.QueueAnim", 0)

    SetData("Worm.ScriptAnim", "Sad2")
    SendIntMessage("Worm.QueueAnim", 0)  
    
    SetData("Worm.ScriptAnim", "Sad2")
    SendIntMessage("Worm.QueueAnim", 0)

    SetData("Worm.ScriptAnim", "Sad2")
    SendIntMessage("Worm.QueueAnim", 0) 
    
    
end

function shocked()





      --  SetData("Camera.Shake.Length",500)
	--SetData("Camera.Shake.Magnitude",0.30)
	--SendMessage("Camera.ShakeStart")

	--TimerID = StartTimer("EndShake", 500)


    SetData("Camera.Path.Knots.Position", "cam2,cam3")
    SetData("Camera.Path.Knots.LookAt", "look2,look3")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",50)  
    SetData("Camera.Path.Steps.LookAt",10)
    SetData("Camera.Path.Tension.Position", 0.5) 
    SendMessage("Camera.Path.Start")

end


function EndShake()

	--SendMessage("Camera.ShakeEnd")
        
end




function Input_SomeInput()

    if camdone == 0 then
    
        camdone =  1
        StartFirstTurn()
    end

end



