
-- Submission - Basic Deathmatch

function Initialise()
-- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)

    --SendMessage("GameLogic.PlaceObjects")

	SetData("Crate.Spawn", "CrateSpawn1")
	SendMessage("GameLogic.CreateCrate")

	SetData("Crate.Spawn", "CrateSpawn2")
	SendMessage("GameLogic.CreateCrate")

    SetupWormsAndTeams()
    SetupInventories()
    StartFirstTurn()


    
end

function SetupWormsAndTeams()
-- Activate Team 0
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GetData("User.HumanTeamName")
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 1
    CloseContainer(lock) -- must close the container ASAP
-- Activate Team 1
    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Darksiders"
    team.TeamColour = 0
    team.IsAIControlled = true
    CloseContainer(lock)
-- Worm 0, Team 0
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GetData ("User.HumanWorm1")
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.SfxBankName = "Pirate"
    worm.Spawn = "hspawn1"
    CloseContainer(lock) 
-- Worm 1, Team 0
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GetData ("User.HumanWorm2")
    worm.Spawn = "hspawn2"
    CloseContainer(lock)
-- Worm 2, Team 0
    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GetData ("User.HumanWorm3")
    worm.Spawn = "hspawn3"
    CloseContainer(lock)
-- Worm 3, Team 0
    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03") 
    worm.Name = GetData ("User.HumanWorm4")
    worm.Spawn = "hspawn4"
    CloseContainer(lock)
-- Worm 4, Team 1
    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 80 
    worm.Name = "Agent Dennis"
    worm.TeamIndex = 1
    worm.SfxBankName = "Biggles"
    worm.Spawn = "cspawn1"
    CloseContainer(lock)
-- Worm 5, Team 1
    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    worm.Energy = 80  
    worm.Name = "Chesh"
    worm.Spawn = "cspawn2"
    CloseContainer(lock)
-- Worm 6, Team 1
    CopyContainer("Worm.Data04", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    worm.Energy = 80  
    worm.Name = "Dunst"
    worm.Spawn = "cspawn3"
    CloseContainer(lock)
-- Worm 7, Team 1
    CopyContainer("Worm.Data04", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    worm.Energy = 80  
    worm.Name = "Das Bruce"
    worm.Spawn = "cspawn4"
    CloseContainer(lock)
   SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
-- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Bazooka = -1
    inventory.Grenade = 5
    inventory.ClusterGrenade = 2
    inventory.Airstrike = 1
    inventory.Dynamite = 1
    inventory.Landmine = 1
    inventory.Sheep = 1
    inventory.Parachute = -1
    inventory.Teleport = 1
    inventory.Jetpack = 1
    inventory.SkipGo = -1
    inventory.Girder = 2
    inventory.Shotgun = 1
    inventory.Uzi = 1
   inventory.FirePunch = 1
    inventory.Prod = -1
    CloseContainer(lock) -- must close the container ASAP

-- Copies this selection into each worm
   CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   CopyContainer("Inventory.Team.Default", "Inventory.Team01")
end


