
-- Tutorial 2  2nd run  

function Initialise()

    firsttime = 1
    NewCrate = 1
    camdone = 0
    diewhere = 0
    lastbit = 0
    nomore = 0
    whichbrief = 0
    Switch = 0

-- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 3000)
    SetData("Mine.MaxFuse", 4000)
    SetData("HotSeatTime", 0) -- no hotseat time
    SetData("RoundTime", 0) -- no Game timer
    SetData("TurnTime", 0) -- no game timer
    
    SetData("HUD.Clock.DisplayRoundTime", 0)
    SendMessage("HUD.HideTurnTime")
    
    SetData("Land.Indestructable", 1)

    SendMessage("GameLogic.ResetCrateParameters")
    SendMessage("EFMV.Start")
    SendMessage("GameLogic.PlaceObjects")
    SetData("Crate.GroundSnap", 0)
    
    SetData("Crate.TrackCam", 0) 
    SendMessage("Commentary.NoDefault")
    SendStringMessage("Camera.Disable", "Track")   
   
    SetData("Crate.Spawn", "crate1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", -1)
    SetData("Crate.Pushable", 0)
    SetData("Crate.Contents", "kWeaponDynamite")
    SetData("Crate.Index", 1)
    SetData("Crate.TeamDestructible", 1)
    SendMessage("GameLogic.CreateCrate")


    SendStringMessage("Camera.Enable", "Track")
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "Orbit")   
        
    SetupWormsAndTeams()
    SetupInventories()
    camera()

end


-- /////////////////////////////////////////////////////////////
-- works out if players worm should be respawned
function TurnEnded()

      StartTurn()

end

function StartFirstTurn()

   WaitUntilNoActivity = false
   SendMessage("Timer.StartGame")
   StartTurn()
   
end


-- //////////////////////////////////////////////////////////////////

function SetupWormsAndTeams()

    GM = QueryContainer("GM.GameInitData")
    -- Activate Team 0
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.Name = GM.T1_Name
    team.TeamColour = 0
    CloseContainer(lock) -- must close the container ASAP

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "Whipping Boys"
    team.IsAIControlled = true
    team.TeamColour = 1
    team.FlagGfxName = "65"
    CloseContainer(lock)

    -- Worm 0, Team 0
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.Energy = 25
    worm.Spawn = "spawn1"
    worm.SfxBankName = GM.T1_Speech
    worm.IsAllowedToTakeTurn = true
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
 
 
    lock, worm = EditContainer("Worm.Data01") 
    worm.Active = true
    worm.Name = "Scruffy"
    worm.IsAllowedToTakeTurn = false
    worm.SfxBankName = "Patronising"
    worm.Energy = 1
    worm.Spawn = "target1"
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    CloseContainer(lock) 
 
    SendMessage("WormManager.Reinitialise")

end

-- //////////////////////////////////////////////////////////////////

function SetupInventories()

    -- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Jetpack = 0
    inventory.Dynamite = 0    
    inventory.SkipGo = 0
    inventory.Surrender = 0  
    
    CloseContainer(lock) -- must close the container ASAP

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
    CopyContainer("Inventory.Team.Default", "Inventory.Team01")
    
    -- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.SkipGo = -1
    CloseContainer(lock)
    
end


function SelectRandomWind()

   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", 0.1*MaxWind)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", 3.3) 

end
      
--display text when players worm dies and what text to display
function dietext()

    if diewhere == 0 then
        SetData("CommentaryPanel.Comment", "Miss.Schools.OhNo")
        SendBriefingMessage()
    end

    if diewhere == 1 then
    
       SetData("CommentaryPanel.Comment", "Tut.Dumps.retrykillself")
       SendBriefingMessage()

    elseif diewhere == 2 then
    
       SetData("CommentaryPanel.Comment", "Tut.Dumps.retrygrenade")
       SendBriefingMessage()
    
    elseif diewhere == 3 then
    
       SetData("CommentaryPanel.Comment", "Tut.Dumps.retrycluster")
       SendBriefingMessage()  
    
    elseif diewhere == 4 then
    
       SetData("CommentaryPanel.Comment", "Tut.Dumps.retrycluster2")
       SendBriefingMessage()    
    
    end
end
 
 
-- what to do when a crate is collected
function Crate_Collected()

    CrateNumber = GetData("Crate.Index")
    
    if CrateNumber == 1 then
        diewhere = 1
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game6")
        SendBriefingMessage() 
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game7")
        SendBriefingMessage()   
    end
    
    
    if CrateNumber == 2 then
        diewhere = 2
    end     
        
    
    if CrateNumber == 3 then
        diewhere = 3
    end 
end
        
        
--what to do when a certain worm dies
        
function Worm_Died()

    deadworm = GetData("DeadWorm.Id")
        
    if deadworm == 0 then

       dietext()
       StartTimer("RespawnWorm", 1000)
       
    end
        
    if deadworm == 1 then

        lock, inventory = EditContainer("Inventory.Alliance00") 
        inventory.Dynamite = 0    
        CloseContainer(lock) -- must close the container ASAP
        
        SendMessage("Weapon.Delete")
        SendMessage("Weapon.Create")
 
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game8")
        SendBriefingMessage() 
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game9")
        SendBriefingMessage()
        
        cameratwo()
    
    end
    
    
    if deadworm == 2 then   

        SetData("CommentaryPanel.Comment", "Tut.Dumps.game12")
        SendBriefingMessage()  
        camerathree()
    end
  
  
    if deadworm == 3 then   
        lock, inventory = EditContainer("Inventory.Alliance00") 
        inventory.Grenade = 0    

        CloseContainer(lock) -- must close the container ASAP
        SendMessage("Weapon.Delete")
        SendMessage("Weapon.Create")
      
        SetData("Camera.Path.IgnoreInput", 0)
      	SetData("Crate.Spawn", "crate3")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", -1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 0)
        SetData("Crate.TrackCam", 0) 
        SetData("Crate.Contents", "kWeaponClusterGrenade")
        SetData("Crate.TeamDestructible", 1)
	SetData("Crate.Index", 3)
	SendMessage("GameLogic.CreateCrate")
        diewhere = 0
        camerafour()
    
    end
  
  
    if deadworm == 4 then   
        lastbit = lastbit + 1
   
        if lastbit == 4 then 
            SetData("GameOver.AwardMovie","DeathMatchDefeat")
            SendMessage("GameLogic.Tutorial.Success")
        end    
      

        --/////////////////
        if lastbit == 2 then
      
      
            lock, inventory = EditContainer("Inventory.Alliance00") 
            inventory.Grenade = -1    

            CloseContainer(lock)
   
   
            lock, worm = EditContainer("Worm.Data05") 
            worm.Active = true
            worm.Name = "Smelly"
            worm.Energy = 1
            worm.Spawn = "target5"
            worm.WeaponFuse = 3
            worm.WeaponIsBounceMax = false
            worm.IsAllowedToTakeTurn = false
            worm.SfxBankName = "Patronising"
            worm.TeamIndex = 1
            CloseContainer(lock) 
            SendIntMessage("Worm.Respawn", 5)
      
      

            lock, worm = EditContainer("Worm.Data07") 
            worm.Active = true
            worm.Name = "Filthy"
            worm.Energy = 1
            worm.Spawn = "target7"
            worm.SfxBankName = "Patronising"
            worm.WeaponFuse = 3
            worm.WeaponIsBounceMax = false
            worm.IsAllowedToTakeTurn = false
            worm.TeamIndex = 1
            CloseContainer(lock) 
            SendIntMessage("Worm.Respawn", 7)
      
      
            SetData("Camera.Path.IgnoreInput", 1)
            SetData("Camera.Path.Knots.Position", "gamecam")
            SetData("Camera.Path.Knots.LookAt", "gamelook,gamelook4")
            SetData("Camera.Path.Loop.LookAt", 0)
            SetData("Camera.Path.Steps.Position",480)  
            SetData("Camera.Path.Steps.LookAt",400)
            SetData("Camera.Path.Tension.Position", -0.2) 
            SendMessage("Camera.Path.Start")
            SendMessage("GameLogic.PauseGame")
            SetData("Camera.Path.IgnoreInput", 1)
        end
    end

   
    if deadworm == 5 then   
  
        lastbit = lastbit + 1
   
        if lastbit == 4 then 
            SetData("GameOver.AwardMovie","DeathMatchDefeat")
            SendMessage("GameLogic.Tutorial.Success")
        end    

    end
    
    
 --///////////////////
 
 

    if deadworm == 6 then   
  
        lastbit = lastbit + 1
   

        if lastbit == 4 then 
            SetData("GameOver.AwardMovie","DeathMatchDefeat")
            SendMessage("GameLogic.Tutorial.Success")
        end    
      
        if lastbit == 2 then
      
            lock, inventory = EditContainer("Inventory.Alliance00") 
            inventory.Grenade = -1    

            CloseContainer(lock)
            diewhere = 0
            lock, worm = EditContainer("Worm.Data05") 
            worm.Active = true
            worm.Name = "Smelly"
            worm.Energy = 1
            worm.Spawn = "target5"
            worm.SfxBankName = "Patronising"
            worm.WeaponFuse = 3
            worm.WeaponIsBounceMax = false
            worm.IsAllowedToTakeTurn = false
            worm.TeamIndex = 1
            CloseContainer(lock) 
            SendIntMessage("Worm.Respawn", 5)
      
            lock, worm = EditContainer("Worm.Data07") 
            worm.Active = true
            worm.Name = "Filthy"
            worm.SfxBankName = "Patronising"
            worm.Energy = 1
            worm.Spawn = "target7"
            worm.WeaponFuse = 3
            worm.WeaponIsBounceMax = false
            worm.IsAllowedToTakeTurn = false
            worm.TeamIndex = 1
            CloseContainer(lock) 
            SendIntMessage("Worm.Respawn", 7)
      

            SetData("Camera.Path.IgnoreInput", 1)
            SetData("Camera.Path.Knots.Position", "gamecam")
            SetData("Camera.Path.Knots.LookAt", "gamelook,gamelook4")
            SetData("Camera.Path.Loop.LookAt", 0)
            SetData("Camera.Path.Steps.Position",480)  
            SetData("Camera.Path.Steps.LookAt",300)
            SetData("Camera.Path.Tension.Position", -0.2) 
            SendMessage("Camera.Path.Start")
            SendMessage("GameLogic.PauseGame")
            SetData("Camera.Path.IgnoreInput", 1)   
        end
    end
       
    if deadworm == 7 then   
  
        lastbit = lastbit + 1
   
        if lastbit == 4 then 
        
            SetData("Camera.Path.IgnoreInput", 1) 
    
            SetData("CommentaryPanel.Comment", "Miss.Breakfast.Success")
            SendMessage("CommentaryPanel.ScriptText")
            

            SetData("GameOver.AwardMovie","DeathMatchDefeat")
            SendMessage("GameLogic.Tutorial.Success")
        end    
    
    end

end

function RespawnWorm()

       lock, worm = EditContainer("Worm.Data00") 
       worm.Active = true
       worm.Name = GM.T1_W1_Name
        worm.SfxBankName = GM.T1_Speech
       worm.Energy = 25
       worm.Spawn = "spawn1"
        worm.IsAllowedToTakeTurn = true
       worm.WeaponFuse = 3
       worm.WeaponIsBounceMax = false
       worm.TeamIndex = 0
       CloseContainer(lock) 
      
       SendIntMessage("Worm.Respawn", 00)

end



--below has most of the camera stuff

function camera()

    SetData("Camera.Path.IgnoreInput", 1)
   
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Idle_5_HeadScratch")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Idle_5_HeadScratch")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Idle_5_HeadScratch")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Idle_5_HeadScratch")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Idle_5_HeadScratch")
    SendIntMessage("Worm.QueueAnim", 0)    
    SetData("Worm.ScriptAnim", "Idle_5_HeadScratch")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "DrawBat")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "FireBat")
    SendIntMessage("Worm.QueueAnim", 0)     

    SetData("Camera.Path.Knots.Position", "cam1,cam2,cam3,cam4")
    SetData("Camera.Path.Knots.LookAt", "look1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",480)  
    SetData("Camera.Path.Steps.LookAt",450)
    SetData("Camera.Path.Tension.Position", -0.2) 
    SendMessage("Camera.Path.Start")
    SendMessage("GameLogic.PauseGame")
 
end



function Game_BriefingDialogOkPressed()
    -- test where in the script we were so we know what to do here..
    if whichbrief == 1 then
        -- ok, we were at the briefing text for briefing 1, so lets go to
        SetData("Camera.Path.IgnoreInput", 1) 
        
        SetData("Camera.Path.Knots.Position", "cratelook,cratelook2")
        SetData("Camera.Path.Knots.LookAt", "cratecam")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",480)  
        SetData("Camera.Path.Steps.LookAt",300)
        SetData("Camera.Path.Tension.Position", -0.2) 
        SendMessage("Camera.Path.Start")
        SendMessage("GameLogic.PauseGame")
        
    end
    
end




function Camera_Path_Reached_Knot()

    knot = GetData("Camera.Path.Knot")
   
    if knot == "cam4" then 
        SendMessage("EFMV.End")

        SendIntMessage("Worm.ResetAnim", 0)
        SetData("Worm.ScriptAnim", "Idle_5_HeadScratch")
        SendIntMessage("Worm.QueueAnim", 0)
        SendIntMessage("Worm.ResetAnim", 1)
        SetData("Worm.ScriptAnim", "OverHere")
        SendIntMessage("Worm.QueueAnim", 1)
        camdone =  1      
        forphil()
    end
   

    if knot == "introlook" then 
        
       -- SetData("Camera.Path.IgnoreInput", 0)
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game1")
        SendBriefingMessage()
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game2")
        SendBriefingMessage()
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game3")
        SendBriefingMessage()  
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game4")
        SendBriefingMessage()
        whichbrief = 1
    end
  
  
  
    if knot == "cratelook2" then 
       -- SetData("Camera.Path.IgnoreInput", 0)
        whichbrief = 0
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game5")
        SendBriefingMessage() 
        SendMessage("Camera.SetDefault")
        SendMessage("GameLogic.ResumeGame")
        StartFirstTurn()
   end
  
    if knot == "gamecam2a" then 
        --camera knot end for 2nd worm 
        SendMessage("GameLogic.ResumeGame") 
       -- SetData("Camera.Path.IgnoreInput", 0)           
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game10")
        SendBriefingMessage()
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game11")
        SendBriefingMessage()
        SendMessage("Camera.SetDefault")
        diewhere = 0
    end
  
    if knot == "gamelook3" then 
    
        --SetData("Camera.Path.IgnoreInput", 0)
        SendMessage("GameLogic.ResumeGame")
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game13")
        SendBriefingMessage()  
        SendMessage("Camera.SetDefault")
    end
    
    
    if knot == "gamelook4" then   
        SendMessage("GameLogic.ResumeGame")
        --SetData("Camera.Path.IgnoreInput", 0)
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game17")
        SendBriefingMessage() 
        SetData("CommentaryPanel.Comment", "Tut.Dumps.game18")
        SendBriefingMessage()  
        SendMessage("Camera.SetDefault")
    end
    
    if knot == "clusterlook2" then 
    
       SendMessage("GameLogic.ResumeGame")
       -- SetData("Camera.Path.IgnoreInput", 0)

       SetData("CommentaryPanel.Comment", "Tut.Dumps.game14")
       SendBriefingMessage() 
       SetData("CommentaryPanel.Comment", "Tut.Dumps.game15")
       SendBriefingMessage()   
       SetData("CommentaryPanel.Comment", "Tut.Dumps.game16")
       SendBriefingMessage()    
       SendMessage("Camera.SetDefault")
 
    end
    
end

function OpeningBrief1()

end

function OpeningBrief2()

end

function OpeningBrief3()

end

function OpeningBrief4()

end


function forphil()
        SendMessage("EFMV.End")
    
        SetData("Camera.Path.IgnoreInput", 1)
        SetData("Camera.Path.Knots.Position", "introcam, introlook")
        SetData("Camera.Path.Knots.LookAt", "introlook2")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",480)  
        SetData("Camera.Path.Steps.LookAt",300)
        SetData("Camera.Path.Tension.Position", -0.2) 
        SendMessage("Camera.Path.Start")
        SendMessage("GameLogic.PauseGame")

end


function Input_SomeInput()

    if camdone == 0 then
       camdone =  1
       forphil()
    end

end

function SendBriefingMessage()

    SendStringMessage("FE.QueuePopUpLight","Game.BriefDialog")

end

--when each stage is passed and what to do


function cameratwo()

    lock, worm = EditContainer("Worm.Data02") 
    worm.Active = true
    worm.IsAllowedToTakeTurn = false
    worm.Name = "Rubbish"
    worm.Energy = 1
    worm.Spawn = "target2"
    worm.SfxBankName = "Patronising"
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    CloseContainer(lock) 
    SendIntMessage("Worm.Respawn", 2)
    
    SetData("Crate.Spawn", "crate2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", -1)
    SetData("Crate.Pushable", 0)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.Index", 2)
    SendMessage("GameLogic.CreateCrate")
   
    SetData("Camera.Path.Knots.Position", "gamecam, gamecam2a")
    SetData("Camera.Path.Knots.LookAt", "gamelook")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",480)  
    SetData("Camera.Path.Steps.LookAt",100)
    SetData("Camera.Path.Tension.Position", -0.2) 
    SendMessage("Camera.Path.Start")
    
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("GameLogic.PauseGame")
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "OverHere")
    SendIntMessage("Worm.QueueAnim", 2)
        
end


function camerathree()

    lock, worm = EditContainer("Worm.Data03") 
    worm.Active = true
    worm.IsAllowedToTakeTurn = false
    worm.Name = "Trash"
    worm.Energy = 1
    worm.Spawn = "target3"
    worm.SfxBankName = "Patronising"
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    CloseContainer(lock) 
   
    SendIntMessage("Worm.Respawn", 3)
    
    SendMessage("GameLogic.PauseGame")

    SetData("Camera.Path.Knots.Position", "gamecam, gamelook3")
    SetData("Camera.Path.Knots.LookAt", "gamelook2a")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",480)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", -0.2) 
    SendMessage("Camera.Path.Start")
        
    SetData("Camera.Path.IgnoreInput", 1)
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "OverHere")
    SendIntMessage("Worm.QueueAnim", 3)
        
        

end



function camerafour()


   --last lot of worms spawn in
       lock, worm = EditContainer("Worm.Data06") 
       worm.Active = true
       worm.Name = "Landfill"
       worm.IsAllowedToTakeTurn = false
       worm.Energy = 1
       worm.Spawn = "target6"
       worm.SfxBankName = "Patronising"
       
       worm.WeaponFuse = 3
       worm.WeaponIsBounceMax = false
       worm.TeamIndex = 1
       CloseContainer(lock) 
   
       SendIntMessage("Worm.Respawn", 6) 
       
       
       lock, worm = EditContainer("Worm.Data04") 
       worm.Active = true
       worm.Name = "Rubbish Tip"
       worm.IsAllowedToTakeTurn = false
       worm.Energy = 1
       worm.Spawn = "target4"
       worm.SfxBankName = "Patronising"
       worm.WeaponFuse = 3
       worm.WeaponIsBounceMax = false
       worm.TeamIndex = 1
       CloseContainer(lock) 
   
        SendIntMessage("Worm.Respawn", 4)
        SendMessage("GameLogic.PauseGame")
   
   
        SetData("Camera.Path.IgnoreInput", 1)
        SetData("Camera.Path.Knots.Position", "clusterlook1, clusterlook2")
        SetData("Camera.Path.Knots.LookAt", "clusterlook3")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",480)  
        SetData("Camera.Path.Steps.LookAt",400)
        SetData("Camera.Path.Tension.Position", -0.2) 
        SendMessage("Camera.Path.Start")
        
        
        
        SendIntMessage("Worm.ResetAnim", 4)
        SetData("Worm.ScriptAnim", "OverHere")
        SendIntMessage("Worm.QueueAnim", 4)
        
        SendIntMessage("Worm.ResetAnim", 6)
        SetData("Worm.ScriptAnim", "OverHere")
        SendIntMessage("Worm.QueueAnim", 6)

end

function CheckOneTeamVictory()

end
